/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.customize.SavePageManager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.SavePageManager"] = true;
dojo.provide("com.ibm.customize.SavePageManager");
dojo.requireLocalization("com.ibm.bundles", "Theme", null, "ROOT,ar,ca,cs,da,de,el,en,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt,pt-br,ro,ru,sk,sl,sv,th,tr,uk,zh,zh-tw");
dojo.requireLocalization("com.ibm.bundles", "Shelf", null, "ROOT,ar,ca,cs,da,de,el,en,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt,pt-br,ro,ru,sk,sl,sv,th,tr,uk,zh,zh-tw");
dojo.declare("com.ibm.customize.SavePageManager",
	[dijit._Widget, dijit._Templated],
	{
		registered: [],
		saveString: "Save",
		unsavedChangesMsg: "",
		beforeSaveCount: 0,
		dirty: false,
		saving: false,
		templateString: '<button class="lotusFormButton lotusBtnDisabled" aria-disabled="true" dojoAttachPoint="savePageButton" dojoAttachEvent="onclick:saveAll" href="javascript:void(0)">${saveString}</button>',
		
		constructor: function(){
			this.saveString = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf")["shelf_saveChanges"];
			this.unsavedChangesMsg = dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["theme_confirm_leave_edit"];
		},
		
		register: function(obj){
			this.registered.push(obj);
			if(obj.beforeSave) this.beforeSaveCount++;
			obj.connection = (obj.scope) ? dojo.connect(obj.scope,obj.dirty,this,"makeDirty") : dojo.connect(obj.dirty,this,"makeDirty");
		},
		
		saveAll: function(){
			if(this.saving) return;
			this.saving = true;
			this.dirty = false;
			this.beforeSavePage();
		},
		
		beforeSavePage: function(){
			var count = this.beforeSaveCount + 1;
			var counter = dojo.hitch(this, function(){
				if(--count == 0) this.savePage();
			});
			counter();
			
			for(var i in this.registered){
				if(this.registered[i].beforeSave) this.registered[i].beforeSave(counter);
			}
		},
		
		savePage: function(){
			var count = this.registered.length + 1;
			var counter = dojo.hitch(this, function(){
				if(--count == 0) {
					this.saving = false;
					if(!this.dirty) {
						dojo.addClass(this.savePageButton, "lotusBtnDisabled");
						dojo.attr(this.savePageButton,"aria-disabled","true");
						window.onbeforeunload = null;
					}
				}
			});
			counter();
			
			com.ibm.portal.dnd.PORTLET_MEDIATOR.saveMoves(counter);
			for(var i in this.registered){
				this.registered[i].save(counter);
			}
		},
		
		leavePage: function(callback,reload){
			if(!ibmPortalConfig.savePageManager.isDirty()){
				callback();
			} else if (confirm(this.unsavedChangesMsg)){
				window.onbeforeunload = null;
				callback();
				if(reload) window.location.replace(top.location.href);
			}
		},
		
		makeDirty: function(){
			if(!this.dirty){
				this.dirty = true;
				dojo.removeClass(this.savePageButton, "lotusBtnDisabled");
				dojo.attr(this.savePageButton,"aria-disabled","false");
				window.onbeforeunload = dojo.hitch(this, function() {
					if(this.dirty){
						return this.unsavedChangesMsg;
					}
				});
			}
		},
		
		isDirty: function(){
			return this.dirty;
		},
		
		isSaving: function(){
			return this.saving;
		},
		
		uninitialize: function(){
			for(var i in this.registered){
				dojo.disconnect(this.registered[i].connection);
			}
		}
	});

}
