/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.FaultFactory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.FaultFactory"] = true;
dojo.provide("com.ibm.data.resolver.FaultFactory");

dojo.require("dojo.string");
dojo.require("com.ibm.domUtilities");
dojo.require("com.ibm.xml.SimpleXmlAccessor");

dojo.declare("com.ibm.data.resolver.FaultFactory",
	null,
	{
		namespaces: {env: "http://www.w3.org/2003/05/soap-envelope"},
		
		selectors: {
			subcode: "/env:Fault/env:Code/env:Subcode/env:Value",
			reason: "/env:Fault/env:Reason/env:Text[" + (dojo.isIE ? "@xml:lang = '${0}'": "lang('${0}')") + "]",
			role: "/env:Fault/env:Role",
			detail: "/env:Fault/env:Detail"
		},
		
		constructor: function() {
			this.engine = new com.ibm.xml.SimpleXmlAccessor({namespaces: this.namespaces});
		},
		
		getFaultError: function(/*String*/xmlStr,/*Error*/ error) {
			// summary: Takes an input xmlStr containing the SOAP Fault document in string format
			//		and a prexisting Error, and returns the same error with its properties
			//		modified appropriately to reflect the Fault document's contents.
			// xmlStr: String representing a SOAP Fault document
			// error: Error object to modify according to the Fault
			var data = com.ibm.domUtilities.docFromString(xmlStr);
			error.name = "Fault - " + this._getRole(data);
			error.number = this._getSubCode(data);
			error.message = this._getReason(data);			
			error.description = this._getDetail(data);
			return error;
		},
		_getSubCode: function(data) {
			return this.engine.select(this.selectors.subcode, data, true).text()[0];
		},
		_getReason: function(data, /*String?*/locale) {
			if(!locale) locale = dojo.locale;
			var query = this.selectors.reason;
			query = dojo.string.substitute(query, [locale]);
			return this.engine.select(query, data, true).text()[0];
		},
		_getRole: function(data) {
			return this.engine.select(this.selectors.role, data, true).text()[0];
		},
		_getDetail: function(data) {
			return this.engine.select(this.selectors.detail, data, true).text()[0];
		},
		toString: function(){
			return this.declaredClass;
		}
	}
);

if(!dojo.isIE) {
	com.ibm.data.resolver.FaultFactory.prototype.namespaces["xml"] = "http://www.w3.org/XML/1998/namespace";
}

}
