/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.LMPocHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.LMPocHandler"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.data.resolver.LMPocHandler");

dojo.require("com.ibm.data.resolver.PMPocHandler");		// for linking across handlers
dojo.require("com.ibm.data.resolver.OpenSearchPocHandler");
dojo.require("com.ibm.data.resolver.ResolverQueryRules");
dojo.require("com.ibm.data.resolver.tree.TreeModeledHandler");
dojo.require("com.ibm.data.resolver.tree.PocLMTreeModel");

dojo.declare("com.ibm.data.resolver.LMPocHandler",
	[com.ibm.data.resolver.OpenSearchPocHandler, com.ibm.data.resolver.tree.TreeModeledHandler],
	{
		category: "content",
		
		parentMgmtStrategy: "com.ibm.data.resolver.LMParentDependencyStrategy",
		
		namespaces: dojo.mixin({}, 
			com.ibm.data.resolver.OpenSearchPocHandler.prototype.namespaces,
			com.ibm.data.resolver.ResolverQueryRules.namespaces),
				
		constructor: function() {
			this._treeModels = {};
			this.customAttributes.treeModel.get = function(item, multiValued) {
				// "this" is the handler
				var id = this.getIdentity(item);
				var pageId = this._extractCompositeIds(id).pageId;
				if(!this._treeModels[pageId]) {
					this._treeModels[pageId] = new com.ibm.data.resolver.tree.PocLMTreeModel({
						pageId: pageId,
						refItem: item,
						handler: this,
						resolver: this.resolver
					});
				}
				return multiValued ? [this._treeModels[pageId]] : this._treeModels[pageId];
			};
		},
		
		_createTemplates: function() {
			var nsDecl = [];
			for(var prefix in this.namespaces) {
				nsDecl.push('xmlns:', prefix, '="', this.namespaces[prefix], '" ');
			}
			dojo.mixin(this, {
				containerTemplate: {
					templateString: 
						 '<?xml version="1.0" encoding="UTF-8"?>'
						+'<atom:feed '
							+nsDecl.join('')
							+'>'
							+'<atom:author>'
								+'<atom:name>IBM WebSphere Portal/6.1</atom:name>'
							+'</atom:author>'
							+'<atom:title>IBM WebSphere Portal Model Feed</atom:title>'
							+'<atom:link href="." rel="self" type="application/atom+xml"/>'
							+'<atom:entry>'
								+'<atom:title>${title}</atom:title>'
								+'<atom:id>${id}</atom:id>'
								+'<atom:content type="application/xml">'
									+'<model:layout-container/>'
								+'</atom:content>'
								+'<thr:in-reply-to ext:uri="${parentId}" href="${parentId}" ref="${parentId}" type="application/atom+xml"/>'
							+'</atom:entry>'
						+'</atom:feed>',
					templateProps: {
						id: "",
						title: "",
						parentId: ""
					}
				},
				
				controlTemplate: {
					templateString:
						 '<?xml version="1.0" encoding="UTF-8"?>'
						+'<atom:feed '
							+nsDecl.join('')
							+'>'
							+'<atom:author>'
								+'<atom:name>IBM WebSphere Portal/6.1</atom:name>'
							+'</atom:author>'
							+'<atom:title>IBM WebSphere Portal Model Feed</atom:title>'
							+'<atom:link href="." rel="self" type="application/atom+xml"/>'
							+'<atom:entry>'
								+'<atom:title>${title}</atom:title>'
								+'<atom:id>${id}</atom:id>'
								+'<atom:content type="application/xml">'
									+'<model:layout-control creationcontext:portlet-definition="${portletDefinitionId}">'
										+'<model:deletable>true</model:deletable>' 
						                +'<model:deletableFlag>true</model:deletableFlag>'
						                +'<model:modifiable>true</model:modifiable>' 
						                +'<model:modifiableFlag>true</model:modifiableFlag>'
									+'</model:layout-control>'
								+'</atom:content>'
								+'<thr:in-reply-to ext:uri="${parentId}" href="${parentId}" ref="${parentId}" type="application/atom+xml"/>'
							+'</atom:entry>'
						+'</atom:feed>',
					templateProps: {
						id: "",
						title: "",
						parentId: "",
						portletDefinitionId: ""
					}
				}
			});
		},
		
		processFetch: function(/*DOMDoc*/ xmlDoc, /*Request*/ request) {
			// summary: Extension point for descendants or consumers of this store to handle
			//		responses from server requests for data.  Most subclasses can leave this
			// 		function as-is, but if special handling is required that cannot be done
			// 		with other extension points, this can be overridden as well.
			// 		Must call onBegin, onItem, and onComplete callbacks correctly as 
			// 		specified by dojo.data.api.Read.  The onError callback is handled elsewhere.
			// xmlDoc: DOMDoc of the response from an IO request
			// request: Request used to fetch the result
			var composite = this.inherited(arguments);
			var id = this.engine.getByRule(composite.meta.root, this.queryRules["id"]).value;
			var compId = this._extractCompositeIds(id);
			
			composite.meta.allAllowedPortlet = this.engine.getByRule(composite.meta.root, this.bodyQueryRules["allAllowedPortlet"], true).value;
			composite.meta.allPortletsAllowed = this.engine.getByRule(composite.meta.root, this.bodyQueryRules["allPortletsAllowed"]).value;
			composite.meta.wmURI = this.engine.getByRule(composite.meta.root, this.bodyQueryRules["wmURI"]).value;
			return composite;
		},
		
		getSaveQuery: function(/*item*/ item) {
			var q = this.inherited(arguments);
			if(this.resolver.isCreated(item)) {
				// merge updates
				// empty representation.. performance-smart
				q.rep = "empty";
			}
			else {
				// lm templates store the creation URI in the title block
				q.uri = this.getLabel(item);
			}
			return q;
		},
		updateReferences: function(item) {
			this.inherited(arguments);
			var isCreated = this.resolver.isCreated(item);
			var parentId = this.getValue(item, "parentId", this.getValue(item, "title"));
			if(parentId) {
				var pageItem = this._getPage(item);
				if(pageItem) {
					var layoutId = this._extractCompositeIds(this.getIdentity(item)).layoutId,
						pageId = this._extractCompositeIds(this.resolver.getIdentity(pageItem)).pageId,
						prefix = isCreated ? "lm:oid:" : "lm:cid:";
					this.setValue(item, "id", prefix + layoutId + "@oid:" + pageId);
				}
				var parentItem = this.resolver.byId(parentId);
				if(parentItem) {
					var compParts = this._extractCompositeIds(this.resolver.getIdentity(parentItem));
					if(compParts.layoutId && compParts.layoutId != compParts.pageId) {
						this.setValue(item, "title", "lm:oid:" + compParts.layoutId + "@oid:" + compParts.pageId);
						this.setValue(item, "parentId", "lm:oid:" + compParts.layoutId + "@oid:" + compParts.pageId);
					}
					else {
						this.setValue(item, "title", "lm:oid:" + compParts.pageId + "@oid:" + compParts.pageId);
					}
				}
			}
		},
		_getPage: function(item) {
			var compId = this._extractCompositeIds(this.getIdentity(item));
			if(compId.pageId) {
				var pageItem = this.resolver.byCId("cm:cid:" + compId.pageId);
				if(!pageItem) pageItem = this.resolver.byId("cm:oid:" + compId.pageId);
				return pageItem;
			}
			return null;
		},
		_extractCompositeIds: function(/*String*/ compositeId) {
			// summary: Extracts the parts from a composite id consisting of a layout part and a page part.
			if(compositeId.indexOf("lm:") == 0) {
				var sepIndex = compositeId.indexOf("@oid:"),
					lid, pageId;
				if(sepIndex > -1) {
					lid = compositeId.substring(7, sepIndex);
					pageId = compositeId.substring(sepIndex + 5);
				}
				else {
					lid = compositeId.substr(7);
					pageId = lid;
				}
				
				return {layoutId: lid, pageId: pageId};
			}
			else if(compositeId.indexOf("cm:") == 0) {
				return {layoutId: null, pageId: compositeId.substring(compositeId.lastIndexOf(":") + 1)};
			}
			else {
				return {layoutId: null, pageId: compositeId};
			}
		},
		modifyNewItemArgs: function(args, parentInfo) {
			this.inherited(arguments);
			var compParts = this._extractCompositeIds(args.parentId);
			if(compParts.pageId) {
				args.pageId = compParts.pageId;
				args.id += "@oid:" + args.pageId;
			}
			if(compParts.layoutId && compParts.layoutId != compParts.pageId) {
				// the parent is a layout node
				args.layoutId = compParts.layoutId;
				args.title = args.parentId;
			}
			else {
				// the parent is the page itself, so we're creating a root layout node
				args.title = args.parentId;
				delete args.parentId;
			}
			
			if(args.portletDefinitionId) {
				args.portletDefinitionId = args.portletDefinitionId.replace(/\s/g, "%20");
			}
		},
		fillInProperties: function(newItem, template, keywordArgs, parentInfo) {
			if(keywordArgs.preferences && this.getValue(newItem, "modelNodeType") == "layout-control") {
				// an interesting way of doing something after an item we're creating here is created
				// on the server
				var delayDfd = new dojo.Deferred();
				this.resolver.addBeforeOnCreate(delayDfd);
				
				var conn = dojo.connect(this.resolver, "onNew", dojo.hitch(this, function(prefsMap, item, parentInfo){
					if(item == newItem) {
						this.resolver.addOnCreate(item, dojo.hitch(this, function(item){
							var windowChain = this.resolver.getValue(this.resolver.getValue(item, "portlet"), "portletWindowChain");
							windowChain.addOnLoad(dojo.hitch(this, function(chain){
								var prefs = chain.getPreferences();
								for(var key in prefsMap) {
									var val = prefsMap[key];
									prefs[dojo.isArray(val) ? "setValues" : "setValue"](key, val);
								}
								prefs.store();
							}));
						}));
						dojo.disconnect(conn);
					}
				}, keywordArgs.preferences));
			}
			delete keywordArgs.preferences;
			return this.inherited(arguments);
		},
		getTemplate: function(args, parentInfo) {
			switch(args.type) {
				case "control": 
				case "portlet":
					return this.controlTemplate;
				case "container": 
				default: 
					return this.containerTemplate;
			}
		},
		instantiateTemplate: function(template, args, parentInfo) {
			var xmlDoc = this.inherited(arguments);
			if(!args.parentId) {
				// we don't want the thr:in-reply-to element in the DOM data to send, so remove it
				this.engine.select("./thr:in-reply-to", xmlDoc).destroy();
			}
			return xmlDoc;
		},
			
		_makeModifiable: function(item) {
			// summary: Modifies the element of this item to become modifiable
			//		for writing back to the server.  Subclasses can override this
			//		to do things like prune an item to only include necessary information
			//		for updates and nothing more.  This is called by backup once after
			//		backing up the original element first.  After this returns,
			//		this item's element may have been modified.  Any queries against
			//		this item should now include logic to check the backup copy as well
			//		if a query doesn't return anything as it could have been deleted by
			//		this function.  Care should be taken to ensure that the query result
			//		specifically detects if nothing was found or if the actual value was
			//		null or an empty string.
			this.engine.select("atom:content/*/* | thr:in-reply-to | atom:link", item.data).destroy();
			
			this.inherited(arguments);
		}
	}
);

dojo.declare("com.ibm.data.resolver.LMParentDependencyStrategy",
	com.ibm.data.resolver.tree.ParentDependencyStrategy,
	{
		
		extensionsMap: dojo.mixin({}, 
			com.ibm.data.resolver.tree.ParentDependencyStrategy.prototype.extensionsMap,
			{
				"newItem": "newItem"
			}
		),
		
		newItem: function(/* Object? */ keywordArgs, /*Object?*/ parentInfo) {
			var item = this.proceed(arguments);
			var pId = this.handler.getLabel(item);
			if(pId) {
				this._changeDependencies(this.handler.getIdentity(item), pId);
			}
			return item;
		}	
	}
);

dojo.declare("com.ibm.data.resolver.LMAtomModelTreeStrategy",
	com.ibm.data.resolver.tree.AtomModelTreeStrategy,
	{
		// summary: Provides layout model specific semantics for processing
		//		fetched data chunks with regards to children and their parents
		//		due to special cases in layout model data and the handler's
		//		request processing.
		
		processFetch: function(/*DOMDoc*/ xmlDoc, /*Request*/ request) {
			var map = this.proceed(arguments);
			var compId = this.handler._extractCompositeIds(request.query.uri);
			if(compId.layoutId == compId.pageId && map.items.length > 0) {
				this.processChildren(map, "all", this.handler.getIdentity(map.items[0]));
			}
			else {
				var levels = request.query.levels;
				if(dojo.isString(levels)) levels = levels.toLowerCase();
				this.processChildren(map, levels, request.query.uri);
			}
			return map;
		}	
	}
);

(function(){
	var r = com.ibm.data.resolver, 
		lmPoc = r.LMPocHandler, 
		prot = lmPoc.prototype, 
		def = prot.definition,
		atomBase = r.ResolverQueryRules.atom;
	
	def = dojo.mixin({}, def, {
		scheme: "lm"
	});
	
	def.features = dojo.mixin({}, def.features, {
		"TreeModeled": true
	});
	
	prot.definition = def;
	
	var bodyExtRules = {
		allPortletsAllowed: {selector: "./model:allPortletsAllowed", field: "$textContent"},
		allAllowedPortlet: {selector: "./atom:link[@portal:rel='allAllowedPortlet']", field: "@portal:uri"},
		wmURI: {selector: "./atom:link[@rel='related']", field: "@href"}
	};
	
	dojo.extend(lmPoc, {
		bodyQueryRules: dojo.mixin({}, com.ibm.data.resolver.OpenSearchPocHandler.prototype.bodyQueryRules, 
			bodyExtRules),
		
		queryRules: dojo.mixin({}, r.OpenSearchPocHandler.prototype.queryRules, 
					atomBase.threadExt,
					atomBase.treeExt,
					atomBase.uniqueNameExt, 
					atomBase.modelExt, 
					atomBase.operationsExt, {
			skin: {selector: "./atom:link[@ext:rel='skin']", field: "@ext:uri", setter: 
				function(data, rule, value){
					this.createFromJson(data, {
						name: "atom:link",
						attributes: {
							"ext:rel": "skin",
							"ext:uri": value
						}
					});
					return true;
				}
			},
			skinUniqueName: {selector: "./atom:link[@ext:rel='skin']", field: "@ext:uniquename", readOnly: true},
			portlet: {selector: "./atom:link[@ext:rel='portlet']", field: "@ext:uri", type: "Item", readOnly: true},
			portletId: {selector: "./atom:link[@ext:rel='portlet']", field: "@ext:uri", readOnly: true},
			portletURI: {selector: "./atom:link[@ext:rel='portlet']", field: "@href", readOnly: true},
			portletDefinition: {selector: "./atom:link[@ext:rel='portlet-definition']", field: "@ext:uri", type: "Item", readOnly: true},
			portletDefinitionURI: {selector: "./atom:link[@ext:rel='portlet-definition']", field: "@href", readOnly: true},
			templateName: {selector: "./atom:content/*[model:templateName]/model:templateName", field: "$textContent", readOnly: true},
			modifiable: {selector: "./atom:content/*[model:modifiable]/model:modifiable", field: "$textContent"},
			modifiableFlag: {selector: "./atom:content/*[model:modifiableFlag]/model:modifiableFlag", field: "$textContent"},
			deletable: {selector: "./atom:content/*[model:deletable]/model:deletable", field: "$textContent"},
			deletableFlag: {selector: "./atom:content/*[model:deletableFlag]/model:deletableFlag", field: "$textContent"},
			containerChild: {selector: "./atom:content/*[model:containerChild]/model:containerChild", field: "$textContent", readOnly: true},
			controlChild: {selector: "./atom:content/*[model:controlChild]/model:controlChild", field: "$textContent", readOnly: true}
		}),
		
		customAttributes: dojo.mixin({}, r.OpenSearchPocHandler.prototype.customAttributes, {
			portletWindowChain: {
				get: function(item, multiValued) {
					if(this.getValue(item, "modelNodeType") != "layout-control") return null;
					if(!this.resolver.isCreated(item)) {
						// the window chain is a mockup... keep track of changes and merge on create
						
					}
					else {
						return new com.ibm.data.resolver.PMWindowChain({
							store: this.resolver,
							windowId: this.getValue(item, "portletId")
						});
					}
				},
				set: function(item, value, multiValued) {
					// can't write to this attribute as it is a composite object derived from others
					return false;
				}
			},
			allPortletsAllowed: {
				get: function(item, multiValued) {
					return dojo.getObject("_cachedMeta.requestMeta.allPortletsAllowed");
				},
				set: function(item, value, multiValued) {
					return false;
				}
			},
			allAllowedPortlet: {
				get: function(item, multiValued) {
					return dojo.getObject("_cachedMeta.requestMeta.allAllowedPortlet");
				},
				set: function(item, value, multiValued) {
					return false;
				}
			},
			wmURI: {
				get: function(item, multiValued) {
					return dojo.getObject("_cachedMeta.requestMeta.wmURI");
				},
				set: function(item, value, multiValued) {
					return false;
				}
			}
		})
	});
	
	com.ibm.strategy.Strategy.applyStrategy(lmPoc, new com.ibm.data.resolver.LMAtomModelTreeStrategy());
	
	com.ibm.data.Resolver.register(def.scheme, lmPoc);
})();

}
