/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.strategy.MetadataStrategy"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.strategy.MetadataStrategy"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.data.resolver.strategy.MetadataStrategy");

dojo.require("com.ibm.data.resolver.strategy.PocHandlerStrategy");

dojo.declare("com.ibm.data.resolver.strategy.MetadataStrategy",
	com.ibm.data.resolver.strategy.PocHandlerStrategy,
	{
		// summary: Advises a POC handler to modify all fetch queries
		//		targeted at the server-side handler registered at the
		//		same scheme with additional metadata parameters for
		//		requesting metadata for the fetched resources in addition
		// 		to whatever default metadata is returned from the request.
		//		It specifically uses the "mdname" query parameter.
		//		The constructor for this module takes a single argument
		//		array of strings, indicating all the metadata keys
		//		to be requested.
		
		extensions: ["modifyFetchQuery"],
		
		constructor: function(/*Array*/ keys) {
			this._keys = keys || [];
		},
		
		modifyFetchQuery: function(query) {
			if(!query.mdname) query.mdname = [];
			else if(!dojo.isArray(query.mdname)) query.mdname = [query.mdname];
			query.mdname = query.mdname.concat(this._keys);
			return this.proceed(arguments);
		}
	}
);

}
