/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.strategy.PocHandlerStrategy"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.strategy.PocHandlerStrategy"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.data.resolver.strategy.PocHandlerStrategy");

dojo.require("com.ibm.strategy.Strategy");

dojo.declare("com.ibm.data.resolver.strategy.PocHandlerStrategy",
	com.ibm.strategy.Strategy,
	{
		// summary: Base strategy implementation for advising POC handlers.
		//		Provides support for using an instance property called "handler"
		//		within this strategy's functions for gaining easy access to the 
		// 		current handler being advised.
		
		// handler: Object POCHandler object which is the currently advised module
		//		in context of the point where this instance property is referenced.
		//		This is set dynamically at each advice wrapper.
		handler: null,
		
		around: function() {
			this.handler = this.getStrategyContext().instance;
			var ret = this.inherited(arguments);
			this.handler = this.getStrategyContext().instance;
			return ret;
		}
	}
);

}
