/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.EventBroker"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.EventBroker"] = true;
dojo.provide( "com.ibm.portal.EventBroker" );

dojo.require( "com.ibm.portal.debug" );

dojo.declare( "com.ibm.portal.Event",
			  null,
			  {
			  	constructor: function ( /*String*/uniqueEventId ) {
				  	this.eventName = uniqueEventId;
				  	this._listeners = new Array();
				},
			  	fire: function ( /*Object?*/ parameters ) {
					// summary: Fires the event to the listeners.
					// parameters: any parameters that are to be passed to the listeners
					ibm.portal.debug.text( "Firing event: " + this.eventName + " with parameters: " );
					////dojo.debugShallow( parameters );
					//dojo.event.topic.publish( this.eventName, parameters );
					dojo.publish( this.eventName, [parameters] );
				},
				register: function ( /*Function or Object*/listener, /*Function or String*/listenerFunc ) {
					// summary: Registers a listener with an event.
					// listener: the listener function to be called when an event is fired.
					
					if ( !listenerFunc ) {
						//dojo.event.topic.subscribe( this.eventName, listener );
						return dojo.subscribe( this.eventName, null, listener ); // Handle
					}
					else {
						//dojo.event.topic.subscribe( this.eventName, listener, listenerFunc );
						return dojo.subscribe( this.eventName, listener, listenerFunc ); // Handle
					}	
				},
				unregister: function( /*Handle*/handle ) { 
					// summary: Unregisters a listener from an event. The parameters must match
					//		exactly.
					//dojo.event.topic.unsubscribe( this.eventName, listener, listenerFunc );
					dojo.unsubscribe( handle );
				},
				cancel: function ( /*Object?*/ parameters ) { 
					// summary: Cancels an event.
					// parameters: any parameters to be passed to the listeners
					dojo.publish( this.id + "/cancel" );	
				} 
			  }
);

dojo.declare( "com.ibm.portal.EventBroker",
			  null,
			  {
			  	// summary: All events should be instance variables of an Event.	
				
				//required events
				startPage: new com.ibm.portal.Event( "portal/StartPage" ),
				endPage: new com.ibm.portal.Event( "portal/EndPage" ),
				startFragment: new com.ibm.portal.Event( "portal/StartFragment" ),
				endFragment: new com.ibm.portal.Event( "portal/EndFragment" ),
				fragmentUpdated: new com.ibm.portal.Event( "portal/FragmentUpdated" ),
				startRequest: new com.ibm.portal.Event( "portal/StartRequest" ),
				endRequest: new com.ibm.portal.Event( "portal/EndRequest" ),
				cancelAll: new com.ibm.portal.Event( "portal/CancelAll" ),
				stateChanged: new com.ibm.portal.Event( "portal/StateChanged" ),
				startScriptHandling: new com.ibm.portal.Event( "portal/StartScriptHandling" ),
				endScriptHandling: new com.ibm.portal.Event( "portal/EndScriptHandling" ),
				startScriptExecution: new com.ibm.portal.Event( "portal/StartScriptExecution" ),
				endScriptExecution: new com.ibm.portal.Event( "portal/EndScriptExecution" ),
                javascriptCleanup: new com.ibm.portal.Event( "portal/JavascriptCleanup" ),
                //The events below this comment need to be removed. They are deprecated. We may have to leave them in for compatibility.
                //startScriptExecution and endScriptExecution should be used instead. There will be no replacement for restorePointUpdated
                //and clearRestorePoint as these should never have been introduced.
                beforeSnapShot: new com.ibm.portal.Event( "portal/BeforeSnapShot" ),
                afterSnapShot: new com.ibm.portal.Event( "portal/AfterSnapShot" ),
                restorePointUpdated: new com.ibm.portal.Event( "portal/RestorePointUpdated" ),
                clearRestorePoint: new com.ibm.portal.Event( "portal/ClearRestorePoint" ),
				//The events above this comment need to be removed. They are deprecated.
                stopEvent: new com.ibm.portal.Event( "portal/StopEvent" ),
				redirect: new com.ibm.portal.Event( "portal/Redirect" )
			  }
);

com.ibm.portal.EVENT_BROKER = new com.ibm.portal.EventBroker();

}
