/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.aggregation.error"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.aggregation.error"] = true;
dojo.provide( "com.ibm.portal.aggregation.error" );

dojo.require("dojo.i18n");

dojo.declare( "com.ibm.portal.aggregation.error.ErrorHandler",
              null,
              {
                constructor: function () {
                    // Take over the onerror handler directly and not as an event listener through dojo
                    // so that when reportError gets called, all 3 parameters have error information
                    window.onerror = this.reportError;
                    //dojo.connect( window, "onerror", dojo.hitch( this, "reportError" ) );
                    
                    //Take over the error handling here from dojo.
                    dojo.raise = this.reportDojoError;
                    
                },
                reportError: function ( /*String*/msg, /*String*/detailedDescription, /*String*/lineNo ) {
                    if ( !detailedDescription ) { 
                        detailedDescription = "";
                        if (lineNo) {
                            detailedDescription = lineNo;
                        }
                    }

                    var errorMessage = new com.ibm.portal.aggregation.StatusMessage( 'error', msg, detailedDescription );
                    dojo.publish("/portal/status",[{message: errorMessage}]);
                },
                reportWarning: function ( /*String*/msg, /*String*/detailedDescription ) {
                    if ( !detailedDescription ) { detailedDescription = ""; }
                    var warningMessage = new com.ibm.portal.aggregation.StatusMessage( 'warning', msg, detailedDescription );
                    dojo.publish("/portal/status",[{message: warningMessage}]); 
                },
                reportDojoError: function ( /*String*/message, /*String*/exception ) {
                    var details = "";
                    if(exception){
                        details = message + ": "+dojo.errorToString(exception);
                      }else{
                        details = dojo.errorToString(message);
                      }
                    var v3themeProperties = dojo.i18n.getLocalization("com.ibm.portal", "v3theme", csaUserLocale);
                    var errorMessage = new com.ibm.portal.aggregation.StatusMessage( 'error', v3themeProperties["statusError"], details );
                    dojo.publish("/portal/status",[{message: errorMessage}]);
                    window.console.log( message );
                    
                    return true;
                }
              }
);

com.ibm.portal.aggregation.error.ERROR_HANDLER = null;

//Need to trigger this after the page is loaded, otherwise the dojo.connect call in the constructor will fail.
dojo.addOnLoad( function () { com.ibm.portal.aggregation.error.ERROR_HANDLER = new com.ibm.portal.aggregation.error.ErrorHandler();  } );

}
