/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.data.ContentModelStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.data.ContentModelStore"] = true;
dojo.provide( "com.ibm.portal.data.ContentModelStore" );

dojo.require( "com.ibm.portal.data._PortalModelStore" );

dojo.declare( "com.ibm.portal.data.ContentModelStore",
			com.ibm.portal.data._PortalModelStore, 
			{
				// itemClass: String the class used to represent items of this store
				itemClass: "com.ibm.portal.data.ContentModelItem",
				
				constructor: function( /*Map*/ args ) {
					// summary: Creates a new instance of a com.ibm.portal.data.ContentModelStore
					// args: Map
					this._features['dojo.data.api.Write'] = true;	// adding Write support for this implementation
					this._features['dojo.data.api.Notification'] = true; // adding Notification support for this implementation
					
					// URL basic format - /wps/[my]contenthandler[/vpmapping]?(uri=model-uri)+(&mode=verb)?(&name=value)*
				},
				
				/********************************/
				/**                            **/
				/**    Extensions used by      **/
				/**    functions implementing  **/
				/**    dojo.data.api.Write     **/
				/**                            **/
				/**                            **/
				/********************************/
				_prepareNewItemArgs: function(args, parentInfo) {
					var map = this.inherited(arguments);
					
					// Disabled popup checkbox for checking private or public
					/*if(map.isPrivate == "on"){
						map.isPrivate = "true";
					}else{
						map.isPrivate = "false";
					}*/
					
					// if layout is null, set to empty string
					if(!map.layout){
						map.layout = "";
					}	
						
					return map;
				},
				_getTemplate: function(args, parentInfo) {
					return this.template;
				}
			}
);

(function(){
	var namespaces = com.ibm.portal.data.ContentModelStore.prototype.namespaces;
	var nsDecl = new Array();
	
	for(var prefix in namespaces) {
		nsDecl.push('xmlns:', prefix, '="', namespaces[prefix], '" ');
	}
	dojo.extend(com.ibm.portal.data.ContentModelStore, {
		template: 	['<?xml version="1.0" encoding="UTF-8"?>',
					'<atom:feed ',
						nsDecl.join(''),
						'>',
						'<atom:author>',
							'<atom:name>IBM WebSphere Portal/6.1</atom:name>',
						'</atom:author>',
						'<atom:title>IBM WebSphere Portal Model Feed</atom:title>',
						'<atom:link href="." rel="self" type="application/atom+xml"/>',
						'<atom:entry>',
							'<atom:title>${title}</atom:title>',
							'<atom:id></atom:id>',
							'<atom:content type="application/xml">',
								'<model:content-page creation-context:private="${isPrivate}">',
									'<model:supported-markup>html</model:supported-markup>',
									'<model:title>',
									'<base:nls-string xml:lang="${locale}">${title}</base:nls-string>',
									'</model:title>',
									'<model:metadata  name="layout">',
									'<base:value xsi:type="base:String" value="${layout}"/>',
									'</model:metadata>',
									'<model:metadata  name="com.ibm.portal.friendly.name">',
									'<base:value xsi:type="base:String" value="${friendlyURL}"/>',
									'</model:metadata>',
								'</model:content-page>',
							'</atom:content>',
							'<thr:in-reply-to portal:uri="${parent}" href="${parent}" ref="${parent}" type="application/atom+xml"/>',
						'</atom:entry>',
					'</atom:feed>'].join('')
	}
);
})();


dojo.declare( "com.ibm.portal.data.ContentModelItem",
			com.ibm.portal.data._PortalModelItem,
			{
				// summary: Helper class used to extend attrMappings for additional attributes provided by
				// 		content model items
				attrMappings: dojo.mixin({}, com.ibm.portal.data._PortalModelItem.prototype.attrMappings, {
					layout: {xpath: "./atom:link[@portal:rel='layout']", targetName: "portal:uri", type: "attr", setter: 
						function(item, rule, value){
							var attrs = {"portal:rel": "layout"};
							attrs[rule.targetName] = value;
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link", attrs);
							item.element.appendChild(elem);
							return true;
						}
					},
					layoutURI: {xpath: "./atom:link[@portal:rel='layout']", targetName: "href", type: "attr", setter: 
						function(item, rule, value){
							var attrs = {"portal:rel": "layout"};
							attrs[rule.targetName] = value;
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link", attrs);
							item.element.appendChild(elem);
							return true;
						}
					},
					theme: {xpath: "./atom:link[@portal:rel='theme']", targetName: "portal:uri", type: "attr", setter: 
						function(item, rule, value){
							var attrs = {"portal:rel": "theme"};
							attrs[rule.targetName] = value;
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link", attrs);
							item.element.appendChild(elem);
							return true;
						}
					},
					contextMenu: {xpath: "./atom:link[@portal:rel='contextMenu']", targetName: "portal:uri", type: "attr", setter: 
						function(item, rule, value){
							var attrs = {"portal:rel": "contextMenu"};
							attrs[rule.targetName] = value;
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link", attrs);
							item.element.appendChild(elem);
							return true;
						}
					},
					contextMenuURI: {xpath: "./atom:link[@portal:rel='contextMenu']", targetName: "href", type: "attr", setter: 
						function(item, rule, value){
							var attrs = {"portal:rel": "contextMenu"};
							attrs[rule.targetName] = value;
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link", attrs);
							item.element.appendChild(elem);
							return true;
						}
					},
					shareable: {xpath: "./atom:content/*[model:shareable]/model:shareable", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var nodes = this._getNodesByXpath(item.element, "./atom:content/*").value;
							if(!nodes || nodes.length == 0) return false;
							var elem = this._createNSElement(item.element.ownerDocument, "model:shareable");
							this._setNodeProp(elem, rule.targetName, value);
							nodes[0].appendChild(elem);
							return true;
						}
					},
					bookmarkable: {xpath: "./atom:content/*[model:bookmarkable]/model:bookmarkable", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var nodes = this._getNodesByXpath(item.element, "./atom:content/*").value;
							if(!nodes || nodes.length == 0) return false;
							var elem = this._createNSElement(item.element.ownerDocument, "model:bookmarkable");
							this._setNodeProp(elem, rule.targetName, value);
							nodes[0].appendChild(elem);
							return true;
						}
					},
					contentNodeType: {xpath: "./atom:content/*", targetName: dojo.isIE ? "baseName" : "localName", type: "node", setter: 
						function(item, rule, value){
							// don't support changing a content node's type
							return false;
						}
					},
					internalRef: {xpath: "./atom:link[@portal:rel='internal-url']", targetName: "portal:uri", type: "attr"},
					internalURL: {xpath: "./atom:link[@portal:rel='internal-url']", targetName: "href", type: "attr"},
					externalURL: {xpath: "./atom:link[@portal:rel='external-url']", targetName: "href", type: "attr"},
					metadata$: {xpath: "./atom:content/*/model:metadata[@name='${0}']/base:value", targetName: "value", type: "attr", mdname: "${0}", setter: 
						function(item, rule, value){
							var result = this._getNodeByXpath(item.element, "./atom:content/*");
							var modelNode = result.value;
							var node = this._getNodeByXpath(modelNode, "./model:metadata[@name='" + rule.mdname + "']").value;
							if(!node) {
								node = this._createNSElement(item.element.ownerDocument, "model:metadata");
								this._setAttribute(node, "name", rule.mdname);
								modelNode.appendChild(node);
							}
							var attrs = {"xsi:type": "base:String"};
							attrs[rule.targetName] = value;
							var elem = this._createNSElement(item.element.ownerDocument, "base:value", attrs);
							node.appendChild(elem);
							return true;
						}
					}
				}),
		        _makeModifiable: function() {
					// summary: Modifies the element of this item to become modifiable
					//		for writing back to the server.  Subclasses can override this
					//		to do things like prune an item to only include necessary information
					//		for updates and nothing more.  This is called by backup once after
					//		backing up the original element first.  After this returns,
					//		this item's element may have been modified.  Any queries against
					//		this item should now include logic to check the backup copy as well
					//		if a query doesn't return anything as it could have been deleted by
					//		this function.  Care should be taken to ensure that the query result
					//		specifically detects if nothing was found or if the actual value was
					//		null or empty.
					var node = this._getNodeByXpath(this.element, "./atom:content/*").value;
					if(node) {
						while(node.childNodes.length > 0) {
							node.removeChild(node.childNodes[0]);
						}
					}
					
					var toRemove = ["./atom:link"];
					dojo.forEach(toRemove, function(expr){
						var nodes = this._getNodesByXpath(this.element, expr).value;
						dojo.forEach(nodes, function(node){
							node.parentNode.removeChild(node);
						}, this);
					}, this);
					
					this.inherited(arguments);
				}
			}
);

}
