/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.data.LayoutModelStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.data.LayoutModelStore"] = true;
dojo.provide( "com.ibm.portal.data.LayoutModelStore" );

dojo.require( "com.ibm.portal.data._PortalModelStore" );

dojo.declare( "com.ibm.portal.data.LayoutModelStore",
			com.ibm.portal.data._PortalModelStore, 
			{
				attrMappings: dojo.mixin({}, com.ibm.portal.data._PortalModelStore.prototype.attrMappings,
					{
						allPortletsAllowed: {xpath: "./model:allPortletsAllowed", targetName: "textContent", type: "node"},
						wmURI: {xpath: "./atom:link[@rel='related']", targetName: "href", type: "attr"}
					}
				),
				
				// itemClass: String the class used to represent items of this store
				itemClass: "com.ibm.portal.data.LayoutModelItem",

				constructor: function( /*Map*/ args ) {
					// summary: Creates a new instance of a com.ibm.portal.data.LayoutModelStore
					// args: Map
					this._features['dojo.data.api.Write'] = true;	// adding Write support for this implementation
					this._features['dojo.data.api.Notification'] = true; // adding Notification support for this implementation
					
					// URL basic format - /wps/[my]contenthandler[/vpmapping]?(uri=model-uri)+(&mode=verb)?(&name=value)*
				},

				/********************************/
				/**                            **/
				/**    Extensions used by      **/
				/**    functions implementing  **/
				/**    dojo.data.api.Write     **/
				/**                            **/
				/**                            **/
				/********************************/
				_prepareNewItemArgs: function(args, parentInfo) {
					var map = this.inherited(arguments);
					
					// this code below determines if we're creating a layout node whose parent is another layout
					// node, or if we're creating a layout node which will be the root layout node of a page,
					// the map.parent will have a layoutId part if we're creating a child of an existing layout node,
					// but if it does not, then we only have a pageId and we will want to remove the thr:in-reply-to
					// element from the data that's sent to the server (so that no parent is specified)
					var compParts = this._extractCompositeIds(map.parent);
					if(compParts.pageId) {
						map.pageId = compParts.pageId;
					}
					if(compParts.layoutId) {
						// the parent is a layout node
						map.layoutId = compParts.layoutId;
					}
					else {
						// the parent is the page itself, so we're creating a root layout node
						delete map.parent;
					}
					
					if(map.portletId) {
						map.portletId = this._fixModelId(map.portletId, "pm").replace(/\s/g, "%20");
					}
					
					return map;
				},
				_getTemplate: function(args, parentInfo) {
					if(args.portletId) {
						// adding a portlet control to the page
						return this.ptemplate;
					}
					else {
						// just adding a layout node to the page
						return this.ltemplate;
					}
				},
				_getCreateUri: function(args, parentInfo) {
					// if there's no parent, we're creating the root layout node of a page
					if(!args.parent) return "lm:oid:" + args.pageId + "@oid:" + args.pageId;
					else return args.parent;
				},
				_extractCompositeIds: function(/*String*/ compositeId) {
					// summary: Extracts the parts from a composite id consisting of a layout part and a page part.
					if(compositeId.indexOf("lm:") == 0) {
						var lid = compositeId.substring(compositeId.indexOf("lm:oid:") + 7, compositeId.indexOf("@"));
						return {layoutId: lid, pageId: compositeId.substring(compositeId.lastIndexOf("@oid:") + 5)};
					}
					else if(compositeId.indexOf("cm:") == 0) {
						return {layoutId: null, pageId: compositeId.substring(compositeId.lastIndexOf(":") + 1)};
					}
					else {
						return {layoutId: null, pageId: compositeId};
					}
				}
			}
);


(function(){
	var namespaces = com.ibm.portal.data.LayoutModelStore.prototype.namespaces;
	var nsDecl = new Array();
	
	for(var prefix in namespaces) {
		nsDecl.push('xmlns:', prefix, '="', namespaces[prefix], '" ');
	}
	dojo.extend(com.ibm.portal.data.LayoutModelStore, {
		ltemplate: 	['<?xml version="1.0" encoding="UTF-8"?>',
					'<atom:feed ',
						nsDecl.join(''),
						'>',
						'<atom:author>',
							'<atom:name>IBM WebSphere Portal/6.1</atom:name>',
						'</atom:author>',
						'<atom:title>IBM WebSphere Portal Model Feed</atom:title>',
						'<atom:link href="." rel="self" type="application/atom+xml"/>',
						'<atom:entry>',
							'<atom:title>lm:oid:${pageId}@oid:${pageId}</atom:title>',
							'<atom:id>lm:oid:${pageId}</atom:id>',
							'<atom:content type="application/xml">',
								'<model:layout-container/>',
							'</atom:content>',
							'<thr:in-reply-to portal:uri="${parent}" href="${parent}" ref="${parent}" type="application/atom+xml"/>',
						'</atom:entry>',
					'</atom:feed>'].join('')
	});
	
	dojo.extend(com.ibm.portal.data.LayoutModelStore, {
		ptemplate: 	['<?xml version="1.0" encoding="UTF-8"?>',
					'<atom:feed ',
						nsDecl.join(''),
						'>',
						'<atom:author>',
							'<atom:name>IBM WebSphere Portal/6.1</atom:name>',
						'</atom:author>',
						'<atom:title>IBM WebSphere Portal Model Feed</atom:title>',
						'<atom:link href="." rel="self" type="application/atom+xml"/>',
						'<atom:entry>',
							'<atom:title>lm:oid:${pageId}@oid:${pageId}</atom:title>',
							'<atom:id>lm:oid:${pageId}</atom:id>',
							'<atom:content type="application/xml">',
								'<model:layout-control creation-context:portlet-definition="${portletId}">',
									'<model:deletable>true</model:deletable>', 
					                '<model:deletableFlag>true</model:deletableFlag>',
					                '<model:modifiable>true</model:modifiable>', 
					                '<model:modifiableFlag>true</model:modifiableFlag>',
								'</model:layout-control>',
							'</atom:content>',
							'<thr:in-reply-to portal:uri="${parent}" href="${parent}" ref="${parent}" type="application/atom+xml"/>',
						'</atom:entry>',
					'</atom:feed>'].join('')
	});
})();


dojo.declare( "com.ibm.portal.data.LayoutModelItem",
			com.ibm.portal.data._PortalModelItem,
			{
				// summary: Helper class used to extend attrMappings for additional attributes provided by
				// 		layout model items
				attrMappings: dojo.mixin({}, com.ibm.portal.data._PortalModelItem.prototype.attrMappings, {
					contextMenu: {xpath: "./atom:link[@portal:rel='contextMenu']", targetName: "portal:uri", type: "attr"},
					contextMenuURI: {xpath: "./atom:link[@portal:rel='contextMenu']", targetName: "href", type: "attr"},
					skin: {xpath: "./atom:link[@portal:rel='skin']", targetName: "portal:uri", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					skinUniqueName: {xpath: "./atom:link[@portal:rel='skin']", targetName: "portal:uniquename", type: "attr", setter:
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					portlet: {xpath: "./atom:link[@portal:rel='portlet']", targetName: "portal:uri", type: "attr"},
					portletURI: {xpath: "./atom:link[@portal:rel='portlet']", targetName: "href", type: "attr"},
					portletDefinition: {xpath: "./atom:link[@portal:rel='portlet-definition']", targetName: "portal:uri", type: "attr"},
					portletDefinitionURI: {xpath: "./atom:link[@portal:rel='portlet-definition']", targetName: "href", type: "attr"},
					templateName: {xpath: "./atom:content/*[model:templateName]/model:templateName", targetName: "textContent", type: "node"},
					modifiable: {xpath: "./atom:content/*[model:modifiable]/model:modifiable", targetName: "textContent", type: "node"},
					modifiableFlag: {xpath: "./atom:content/*[model:modifiableFlag]/model:modifiableFlag", targetName: "textContent", type: "node"},
					deletable: {xpath: "./atom:content/*[model:deletable]/model:deletable", targetName: "textContent", type: "node"},
					deletableFlag: {xpath: "./atom:content/*[model:deletableFlag]/model:deletableFlag", targetName: "textContent", type: "node"},
					containerChild: {xpath: "./atom:content/*[model:containerChild]/model:containerChild", targetName: "textContent", type: "node"},
					controlChild: {xpath: "./atom:content/*[model:controlChild]/model:controlChild", targetName: "textContent", type: "node"}
				}),
		        _makeModifiable: function() {
					// summary: Modifies the element of this item to become modifiable
					//		for writing back to the server.  Subclasses can override this
					//		to do things like prune an item to only include necessary information
					//		for updates and nothing more.  This is called by backup once after
					//		backing up the original element first.  After this returns,
					//		this item's element may have been modified.  Any queries against
					//		this item should now include logic to check the backup copy as well
					//		if a query doesn't return anything as it could have been deleted by
					//		this function.  Care should be taken to ensure that the query result
					//		specifically detects if nothing was found or if the actual value was
					//		null or empty.
					var node = this._getNodeByXpath(this.element, "./atom:content/*").value;
					if(node) {
						while(node.childNodes.length > 0) {
							node.removeChild(node.childNodes[0]);
						}
					}
					
					var toRemove = ["./atom:link"];
					dojo.forEach(toRemove, function(expr){
						var nodes = this._getNodesByXpath(this.element, expr).value;
						dojo.forEach(nodes, function(node){
							node.parentNode.removeChild(node);
						}, this);
					}, this);
					
					this.inherited(arguments);
				}
			}
);

}
