/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.dnd.PortletMediator"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.dnd.PortletMediator"] = true;
dojo.provide("com.ibm.portal.dnd.PortletMediator");

dojo.require("dojo.dnd.Manager");
dojo.require("dojo.dnd.Source");
dojo.require("dojo.dnd.Container");
dojo.require("com.ibm.portal.dnd.PortletSourceGhost");
dojo.require("com.ibm.portal.dnd.PortletSource");
dojo.require("dojo.parser");

dojo.declare("com.ibm.portal.dnd.PortletMediator",
	null,
	{
		type: "ibmPortalPortlet",
		isDragging: false,
		currentType: null,
		currentTarget: null,
		currentTargetId: null,
		currentParentId: null,
		currentSourceId: null,
		currentMargin: 0,
		emptyContainer: null,
		before: false,
		ghostHeight: 0,
		ghostClass: "ibmPortalDndGhost",
		portletBodyClass: "ibmPortalPortletBody",
		portletContainerClass: "ibmPortalControlContainer",
		layoutContainerClass: "ibmPortalLayoutContainer",
		layoutRootClass: "ibmPortalLayoutRoot",		
		defaultTargetIndicator: "dojoDndItemBefore",
		dndContainers: {},
		delaySave: true,
		movedItems: [],
		
		init: function(){		
			//gather the portlet containers
			var containers = dojo.query("."+com.ibm.portal.dnd.PORTLET_MEDIATOR.layoutContainerClass);
			dojo.forEach(
				containers,
			    function(item){
					var portlets = dojo.query('.'+com.ibm.portal.dnd.PORTLET_MEDIATOR.portletContainerClass, item);				
					//add required dnd attributes/classes for portlets
					dojo.forEach(
						portlets,
						function(portlet){	
							// create this portlet as a dnd item
							dojo.addClass(portlet, "dojoDndItem");
							
							// set the dnd type as a portlet
							dojo.attr(portlet, "dndType", com.ibm.portal.dnd.PORTLET_MEDIATOR.type);
							
							//set the drag and drop handle inside the control
							var controlDndHandle = dojo.query('.ibmPortalControlDndHandle', portlet);
							if(controlDndHandle){
								controlDndHandle.addClass("dojoDndHandle");
							}
						}
					);

					com.ibm.portal.dnd.PORTLET_MEDIATOR.dndContainers[item.id] = null;

					//create dnd containers	for portlets
					var cls = dojo.eval(ibmPortalConfig.portletDndSource);
					com.ibm.portal.dnd.PORTLET_MEDIATOR.dndContainers[item.id] = new cls(
							item,{
							creator: com.ibm.portal.dnd.PORTLET_MEDIATOR.creator, 
							accept: [com.ibm.portal.dnd.PORTLET_MEDIATOR.type], 
							withHandles: ibmPortalConfig.dndPortletsWithHandles,
							singular: true,
							skipForm: true
							});
				}
			);			
			
			// connect dnd events
			dojo.subscribe("/dnd/start", com.ibm.portal.dnd.PORTLET_MEDIATOR, "onStart");
			dojo.subscribe("/dnd/drop/before", com.ibm.portal.dnd.PORTLET_MEDIATOR, "onBeforeDrop");
			dojo.subscribe("/dnd/drop", com.ibm.portal.dnd.PORTLET_MEDIATOR, "onDrop");
			dojo.subscribe("/dnd/cancel", com.ibm.portal.dnd.PORTLET_MEDIATOR, "onCancel");
		},
		saveMoves: function(callback){
			ibmPortalConfig.resolver.saveItems(this.movedItems,{onComplete:callback,onError:callback});
			this.movedItems = [];
		},
		onStart: function(source, nodes, copy){
			this.isDragging = true;			
			var sourceObject = source.getItem(nodes[0].id);
			this.currentType = sourceObject.type;
			if(this.currentType == this.type){			
				// set the cursor to move on the entire page
				dojo.style(dojo.body(),{cursor:"move"});
				// override style for portlet body
				dojo.query("."+this.portletBodyClass).style({cursor:"move"});
				
				this.setLayoutContainerHeight();
				
				//retrieve the current node that is dragging
				var node = dojo.byId(nodes[0].id);
				
				//retrieve control height
				this.ghostHeight = node.offsetHeight;
				
				//calculate the control's margin
				var control = dojo.query(".ibmPortalControl", node)[0];
				this.currentMargin = dojo.marginBox(node).w - control.offsetWidth;
				//retrieve the current dragging control's id
				this.currentSourceId = dojo.attr(node,"controlId");
				
				dojo.style(node, { display:"none" });
			}
		},
		onBeforeDrop: function(source, nodes, copy){
			if(this.currentType == this.type){
				if(this.currentTarget && !this.emptyContainer){
					this.currentParentId = dojo.byId(this.currentTarget.id).parentNode.id;
					if(this.before == true){
					// the target is before the current node
						this.currentTargetId = this.currentTarget.id;
					}else{
					// the target is after the current node	
						var layoutContainer = this.getLayoutContainer(dojo.byId(this.currentTarget.id));					
						var portlets = dojo.query("."+this.portletContainerClass, layoutContainer);
						
						for(var index=0;index<portlets.length;index++){
							if(portlets[index].id == this.currentTarget.id){
								if(index+1 < portlets.length){
									this.currentTargetId = portlets[index+1].id;
									break;
								}else{
									// the target is below the last node
									// set to null to append at end of container
									this.currentTargetId = null;	
									break;
								}
							}
						}
					}
				}else{
				// the target is an empty container
					if(this.emptyContainer){
						this.currentParentId = this.emptyContainer.id;
						this.currentTargetId = null;
					}else{
						this.onCancel();
					}
				}
			}
		},
		onDrop: function(source, nodes, copy){
			if(this.currentType == this.type){
				// reset the cursor to default
				dojo.style(dojo.body(), { cursor:"default" });
				dojo.query("."+this.portletBodyClass).style({cursor: "default"});
				this.removeLayoutContainerHeight();
				this.removeTargetIndicator();			
				this.isDragging = false;
				this.resetGhostDimensions();
				this.sendMoveRequest(nodes[0].id);
				var node = dojo.byId(nodes[0].id);
				if(node)
					dojo.style(node, { opacity: 1, display:"" });
			}
		},
		onCancel: function(){
			if(this.currentType == this.type){
				// reset the cursor to default
				dojo.style(dojo.body(), { cursor:"default" });
				dojo.query("."+this.portletBodyClass).style({cursor: "default"});
				this.removeLayoutContainerHeight();
				var node = dojo.byId(dojo.dnd.manager().nodes[0].id);
				dojo.style(node, { opacity: 1, display:"" });
				this.isDragging = false;
				this.resetGhostDimensions();
			}
		},
		sendMoveRequest: function(sourceId){	
			var suffix = "@oid:"+ibmPortalConfig.currentPageOID;
			var targetControlId = null;
			
			if(this.currentTargetId != null){
				targetControlId = dojo.attr(dojo.byId(this.currentTargetId),"controlId")+suffix;
			}
			
			if(this.currentSourceId && this.currentParentId){
				
				var store = ibmPortalConfig.resolver;
				var setAttributes = dojo.hitch(this,function(item){
					store.setValue(item, "parentId", "lm:"+this.currentParentId+suffix); 
					if(targetControlId) store.setValue(item, "nextId", "lm:"+targetControlId);
					if(!this.delaySave) store.save();
					else this.movedItems.push(item);
				});
				var item = store.byId("lm:"+this.currentSourceId+suffix);
				if(store.isItemLoaded(item)){
					setAttributes(item);
				} else {
					store.loadItem({
						item: item,
						onItem: setAttributes
					});
				}			
			}
			
			this.resetTargets();			
		},
		createGhost: function(node, type){
			if(type == "Before"){
				this.before = true;
				node.insertBefore(this.createGhostMarkup(this.ghostHeight), 
								  node.childNodes[0]);
				
			}else if (type == "After"){
				this.before = false;
				node.appendChild(this.createGhostMarkup(this.ghostHeight));
			}
		},
		removeGhost: function(){
			var ghost = dojo.byId(this.ghostClass);
			if(ghost){
				var parent = ghost.parentNode;
				parent.removeChild(ghost);
			}
		},
		removeTargetIndicator: function(){
			if(ibmPortalConfig.dndPortletsWithGhost){
				this.removeGhost();
			}else{
				// this cleans up the indicator on empty containers
				dojo.query("."+this.defaultTargetIndicator).removeClass(this.defaultTargetIndicator);
			}
		},
		createGhostMarkup: function(height){
			var elem = document.createElement("div");
			dojo.style(elem, { height: height+"px"});
			var node = dojo.byId(dojo.dnd.manager().target.current.id);
			elem.style.width=node.offsetWidth;

			if(dojo.isIE)
				dojo.style(elem, { margin: "0"});
			
			elem.className = this.ghostClass;
			elem.id = this.ghostClass;
			return elem;
		},
		createEmptyContainerGhostMarkup: function(height, width){
			var elem = document.createElement("div");
			dojo.style(elem, { height: height+"px"});
			dojo.style(elem, { width: width-this.currentMargin});
			
			if(dojo.isIE)
				dojo.style(elem, { margin: "0"});
			
			elem.className = this.ghostClass;
			elem.id = this.ghostClass
			return elem;
		},
		creator: function(item, hint){
			if(hint=="avatar"){
				var node = dojo.doc.createElement("div");
				if(dojo.dnd.manager().source.current){
					// use the portlet markup as avatar
					node.innerHTML = String(item);
					var elem = dojo.byId(dojo.dnd.manager().source.current.id);
					dojo.style(node, { width: elem.offsetWidth+"px", opacity: 0.5});
				}
				return {node: node, data: item, type: [com.ibm.portal.dnd.PORTLET_MEDIATOR.type]};
			}else{  // this works the same way as the _normalizedCreator/onDropExternal functions in dojo.dnd.Source when there is no given creator function
				if(dojo.isOpera) {
					var node = dojo.byId(com.ibm.portal.dnd.PORTLET_MEDIATOR.currentSourceId).parentNode;  // opera returned nothing using dojo.query below
				} else {
					var node = dojo.query("[controlid~="+com.ibm.portal.dnd.PORTLET_MEDIATOR.currentSourceId+"]")[0];
				}
				var source = com.ibm.portal.dnd.PORTLET_MEDIATOR.dndContainers[node.parentNode.id];
				var t = source.getItem(node.id);
				source.delItem(node.id);
				source.selection = {};  // prevents node from being deleted in dojo.dnd.Selector.deleteSelectedNodes called by onDropExternal()
				return {node: node, data: t.data, type: t.type};
			}
		},
		getLayoutContainer: function(node){
		    var elem = node.parentNode;

		    while ( !(elem.className.indexOf(this.layoutContainerClass)) ) {
				elem = elem.parentNode;
			}
		    
		    return elem;
		},
		setLayoutContainerHeight: function(){
			var containers = dojo.query("."+this.layoutContainerClass);
			var height = 0;
			for(var i = 0; i < containers.length; i++){
				var currentHeight = containers[i].clientHeight;
				
				if(currentHeight > height){
						height = currentHeight;
				}
			}
			containers.style({minHeight: height+"px"});
			// Fixes IE6 not knowing how to use minheight
			if (dojo.isIE == 6)
				containers.style({height: height+"px"});
		},
		removeLayoutContainerHeight: function(){
			dojo.query("."+this.layoutContainerClass).style({minHeight:"0px"});
			dojo.query("."+this.layoutContainerClass).style({height:"auto"});
		},
		resetGhostDimensions: function(){
			this.ghostHeight = 0;
		},
		resetTargets: function(){
			this.currentTargetId = null;
			this.emptyContainer = null;
		}
	}
);

com.ibm.portal.dnd.PORTLET_MEDIATOR = new com.ibm.portal.dnd.PortletMediator();


}
