<?xml version="1.0"?> 
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:state="http://www.ibm.com/xmlns/prod/websphere/portal/v6.1/portal-state">

<xsl:output method="xml" indent="yes"/>

<xsl:template match="@*|node()">

<root  xmlns="http://www.ibm.com/xmlns/prod/websphere/portal/v6.1/portal-state">
<state type="navigational">

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:selection"></xsl:apply-templates>
			<xsl:call-template name="selection"></xsl:call-template>

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:expansions"></xsl:apply-templates>
			<xsl:call-template name="expansions"></xsl:call-template>

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:portlet"></xsl:apply-templates>
			<xsl:call-template name="portlet"></xsl:call-template>

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:shared-parameters"></xsl:apply-templates>
			<xsl:call-template name="shared-parameters"></xsl:call-template>

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:solo"></xsl:apply-templates>
			<xsl:call-template name="solo"></xsl:call-template>

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:statepartition"></xsl:apply-templates>
			<xsl:call-template name="statepartition"></xsl:call-template>

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:theme-template"></xsl:apply-templates>
			<xsl:call-template name="theme-template"></xsl:call-template>

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:screen-template"></xsl:apply-templates>
			<xsl:call-template name="screen-template"></xsl:call-template>

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:theme-policy"></xsl:apply-templates>
			<xsl:call-template name="theme-policy"></xsl:call-template>

			<xsl:apply-templates select="/merge/base-state/state:root/state:state/state:locale"></xsl:apply-templates>
			<xsl:call-template name="locale"></xsl:call-template>
			
</state>
</root>

</xsl:template>

<xsl:template match="state:selection">
	<xsl:variable name="s2" select="/merge/new-state/state:root/state:state/state:selection"></xsl:variable>
	<xsl:choose>
		<xsl:when test="$s2">
			<xsl:copy-of select="$s2"/>	
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="selection">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:selection">
		<xsl:if test="not(/merge/base-state/state:root/state:state/state:selection)">
			<xsl:copy-of select="."/>		
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="state:expansions">
	<xsl:variable name="e2" select="/merge/new-state/state:root/state:state/state:expansions"></xsl:variable>
	<xsl:choose>
		<xsl:when test="$e2">
			<xsl:copy-of select="$e2"/>	
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="expansions">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:expansions">
		<xsl:if test="not(/merge/base-state/state:root/state:state/state:expansions)">
			<xsl:copy-of select="."/>		
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="state:solo">
	<xsl:variable name="s2" select="/merge/new-state/state:root/state:state/state:solo"></xsl:variable>
	<xsl:choose>
		<xsl:when test="$s2">
			<xsl:copy-of select="$s2"/>	
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="solo">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:solo">
		<xsl:if test="not(/merge/base-state/state:root/state:state/state:solo)">
			<xsl:copy-of select="."/>		
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="state:statepartition">
	<xsl:variable name="sp2" select="/merge/new-state/state:root/state:state/state:statepartition"></xsl:variable>
	<xsl:choose>
		<xsl:when test="$sp2">
			<xsl:copy-of select="$sp2"/>	
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="statepartition">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:statepartition">
		<xsl:if test="not(/merge/base-state/state:root/state:state/state:statepartition)">
			<xsl:copy-of select="."/>		
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="state:theme-template">
	<xsl:variable name="tt2" select="/merge/new-state/state:root/state:state/state:theme-template"></xsl:variable>
	<xsl:choose>
		<xsl:when test="$tt2">
			<xsl:copy-of select="$tt2"/>	
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="theme-template">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:theme-template">
			<xsl:if test="not(/merge/base-state/state:root/state:state/state:theme-template)">
				<xsl:copy-of select="."/>		
			</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="state:screen-template">
	<xsl:variable name="st2" select="/merge/new-state/state:root/state:state/state:screen-template"></xsl:variable>
	<xsl:choose>
		<xsl:when test="$st2">
			<xsl:copy-of select="$st2"/>	
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="screen-template">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:screen-template">
			<xsl:if test="not(/merge/base-state/state:root/state:state/state:screen-template)">
				<xsl:copy-of select="."/>		
			</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="state:theme-policy">
	<xsl:variable name="tp2" select="/merge/new-state/state:root/state:state/state:theme-policy"></xsl:variable>
	<xsl:choose>
		<xsl:when test="$tp2">
			<xsl:copy-of select="$tp2"/>	
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="theme-policy">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:theme-policy">
			<xsl:if test="not(/merge/base-state/state:root/state:state/state:theme-policy)">
				<xsl:copy-of select="."/>		
			</xsl:if>
	</xsl:for-each>
</xsl:template>


<xsl:template match="state:locale">
	<xsl:variable name="l2" select="/merge/new-state/state:root/state:state/state:locale"></xsl:variable>
	<xsl:choose>
		<xsl:when test="$l2">
			<xsl:copy-of select="$l2"/>	
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="locale">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:locale">
			<xsl:if test="not(/merge/base-state/state:root/state:state/state:locale)">
				<xsl:copy-of select="."/>		
			</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="state:portlet">
	<xsl:variable name="p2" select="/merge/new-state/state:root/state:state/state:portlet[@id = current()/@id]"></xsl:variable>
	<xsl:choose>
		<xsl:when test="$p2">
			<xsl:copy-of select="$p2"/>	
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="portlet">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:portlet">
			<xsl:if test="not(/merge/base-state/state:root/state:state/state:portlet[@id = current()/@id])">
				<xsl:copy-of select="."/>		
			</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="state:shared-parameters">
	<xsl:variable name="bucketID" select="current()/@id"></xsl:variable>
	<xsl:choose>
		<xsl:when test="/merge/new-state/state:root/state:state/state:shared-parameters[@id = $bucketID]">
			<state:shared-parameters><xsl:attribute name="id"><xsl:value-of select='$bucketID'></xsl:value-of></xsl:attribute>
			<xsl:for-each select="/merge/base-state/state:root/state:state/state:shared-parameters[@id = $bucketID]/state:shared-parameter">
				<xsl:variable name="nsuri" select="current()/@nsuri"></xsl:variable>
				<xsl:variable name="localpart" select="current()/@localpart"></xsl:variable>
				<xsl:variable name="sp2" select="/merge/new-state/state:root/state:state/state:shared-parameters[@id = $bucketID]/state:shared-parameter[@nsuri = $nsuri and @localpart = $localpart]">
				</xsl:variable>
				<xsl:choose>
					<xsl:when test="$sp2">
						<xsl:copy-of select="$sp2"/>	
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="."/>		
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			<xsl:for-each select="/merge/new-state/state:root/state:state/state:shared-parameters[@id = $bucketID]/state:shared-parameter">
				<xsl:variable name="nsuri" select="current()/@nsuri"></xsl:variable>
				<xsl:variable name="localpart" select="current()/@localpart"></xsl:variable>
				<xsl:variable name="sp1" select="/merge/base-state/state:root/state:state/state:shared-parameters[@id = $bucketID]/state:shared-parameter[@nsuri = $nsuri and @localpart = $localpart]">
				</xsl:variable>
				<xsl:choose>
					<xsl:when test="$sp1">
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="."/>		
					</xsl:otherwise>
				</xsl:choose> 
			</xsl:for-each>
			</state:shared-parameters>
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy-of select="."/>		
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="shared-parameters">
	<xsl:for-each select="/merge/new-state/state:root/state:state/state:shared-parameters">
			<xsl:if test="not(/merge/base-state/state:root/state:state/state:shared-parameters[@id = current()/@id])">
				<xsl:copy-of select="."/>		
			</xsl:if>
	</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
