/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.query.TypeHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.query.TypeHandler"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.query.TypeHandler");
dojo.require("dojo.date.stamp");

(function(){
	var th = com.ibm.query.TypeHandler;
	var dst = dojo.date.stamp;
	th.types = {
		"Number": {
			to: function(value) {
				return value - 0;
			},
			from: function(value) {
				return value.toString();
			}
		},
		"Date": {
			to: function(value) {
				return dst.fromISOString(value);
			},
			from: function(value) {
				return dst.toISOString(value);
			}
		}
	}
	
	th.toType = function(/*String*/ value, /*String*/ type) {
		if(th.types[type] && dojo.isFunction(th.types[type].to)) {
			return th.types[type].to(value);
		}
		else return value;
	}
	
	th.fromType = function(/*String*/ value, /*String*/ type) {
		if(th.types[type] && dojo.isFunction(th.types[type].from)) {
			return th.types[type].from(value);
		}
		else return value;
	}
})();

}
