/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.query.rules.Atom"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.query.rules.Atom"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.query.rules.Atom");

com.ibm.query.rules.Atom = {
	
	namespaces: {
		//"xml" : "http://www.w3.org/XML/1998/namespace",	// added for non-IE browsers
		"atom" : "http://www.w3.org/2005/Atom",
		"app" : "http://www.w3.org/2007/app"
	},
	
	syndication: {
		mimeTypes: {
			atom: "application/atom+xml"
		},
		common: {
			// rules that apply to atom:feed and atom:entry elements
			title: {selector: "./atom:title", field: "$textContent", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:title",
						children: [value]
					});
					return true;
				}
			},
			id: {selector: "./atom:id", field: "$textContent", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:id",
						children: [value]
					});
					return true;
				}
			},
			updated: {selector: "./atom:updated", field: "$textContent", type: "Date"},
			category: {selector: "./atom:category", field: "@term", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:category",
						attributes: {
							"term": value
						}
					});
					return true;
				}
			},
			categoryScheme: {selector: "./atom:category", field: "@scheme", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:category",
						attributes: {
							"scheme": value
						}
					});
					return true;
				}
			},
			categoryLabel: {selector: "./atom:category", field: "@label", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:category",
						attributes: {
							"label": value
						}
					});
					return true;
				}
			},
			contributer: {selector: "./atom:contributer", type: "Node"},
			author: {selector: "./atom:author", type: "Node"},
			summary: {selector: "./atom:summary", field: "$textContent", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:summary",
						children: [value]
					});
					return true;
				}
			},
			source: {selector: "./atom:source", type: "Node", setter: 
				function(item, rule, value){
					item.element.appendChild(value);
					return true;
				}
			},
			rights: {selector: "./atom:rights", field: "$textContent", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:rights",
						children: [value]
					});
					return true;
				}
			},
			selfLink: {selector: "./atom:link[@rel='self']", field: "@href", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:link",
						attributes: {
							"rel": "self",
							"href": value
						}
					});
					return true;
				}
			},
			link: {selector: "./atom:link[@href]", field: "@href", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:link",
						attributes: {
							"href": value
						}
					});
					return true;
				}
			},
			content: {selector: "./atom:content", type: "Node", setter: 
				function(item, rule, value){
					item.element.appendChild(value);
					return true;
				}
			}
		},
		entry: {
			// the following rules are for atom:entry specific attributes
			subtitle: {selector: "./atom:subtitle", field: "$textContent", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:subtitle",
						children: [value]
					});
					return true;
				}
			},
			generator: {selector: "./atom:generator", field: "$textContent", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:generator",
						children: [value]
					});
					return true;
				}
			},
			icon: {selector: "./atom:icon", field: "$textContent", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:icon",
						children: [value]
					});
					return true;
				}
			},
			logo: {selector: "./atom:logo", field: "$textContent", setter: 
				function(item, rule, value){
					this.createFromJson(item.element, {
						name: "atom:logo",
						children: [value]
					});
					return true;
				}
			}
		}
	},
	
	publishing: {
		mimeTypes: {
			service: "application/atomsvc+xml",
			contentTypeReg: "application/atomcat+xml"
		},
		serviceDoc: {
			workspace: {selector: "./app:workspace", type: "Node"},
			workspaceTitle: {selector: "./app:workspace/atom:title", field: "$textContent"}
		},
		categoriesDoc: {
			category: {selector: "./app:categories/atom:category", type: "Node"},
			categoryTerm: {selector: "./app:categories/atom:category", field: "@term"},
			categoryScheme: {selector: "../app:categories", field: "@scheme"},
			categoriesScheme: {selector: "./app:categories", field: "@scheme"},
			categoriesFixed: {selector: "./app:categories", field: "@fixed"},
			categoriesLink: {selector: "./app:categories", field: "@href"}
		},
		member: {selector: "./app:collection/app:member", type:"Node"}
	}
};

if(!dojo.isIE) {
	com.ibm.query.rules.Atom.namespaces["xml"] = "http://www.w3.org/XML/1998/namespace";
}

}
