/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.widgets.LazyLoadingDropdown"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.LazyLoadingDropdown"] = true;
dojo.provide("com.ibm.widgets.LazyLoadingDropdown");
dojo.require("dijit.form.Button");
dojo.require("dojo.io.iframe");
dojo.declare("com.ibm.widgets.LazyLoadingDropdown",
[dijit.form.DropDownButton],
{
	label: "",			// text to put on the button
	url: null,			// url to the drop down menu content
	loaded: false,		// true if the content from the url has been loaded
	button: true,		// true if it should be a buttom DOM element, if false it will be an anchor
	btnClass: "",		// class to put on the drop down button
	savedList: null,	// list of all menu items added via insertChild, list can be cleared via removeSaved function
	emptyMenuText:"0",	// text to display if the menu is empty
	arrowImg: "",		// url to a drop down image to display
	altText: "",		// alt text for the image
	templateString:'<span class="dijitLeft dijitInline" dojoattachevent="onmouseenter:_onMouse,onmouseleave:_onMouse,onmousedown:_onMouse,onclick:_onDropDownClick,onkeydown:_onDropDownKeydown,onblur:_onDropDownBlur,onkeypress:_onKey" widgetid="${id}">' +
						'<span class="dijitInline">' +
							'<${domType} title="${altText}" href="javascript:void(0);" class="${btnClass}" waistate="haspopup-true,labelledby-${id}_label" wairole="button" dojoattachpoint="focusNode,titleNode" type="button" role="button" aria-haspopup="true" aria-labelledby="${id}_label" tabindex="0" style="-moz-user-select: none;">' +
								'<span id="${id}_label" dojoattachpoint="containerNode,popupStateNode">${label}</span>' +
								'<img alt="${altText}" src="${arrowImg}"/>' +
							'</${domType}>' +
						'</span>' +
					'</span>',
					
	postMixInProperties: function(){
		// summary: create the drop down menu and save list and initialize variables
		this.dropDown = new dijit.Menu({style:"display: none;"});
		this.savedList = new Array();
		this.domType = this.button ? "button" : "a";
	},
	
	insertChild: function(child,save){
		// summary: inserts a child into the dropdown menu
		// child: menu item to put insert
		// save: true if it should be added to the savedList
		this.dropDown.addChild(child);
		if(save) this.savedList.push(child);
	},
	
	removeSaved: function(){
		// summary: delete all the items out of the saved list and the menu
		for(var i = 0; i < this.savedList.length; i++){
			this.dropDown.removeChild(this.savedList[i]);
		}
		delete this.savedList;
		this.savedList = new Array();
	},
	
	_onDropDownClick: function(){
		// summary: loads the url menu data if necessary, and runs the onOpenMenu function
		if(!this.loaded){
			this.loaded = true;
			if(this.url) this.loadMenuItemsFromURL();
			else this.postLoadMenuItems();
		} else {
			this.removeSaved();
			this.onOpenMenu();
			this.inherited("_onDropDownClick",arguments);
		}
	},
					
	loadMenuItemsFromURL: function(){
		// loads the json object of menu items from the given url
		dojo.io.iframe.send ({
			url: this.url,
			handleAs: "json",
			method: "GET",
			load: dojo.hitch(this, function (data) {
				// add each json item into the menu
				dojo.forEach(data, dojo.hitch(this,function(item){
					if(item.label){
						var menuItem = new dijit.MenuItem({
							 label: item.label,
							 onClick: item.fcn
						});
						this.dropDown.addChild(menuItem);
					}
				}));
				this.postLoadMenuItems();
			}),
			error: dojo.hitch(this, function (e) {
				var statusMessage = new com.ibm.widgets.StatusMessage("error", this.errorMsg, "");
				dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmPortalStatusBox'}]);
			})
        });
	},
	
	postLoadMenuItems: function(){
		// run the given onOpenMenu function
		this.onOpenMenu();
		// if the menu is empty, add a menu item containing the "empty menu" text
		if(this.dropDown.getChildren().length == 0){
			var menuItem = new dijit.MenuItem({
				 label: this.emptyMenuText,
				 onClick: function(){}
			});
			this.dropDown.addChild(menuItem);
		}
		this._onDropDownClick();
		// select the first menu item for accessibility
		//this.dropDown.getChildren()[0].focus();
	},
	
	onOpenMenu: function(){
	}
});

}
