/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource['com.ibm.workplace.wcm.ecm.quickr.picker.launcher.DocPickerLauncher']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['com.ibm.workplace.wcm.ecm.quickr.picker.launcher.DocPickerLauncher'] = true;
/*********************************************************************/ 
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5724-S31                                                          */
/*                                                                   */
/* Copyright IBM Corp.  2009    All Rights Reserved.                 */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*********************************************************************/

    dojo.provide('com.ibm.workplace.wcm.ecm.quickr.picker.launcher.DocPickerLauncher');
    
    dojo.declare('com.ibm.workplace.wcm.ecm.quickr.picker.launcher.DocPickerLauncher', null, {
        _onConfirmCallbackFn: null,
        _onCloseCallbackFn: null,
        _dialogTitleKey: "dialogTitleDefault",
        _locale: null,
        _showPlaces: false,
        _showNodePath: true,
        _nodeTypes: [],
        _downloadTypes: [],
        _viewTypes: [],
        _forceSSO: false,
        _isMovable: true,
        _allowCustomServers: true,
        _allowedHosts: [],
        _cookieName: "QuickrPickerRecentHosts",
        _lastHostCookie: "qkrMRHU",
 		_proxyUrl : "/wps/proxy",
        _pageSize: 10,
        _timeout: 15000,
        _linkType: null,
        _currentItem: null,
        _nodeType2Selector: {
            place: "new quickr.picker.data.filter.PlaceSelector()",
            library: "new quickr.picker.data.filter.LibrarySelector()",
            folder: "new quickr.picker.data.filter.FolderSelector()",
            doclink: "new quickr.picker.data.filter.DocLinkSelector()",    
            document: "new quickr.picker.data.filter.DocumentSelector()"
        },
        _nlsStrings: null,
        _onCloseHdl: null,
        
        // summary:
        //    Constructor of DocPickerLauncher.
        // p_onConfirmCallbackFn:
        //    Javascript function to call when the selection of an item is confirmed pressing 'OK' in the document picker dialog.
        // p_onCloseCallbackFn:
        //    Javascript function to call when the document picker dialog is closed. (optional)
        // p_args:
        //    Arguments to initialize the DocPickerLauncher with. (optional)
        constructor: function(/*function*/ p_onConfirmCallbackFn, /*function?*/ p_onCloseCallbackFn, /*object?*/ p_args)
        {
            if (typeof p_onConfirmCallbackFn == 'function')
            {
                this._onConfirmCallbackFn = p_onConfirmCallbackFn;
            }
        
            if (typeof p_onCloseCallbackFn == 'function')
            {
                this._onCloseCallbackFn = p_onCloseCallbackFn;
            }
            
            this._evalArgs(p_args);
            
            this._loadPrereqs();
        },
        
        // summary:
        //    Launches the document picker.
        launchDocumentPicker: function()
        {
            var insertLinkAction;
            // explicitly bind 'inst' to 'this' because this will be bound to the JS global object when the anonymous fn for the onItemSelected event gets called
            inst = this;
            if (this._downloadTypes.length > 0 && this._viewTypes.length > 0)            
            {
                this._linkType = 'any';
            
                var viewLinkAction = {
                    displayText: this._nlsStrings.menuItemViewLink,
                    onClick: function(p_dialog) { inst._confirmSelection(p_dialog, 'view') }, 
                    onItemSelected: function(p_button, p_dialog, p_picker) { inst._onItemSelected(p_button, p_dialog, p_picker) }
                };

                var downloadLinkAction = {
                    displayText: this._nlsStrings.menuItemDownloadLink,
                    onClick: function(p_dialog) { inst._confirmSelection(p_dialog, 'download') }, 
                    onItemSelected: function(p_button, p_dialog, p_picker) { inst._onItemSelected(p_button, p_dialog, p_picker) }
                };

                insertLinkAction = {
                    displayType: 'menubutton',
                    displayText: this._nlsStrings.menuInsertLink, 
                    menuItems: [ viewLinkAction, downloadLinkAction ]
                };
            }
            else
            {
                if (this._downloadTypes.length > 0)
                {
                    this._linkType = 'download';
                }
                else if (this._viewTypes.length > 0)
                {
                    this._linkType = 'view';
                }
            
                if (this._linkType) {
                    insertLinkAction = { 
                        displayType: 'button', 
                        displayText: this._nlsStrings.buttonOk,
                        onClick: function(p_dialog) { inst._confirmSelection(p_dialog, inst._linkType) }, 
                        onItemSelected: function(p_button, p_dialog, p_picker) { inst._onItemSelected(p_button, p_dialog, p_picker) } 
                    };
                }
            }
            
            var cancelAction = quickr.picker.widgets.PickerDialog.getCancelAction();

            var actions;
            if (typeof insertLinkAction != 'undefined')
            {
                actions = [insertLinkAction, cancelAction];
            } 
            else
            {
                actions = [cancelAction];
            }
            
            var filters = { 
                filterAttribute: "category"
            };
            
            if (this._nodeTypes.length == 0)
            {
                filters.place = [new quickr.picker.data.filter.PlaceSelector()];
                filters.library = [new quickr.picker.data.filter.LibrarySelector()];
                filters.folder = [new quickr.picker.data.filter.FolderSelector()];
                filters.doclink = [new quickr.picker.data.filter.DocLinkSelector()];
                filters.document = [new quickr.picker.data.filter.DocumentSelector()];
            }
            else
            {
                for (i = 0; i < this._nodeTypes.length; i++)
                {
                    var nodeType = this._nodeTypes[i];
                    var selector = this._nodeType2Selector[nodeType];
                    if (typeof selector == 'string')
                    {
                        filters[nodeType] = eval("[" + selector + "]");
                    }
                }
            }
            
            var args = {
                title: this._nlsStrings[this._dialogTitleKey],
                filters: filters,
                isBrowseLocalOnly: false,
                showSummary: this._showNodePath,
                showPlaces: this._showPlaces,
                isMovable: this._isMovable,
                actions: actions,
                forceSSO: this._forceSSO,
                allowCustomServers: this._allowCustomServers,
                allowedHosts: this._allowedHosts,
                cookieName: this._cookieName,
                lastHostCookie: this._lastHostCookie,
				proxyUrl: this._proxyUrl,
                pageSize: this._pageSize,
                timeout: this._timeout,
                useInternalProxy: false
            };

            var pickerDialog = new quickr.picker.widgets.PickerDialog(args);

            // make sure to get notified when the document picker dialog is closed
            this._onCloseHdl = dojo.connect(pickerDialog, "hide", this, "_onClose");
            
            pickerDialog.show();
        },
        
        // summary:
        //    Notifies the caller of DocPickerLauncher about the closing of the document picker dialog by calling the corresponding callback function.
        _onClose: function()
        {
            if (this._onCloseHdl)
            {
                dojo.disconnect(this._onCloseHdl);
            }
            this._onCloseHdl = null;
            this._currentItem = null;
            if (this._onCloseCallbackFn)
            {
                this._onCloseCallbackFn();
            }
        },
        
        // summary:
        //    Completes an item selection operation and closes the document picker dialog. Executes the client callback function providing the title and the URL of the selected node.
        // p_dialog:
        //    Current instance of PickerDialog.
        // p_linkType:
        //    Determines which type of URL to pass on to the client callback function - either 'view' or 'download' (default). (optional)
        _confirmSelection: function(/*object*/ p_dialog, /*string?*/ p_linkType)
        {
            if (this._currentItem)
            {
                var url;
                if (p_linkType == 'view')
                {
                    url = this._currentItem.viewUrl;
                }
                else
                {
                    url = this._currentItem.downloadUrl;
                }
                
                if (this._onConfirmCallbackFn)
                {
                    this._onConfirmCallbackFn(this._currentItem.title, url);
                }
            }
            p_dialog.hide();
            p_dialog.destroy();
        },

        // summary:
        //    Upon selecting an item, disables or enables the button(s) used to confirm a selection in dependence of the type of the selected item.
        // p_button:
        //    Current link, button, or menu item that receives the onItemSelected event.
        // p_dialog:
        //    Current instance of PickerDialog.
        // p_picker:
        //    Current instance of DocumentPicker.
        _onItemSelected: function(/*object*/ p_button, /*object*/ p_dialog, /*object*/ p_picker)
        {
            var item = p_picker.getCurrentItem();
            var title = p_picker.store.getLabel(item);
            var path = p_picker.store.getPath(item);
            var category = p_picker.store.getValue(item, "category");
            var downloadUrl = p_picker.store.getValue(item, "downloadurl");
            var viewUrl = p_picker.store.getValue(item, "viewurl");

            this._currentItem = {
                title: title,
                path: path,
                category: category[0],
                downloadUrl: downloadUrl,
                viewUrl: viewUrl
            };
        
            var enableButton = true;
            if (this._linkType == 'view' || (this._linkType == 'any' && p_button.label == this._nlsStrings.menuItemViewLink))
            {
                enableButton = this._containsString(this._viewTypes, category[0]);
            }
            else if (this._linkType == 'download' || (this._linkType == 'any' && p_button.label == this._nlsStrings.menuItemDownloadLink))
            {
                enableButton = this._containsString(this._downloadTypes, category[0]);
            }

            p_button.setDisabled(!enableButton);
        },
        
        // summary:
        //    Evaluates the arguments passed in and initializes the DocPickerLauncher instance accordingly.
        // p_args:
        //    Arguments to initialize the DocPickerLauncher with. (optional)
        _evalArgs: function(/*object?*/ p_args)
        {
            if (typeof p_args != "undefined" && p_args)
            {
                if (typeof p_args.dialogTitleKey == 'string')
                {
                    this._dialogTitleKey = p_args.dialogTitleKey;
                }
                
                if (typeof p_args.locale == 'string')
                {
                    this._locale = p_args.locale;
                }
                else
                {
                    this._locale = dojo.config.locale;
                }
                
                if (typeof p_args.showPlaces == 'boolean')
                {
                    this._showPlaces = p_args.showPlaces;
                }
                
                if (typeof p_args.showNodePath == 'boolean')
                {
                    this._showNodePath = p_args.showNodePath;
                }
                
                if (typeof p_args.nodeTypes == 'object' && p_args.nodeTypes)
                {
                    this._nodeTypes = p_args.nodeTypes;
                }
                
                if (typeof p_args.downloadTypes == 'object' && p_args.downloadTypes)
                {
                    this._downloadTypes = p_args.downloadTypes;
                }
                
                if (typeof p_args.viewTypes == 'object' && p_args.viewTypes)
                {
                    this._viewTypes = p_args.viewTypes;
                }
                
                if (typeof p_args.forceSSO == 'boolean')
                {
                    this._forceSSO = p_args.forceSSO;
                }
                
                if (typeof p_args.isMovable == 'boolean')
                {
                    this._isMovable = p_args.isMovable;
                }
                
                if (typeof p_args.allowCustomServers == 'boolean')
                {
                    this._allowCustomServers = p_args.allowCustomServers;
                }
            
                if (typeof p_args.allowedHosts == 'object' && p_args.allowedHosts)
                {
                    this._allowedHosts = p_args.allowedHosts;
                }
                
                if (typeof p_args.cookieName == 'string')
                {
                    this._cookieName = p_args.cookieName;
                }
                
 				if (typeof p_args.proxyUrl == 'string')
                {
                    this._proxyUrl = p_args.proxyUrl;
                }
                
                if (typeof p_args.lastHostCookie == 'string')
                {
                    this._lastHostCookie = p_args.lastHostCookie;
                }
                
                if (typeof p_args.pageSize == 'integer')
                {
                    this._pageSize = p_args.pageSize;
                }
                
                if (typeof p_args.timeout == 'integer')
                {
                    this._timeout = p_args.timeout;
                }
            }
        },
        
        
        // summary:
        //    Dynamically loads any pre-requisite Dojo or other Javascript components required by DocPickerLauncher.
        _loadPrereqs: function()
        {
            dojo.require('dojo.i18n');
            dojo.requireLocalization('com.ibm.workplace.wcm.ecm.quickr.picker.launcher', 'DocPickerLauncher', this._locale, "", "");
            this._nlsStrings = dojo.i18n.getLocalization('com.ibm.workplace.wcm.ecm.quickr.picker.launcher', 'DocPickerLauncher');
			//dojo.config.styleUrl = '/wps/themes/html/css';
        },
        
        // summary:
        //    Checks whether p_array contains p_string.
        // p_array:
        //    The string array to search in for p_string.
        // p_string:
        //    The string to search for in p_array.
        // return:
        //    A boolean to indicate whether p_string is found in p_array.
        _containsString: function(/*object*/ p_array, /*string*/ p_string)
        {
            if ((typeof p_array == 'object') && (p_array != null) && (typeof p_string == 'string'))
            {
                for (i = 0; i < p_array.length; i++)
                {
                    if (p_array[i] == p_string)
                    {
                        return true;
                    }
                }
            }
            return false;
        }
    });

}
