#! /bin/sh
#  Licensed Materials - Property of IBM
#  5724-M24
#  (C) Copyright IBM Corporation 2009. All Rights Reserved.
#  US Government Users Restricted Rights- Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

# The shell script to start the PDF Report Server

# The port number to be used to establish a connection between Alphablox Analytics and the PDF Report Server
LISTEN_PORT=8178

# Path to the specified jars in the classpath can be found
LIB="[washome]/Alphablox/lib"

# Path and file to start Java
JAVA="[washome]/java/bin/java"

# Initial and maximum heap memory sizes
HEAP="-Xms64M -Xmx256M"

# Set the CLASSPATH variable
CLASSPATH="${LIB}/pdfserver.jar:${LIB}/bforeport.jar:${LIB}/xercesImpl.jar:${LIB}/xml-apis.jar:${LIB}/xalan.jar:${LIB}/icu4j-3_6.jar"

# Move to the directory that includes the DB2 Alphablox repository directory
# If you copy the repository folder into this folder (AlphabloxPDFRemote), remove the "cd.." below.
cd ..

# Start the PDF Report Server
${JAVA} ${HEAP} -classpath ${CLASSPATH} com.alphablox.printprocessor.remote.PDFReportServer ${LISTEN_PORT}

