/*
 *    Copyright  2002 Alphablox, Inc. All rights reserved.
 */
var beanName = "commentsAdminBean";

function openHelp(height,width)
{
  var url = "/AlphabloxServer/help/admin/admin/server/commentsManagementHelp.html";
  var windowName = "commentsManagementWindow";
  var top = (screen.height / 2) - (height / 2) - 100;
  var left = (screen.width / 2) - (width / 2);
  var features = "Height=" + height + ",Width=" + width + ",top=" + top + ",left=" + left + ",scrollbars=yes,resizable=yes,location=yes,toolbar=yes";
  fWindow = window.open(url, windowName, features);
  setTimeout("focusWindow();", 200);

}

function focusWindow()
{
    if (fWindow)
        fWindow.focus();
}

function setStatus( str ) {
	top.status = str;
	return true;
}

function changeRdbDataSource() {
	var dsnSelect = document.theForm.dsnSelect;
	document.theForm.username.value = "";
	document.theForm.password.value = "";
	document.theForm.commentsCollectionName.options.length = 0;
	document.getElementById("rightColumn").innerHTML = "";

    var connectButton = document.getElementById("tableConnect");
	if (connectButton && dsnSelect.selectedIndex != 0) {
        connectButton.className = "TableButtonEnabled";
	} else if (connectButton) {
        connectButton.className = "TableButtonDisabled";
	}

	enableButtons(false);
}

// Talk to the server in order to connect to the data source and
// fetch all the collection names in this data source.
function connectToDataSource() {
    var dsnSelect = document.theForm.dsnSelect;
	var collectionNames = document.theForm.commentsCollectionName;

    // Empty collection names and put in all the new ones.
    collectionNames.options.length = 0;

    if (dsnSelect.selectedIndex != 0) {
		// Call getAllCollectionNames() on the server.
		var url = "rmi.jsp?bean=" + beanName +
			"&method=getAllCollectionNames" +
			"&dataSourceName=" + encodeURIComponent(dsnSelect.options[ dsnSelect.selectedIndex ].value) +
			"&username=" + encodeURIComponent(document.theForm.username.value) +
			"&password=" + encodeURIComponent(document.theForm.password.value);

		var resultString = talkToServer( url );

		if (showErrorMessage(resultString)) {
		    enableButtons(false);
			return;
	    }

		// Expect something like this: new Array( new Array("name", true));
		// 	 result[i][0] is the name/value of the option
		// 	 result[i][1] is the selected value
		var result = eval( resultString );

		for (var i=0; i<result.length; i++) {
			collectionNames.options[i] = new Option( result[i][0], result[i][0], result[i][1], result[i][1] );
		}

		enableButtons(true);
	}
}

// Enable or disable the create, edit and delete buttons.
function enableButtons(doEnable) {
    var suffixString = "Enabled.gif";

    if (!doEnable) {
        suffixString = "Disabled.gif";
    }
/*
    document.getElementById("createButton").src = "images/Create" + suffixString;
    document.getElementById("editButton").src = "images/Edit" + suffixString;
    document.getElementById("deleteButton").src = "images/Delete" + suffixString;
*/
    var createLink = document.getElementById("createLink");
    var editLink = document.getElementById("editLink");
    var deleteLink = document.getElementById("deleteLink");

    if (doEnable) {
        createLink.href="javascript: newCollection();";
        editLink.href="javascript: editCollection();";
        deleteLink.href="javascript: deleteCollection();";

        createLink.className = "TableButtonLinkEnabled";
        editLink.className = "TableButtonLinkEnabled";
        deleteLink.className = "TableButtonLinkEnabled";

        document.getElementById("tableCreate").className = "TableButtonEnabled";
        document.getElementById("tableEdit").className = "TableButtonEnabled";
        document.getElementById("tableDelete").className = "TableButtonEnabled";
    }
    else {
        createLink.href="javascript:void(0);";
        editLink.href="javascript:void(0);";
        deleteLink.href="javascript:void(0);";

        createLink.className = "TableButtonLinkDisabled";
        editLink.className = "TableButtonLinkDisabled";
        deleteLink.className = "TableButtonLinkDisabled";

        document.getElementById("tableCreate").className = "TableButtonDisabled";
        document.getElementById("tableEdit").className = "TableButtonDisabled";
        document.getElementById("tableDelete").className = "TableButtonDisabled";
    }

}

// Edit details for the current collection.
function editCollection() {
    var cbIndex = document.theForm.commentsCollectionName.selectedIndex;

	if (cbIndex >=0) {
	    var cbName = document.theForm.commentsCollectionName.options[ cbIndex ].value;

    	// encode unicode strings. these need to be decoded on the server
    	var url = "editCollection.jsp?&collectionName=" + encodeURIComponent(cbName);

		// In the right hand panel, load up the editCollection JSP
	    document.getElementById("rightColumn").innerHTML = talkToServer( url );

	    setFieldsArray();

	    setExistingDimensions();
	}
}

// Display the form to create a new collection
function newCollection() {
    var url = "newCollection.jsp";

	// In the right hand panel, load up the newCollection JSP
    document.getElementById("rightColumn").innerHTML = talkToServer( url );

	// Unselect any existing collection
	document.theForm.commentsCollectionName.selectedIndex = -1;

    resetFieldsArray();

    setExistingDimensions();
}

function resetFieldsArray() {
    fields.length=0;
    fields[0]=new Array();
    fields[0][0]="Author";
    fields[0][1]="";
    fields[1]=new Array();
    fields[1][0]="Timestamp";
    fields[1][1]="";
    fields[2]=new Array();
    fields[2][0]="CommentText";
    fields[2][1]="";

}

function setFieldsArray() {
    var fieldsTable = document.getElementById("fieldsTable");

    resetFieldsArray();

    // we skip the header row
    for (var index=1; index < fieldsTable.rows.length; index++) {
        var trs=fieldsTable.getElementsByTagName("tr");

        fields[index-1] = new Array();  

	if(trs[index].cells[1].firstChild != null)
	    fields[index-1][0] = trs[index].cells[1].firstChild.nodeValue;
	else
	    fields[index-1][0] = "";

	if(trs[index].cells[2].firstChild != null)
	    fields[index-1][1] = trs[index].cells[2].firstChild.nodeValue;
	else
	    fields[index-1][1] = "";
    }
}

// Delete the currently selected collection
function deleteCollection() {
    var cbIndex = document.theForm.commentsCollectionName.selectedIndex;
    var cbName = document.theForm.commentsCollectionName.options[ cbIndex ].value;

    if (!confirm("Continue with the deletion of comments collection "+cbName+"?"))
        return;

    // encode unicode collection names. these need to be decoded on the server
    var url = "rmi.jsp?&bean=" + beanName +
		"&method=deleteCollection" +
		"&collectionName=" + encodeURIComponent(cbName);

	var result = talkToServer( url );

	// Empty the right hand panel.
    document.getElementById("rightColumn").innerHTML = "";

	// Repopulate the collectionNames box.
	connectToDataSource();
}

function cancelNewCollection() {
	// Empty the right hand panel.
    document.getElementById("rightColumn").innerHTML = "";
}

/*****************
 *
 * Methods used to create a new collection.
 *
 *****************/
var fields = new Array();
var dimensions;
var existingDimensions=new Array();
var cubeNames;

// Called when the Save button is clicked. Calls to the server
// to save this collection.
function saveNewCollection() {
    saveCollection("saveNewCollection");
}

function saveExistingCollection() {
    saveCollection("saveExistingCollection");
}

function isAcceptable(s) {
	var acceptableChars = "abcdefghijklmnopqrstuvwxyz0123456789_";
  	s = s.toLowerCase();
   	for ( var i=s.length-1; i>=0; i-- ) {
   		if ( acceptableChars.indexOf(s.charAt(i))==-1 ) {
       			return false;
		}
   	}
  	return true;
}


function saveCollection(method) {
	var collectionName = document.getElementById("_collectionName").value;
	var dimSelect = document.getElementById("mdbDimensions");

	if (collectionName == "") {
		alert("You must set the name of the collection");
		return;
	}

    // This is done in a better way on the server. And we can no longer only allow
    // A-Z and numbers, since we need to be able to support unicode names.
//	if(!isAcceptable(collectionName)) {
//		alert("Collection name "+collectionName+" is invalid. It must contain alphanumeric characters or '_'.");
//		return;
//	}

	var saveUrl = "rmi.jsp?method="+method +
			"&bean=" + beanName +
			"&collectionName=" + encodeURIComponent(collectionName);


	for (i=0; i<fields.length; i++) {

	    if (fields[i][0].length > 0) {
		    saveUrl += "&fieldNames=" + encodeURIComponent(fields[i][0]);
		    saveUrl += "&fieldDescrs=" + encodeURIComponent(fields[i][1]);
		}
	}

	var emptyDimensions = "true";

	if (dimSelect != null) {
        for (j=0; j<dimSelect.options.length; j++) {
            if (dimSelect.options[j].selected)
	    {
                saveUrl += "&dimensions=" + encodeURIComponent(dimSelect.options[j].value);
		emptyDimensions = "false";
            }
        }
	}

	if(emptyDimensions == "true")
        {
	    if (!confirm("Comments Collection created with no dimension cannot be used with DataBlox, Continue?"))
	        return;
        }

	// encode the url since it contains unicode collection names
	var resultString = talkToServer( saveUrl );

    if (showErrorMessage(resultString)) {
        return;
    }

	// Repopulate the collection names box.
	connectToDataSource();

	// Edit the collection.
	editCollection();

	alert("Comments collection "+collectionName+" has been saved.");
}

// Called when the "+" button is clicked.
function addField() {
    addNamedField("","",true);
    return;


}

// Called when the "+" button is clicked.
function addNamedField(name, description, editable) {
    var fieldsTable = document.getElementById("fieldsTable");

	// I can't use innerHTML on a select box, so instead, I do it the DOM way.
	elmTbody = fieldsTable.tBodies[0];

	elmTr = document.createElement( "tr" );

	elmTdDelete = document.createElement( "td" );
	elmTdDelete.className = "TableFieldValue";
	elmTdDelete.style.textAlign = "center";
	elmTdDelete.innerHTML = "<label title='delete" +fields.length+ "'>" + "<input type='checkbox' id='delete"+fields.length+"'>" + "</label>";

	elmTdName = document.createElement( "td" );
	elmTdName.className = "TableFieldValue";
	elmTdName.setAttribute("fieldProperty", "0");
	elmTdName.setAttribute("fieldIndex", fields.length);
	elmTdName.innerHTML = name;

	elmTdDescr = document.createElement( "td" );
	elmTdDescr.className = "TableFieldValue";
	elmTdDescr.setAttribute("fieldProperty", "1");
	elmTdDescr.setAttribute("fieldIndex", fields.length);
	elmTdDescr.innerHTML = description;

    if (editable) {
        var nameFieldInput = document.createElement( "input" );
	nameFieldInput.setAttribute("type", "text");
	nameFieldInput.setAttribute("id", "newName"+ (fields.length));
	nameFieldInput.className = "TableFieldInput";
	nameFieldInput.setAttribute("value", "Click to set name");
	elmTdName.appendChild(nameFieldInput);

        var DscptFieldInput = document.createElement( "input" );
	DscptFieldInput.setAttribute("type", "text");
	DscptFieldInput.setAttribute("id", "newDescription"+(fields.length));
	DscptFieldInput.className = "TableFieldInput";
	DscptFieldInput.setAttribute("value", "Click to set Description");
	elmTdDescr.appendChild(DscptFieldInput);

	setElementEventHandler(nameFieldInput);
	setElementEventHandler(DscptFieldInput);
    }

	elmTr.appendChild( elmTdDelete );
	elmTr.appendChild( elmTdName );
	elmTr.appendChild( elmTdDescr );
	elmTbody.appendChild( elmTr );

	// add new elements to JavaScript array
	fields[ fields.length ] = new Array();
	fields[ fields.length-1 ][0] = name;
	fields[ fields.length-1 ][1] = description;

}

function addCellValueField() {
    for (var x=0; x<fields.length; x++) {
        if (fields[x][0] == "CellValue")
            return;
    }
    addNamedField("CellValue","");
}

function alertFieldsTable() {
    var fieldsTable = document.getElementById("fieldsTable");
    var currentFields="";
    var trs=fieldsTable.getElementsByTagName("TR");

    for (var index=0; index < fields.length; index++) {
        var rowIndex=index+1;
        var checkbox=document.getElementById("delete"+index);
        currentFields=currentFields+" Field "+index+" "+trs(rowIndex).cells(1).innerText+" "+trs(rowIndex).cells(1).getAttribute("fieldIndex");
        currentFields+=" "+((checkbox != null && checkbox.checked) ? "DELETE" : "");
        currentFields+=" "+((checkbox != null) ? checkbox.getAttribute("id") : "NoCheckbox");
        currentFields+="\r\n";
    }
    alert(currentFields);
}

// Called when the "-" is clicked. Will simply remove the last
// row in the fields table (except for the default fields)
function removeFields() {
    var fieldsTable = document.getElementById("fieldsTable");
    var fieldsToDelete=new Array();

    // we skip the header row
    for (var index=0; index < fields.length; index++) {
        var checkbox=document.getElementById("delete"+index);

        if (checkbox != null && checkbox.checked)
            fieldsToDelete[fieldsToDelete.length]=index;
    }

    for (var index=fieldsToDelete.length-1; index>=0; index--)
        fieldsTable.deleteRow(fieldsToDelete[index]+1); // plus one for the header

    // we need to reset the fieldIndex values with new row numbers
    var trs=fieldsTable.getElementsByTagName("TR");
    for (var index=1; index < fieldsTable.rows.length; index++) {
        var fieldIndex=index-1;

        var checkbox=trs[index].cells[0].getElementsByTagName("checkbox");

        if (checkbox.length != 0)
            checkbox[0].setAttribute("id","delete"+fieldIndex);

        trs[index].cells[1].setAttribute("fieldIndex",fieldIndex);
        trs[index].cells[2].setAttribute("fieldIndex",fieldIndex);
    }

	setFieldsArray();
}

// User sets the field name or description. We save it to our array.
function onFieldChanged(fieldIndex, fieldProperty, value) {
	fields[fieldIndex][fieldProperty] = value;
}

function changeMdbDataSource() {
	var dsnSelect = document.getElementById("dsnMdbSelect");

    document.theForm.mdbUsername.value = "";
    document.theForm.mdbPassword.value = "";

    cubeNames = null
    dimensions = null;
    hideCubeNames();
    populateDimensionBox( dimensions );

    var connectButton = document.getElementById("tableMdbConnect");
    if (connectButton && dsnSelect.selectedIndex != 0) {
        connectButton.className = "TableButtonEnabled";
    } else if (connectButton) {
        connectButton.className = "TableButtonDisabled";
    }
}

// Call to the server to show all the available dimensions for the
// selected MDB (hopefully) data source.
function connectToMdbDataSource() {
	var dsnSelect = document.getElementById("dsnMdbSelect");

	if (dsnSelect.selectedIndex > 0) {
		var dsn = dsnSelect.options[ dsnSelect.selectedIndex ].value;

		var url = "rmi.jsp?method=getCubeNamesAndDimensions" +
				"&bean=" + beanName +
				"&mdbDataSourceName=" + encodeURIComponent(dsn) +
                "&username=" + encodeURIComponent(document.theForm.mdbUsername.value) +
                "&password=" + encodeURIComponent(document.theForm.mdbPassword.value);

		var resultString = talkToServer( url );
		if (showErrorMessage(resultString)) {
			cubeNames = null;
			dimensions = null;

			// Hide everything
			hideCubeNames();
			populateDimensionBox(dimensions);
			return;
		}

		// Expect something like
		//     new Array("cubeName1", "cubeName2"); new Array( new Array("dim1", "dim2"));
		// Split at ";" to get the cubenames and the dimensions for each.
		var cubeResult = resultString.substring( 0, resultString.indexOf(";")+1 );
		var dimensionResult = resultString.slice( resultString.indexOf(";")+1 );

		cubeNames = eval( cubeResult );
		dimensions = eval( dimensionResult );

		if (cubeNames.length > 1) {
			showCubeNames( cubeNames );
			populateDimensionBox( null );
		} else {
			hideCubeNames();
			populateDimensionBox( dimensions[0] );
		}
	}
}

function hideCubeNames() {
	var mdbTable = document.getElementById("mdbDataSourceTable");
	elmTbody = mdbTable.tBodies[0];

	// Remove the last row:
	if (document.getElementById("mdbCubeNames")) {
		elmTbody.removeChild( elmTbody.lastChild );
	}
}

function showCubeNames() {
    // If there were cube names before, we need to remove them first.
    hideCubeNames();

	var mdbTable = document.getElementById("mdbDataSourceTable");
	// I can't use innerHTML on a select box, so instead, I do it the DOM way.
	elmTbody = mdbTable.tBodies[0];

	elmTr = document.createElement( "tr" );
	elmTr.id = "mdbCubeNames";

	elmTdName = document.createElement( "td" );
	elmTdName.className = "TableFieldValue";
	elmTdName.innerHTML = "<b>Cube Name:</b>";
    elmTdName.style.paddingTop = "20px";

	elmTdSelect = document.createElement( "td" );
	elmTdSelect.className = "TableFieldValue";
    elmTdSelect.style.paddingTop = "20px";

	// build cube select box:
	var cubeSelect = "<select id=\"cubeNames\" name=\"cubeNames\" onChange=\"changeCubeName();\">";

	cubeSelect += "<option selected>Select a cube...</option>";

	for (var i=0; i<cubeNames.length; i++) {
		cubeSelect += "<option value=\"" + cubeNames[i] + "\">";
		cubeSelect += cubeNames[i];
		cubeSelect += "</option>";
	}
	cubeSelect += "</select>";

	elmTdSelect.innerHTML = cubeSelect;

	elmTr.appendChild( elmTdName );
	elmTr.appendChild( elmTdSelect );
	elmTbody.appendChild( elmTr );  // Make this the last row
}

function changeCubeName() {
	var cubeSelect = document.theForm.cubeNames;

	if (cubeSelect.selectedIndex > 0) {
		populateDimensionBox( dimensions[cubeSelect.selectedIndex-1] );
	} else {
        populateDimensionBox( null );
	}
}

function populateDimensionBox( dimArray ) {
	var dimSelect = document.getElementById("mdbDimensions");

    dimSelect.options.length = 0;
	if (dimArray != null) {
		for (i=0; i<dimArray.length; i++) {
		    var selected=contains(dimArray[i], existingDimensions);
			dimSelect.options[i] = new Option(dimArray[i], dimArray[i], selected, selected);
		}
	}
}

function setExistingDimensions() {
	var dimSelect = document.getElementById("mdbDimensions");

    existingDimensions.length=0;

	if (dimSelect != null) {
		for (i=0; i<dimSelect.options.length; i++) {
		    if (dimSelect.options[i].selected)
                existingDimensions[existingDimensions.length]=dimSelect.options[i].value;
		}
	}

}

function contains(name, array) {
    for (var x=0; x<array.length; x++) {
        if (array[x] == name)
            return true;
    }
    return false;
}

// Checks what is returned from the server for any
// error messages.
var errorMessage;
var detailedErrorMessage;
function showErrorMessage(message) {
	if (message.indexOf("Error") != -1) {
		var errorStart = message.indexOf("Error:") + 6;
		var errorEnd = message.indexOf("Details:");
		var detailStart = errorEnd + 8;
		errorMessage = message.substring(errorStart, errorEnd);
		detailedErrorMessage = message.substring(detailStart, message.length);

		var errorUrl = "errorPage.jsp";
		window.open(errorUrl, "errorWindow", "height=100,width=640,resizable");
		return true;
	}

	return false;
}

// Use this method to make a call to the server.
function talkToServer(url) {
   var xmlhttp = bloxHttp._xmlHttp;
   xmlhttp.open("GET", url, false);
   xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
   xmlhttp.send(null);
   return xmlhttp.responseText;
}

function setElementEventHandler(eventElement)
{
	var index = navigator.userAgent.indexOf( "MSIE" );
	if(index != -1)
	{
	    eventElement.onmouseup = edit;
	    eventElement.onmouseover = highlight;
	    eventElement.onmouseout =  restore;
	    eventElement.onblur = save;
	}
	else
	{
	    eventElement.onmouseup = new Function("event", "editFF(event);");
	    eventElement.onmouseover = new Function("event", "highlightFF(event);");
	    eventElement.onmouseout = new Function("event", "restoreFF(event);");
	    eventElement.onblur = new Function("event", "saveFF(event);");
        }
}

function highlight(){
	 var editbox = event.srcElement;
	 editbox.className = "TableFieldInputHighlight";
}

function restore(){
	var editbox = event.srcElement;
	editbox.className = "TableFieldInput";
}
      
function edit()
{
	var editbox = event.srcElement;
	editbox.select();
}
   
function save(){
	var editbox = event.srcElement
	var cell = editbox.parentNode;
	
	onFieldChanged(cell.fieldIndex, cell.fieldProperty, editbox.value);
}

function highlightFF(event){
	 var editbox = event.target;
	 editbox.className = "TableFieldInputHighlight";
}

function restoreFF(event){
	var editbox = event.target;
	editbox.className = "TableFieldInput";
}
      
function editFF(event)
{
	var editbox = event.target;
	editbox.select();
}
   
function saveFF(event){
	var editbox = event.target
	var cell = editbox.parentNode;
	
	onFieldChanged(cell.getAttribute("fieldIndex"), cell.getAttribute("fieldProperty"), editbox.value);
}
