<%@ page contentType="text/html; charset=UTF-8" %>
<!--
    Copyright  2002 Alphablox, Inc. All rights reserved.
-->
<%@ page import="com.alphablox.blox.comments.CommentsAdmin,
                 com.alphablox.blox.repository.DataSource,
                 java.util.Vector,
                 com.alphablox.resource.AlphaBlox,
                 com.alphablox.net.URLFactory,
                 java.util.Collections,
                 com.alphablox.server.bloxcontext.BloxContextImpl,
                 com.alphablox.blox.BloxContextFactory,
                 com.alphablox.blox.BloxRequest,
                 com.alphablox.blox.BloxResponse,
                 java.util.Locale"%>
<%@ taglib uri="bloxtld" prefix="blox" %>

<jsp:useBean id="adminBlox" class="com.alphablox.blox.AdminBlox" scope="session" />
<%
    // Get a list of RDB data sources.
    DataSource[] dataSources = adminBlox.getDataSources();
    Vector rdbDataSources = new Vector();

    for (int idx = 0; idx < dataSources.length; idx++) {
        if (!dataSources[idx].isMDB())
            rdbDataSources.add( dataSources[idx].getName() );
    }
    Collections.sort(rdbDataSources);
%>

<jsp:useBean id="commentsAdminBean" class="com.alphablox.blox.comments.CommentsAdmin" scope="session" />
<%
    String commentsCollectionName = CommentsAdmin.stringToValue( request.getParameter("commentsCollectionName") );
    commentsAdminBean.setCurrentCollectionName(commentsCollectionName);

    URLFactory url = URLFactory.getServerContext( "jslib/BloxHttp.js" );
%>
<%
    final Locale[] english = new Locale[] {Locale.ENGLISH};
%>

<html>
<head>
    <SCRIPT LANGUAGE="javascript" src="<%= url.toString() %>"></SCRIPT>
    <link href="styles.css" rel="stylesheet" type="text/css">
    <script>var urlPrefix = "<%= URLFactory.getURLPrefix()%>";</script>
    <script src="commentsAdmin.js" language="JavaScript"></script>
</head>

<body class="default" onLoad="enableButtons(<%= commentsAdminBean.isConnected() %>)" >

<!-- Logo and help buttons -->
<table width="575" border="0" cellpadding="0" cellspacing="0">
    <tr>
        <td align="left"><img src="<%= URLFactory.getAdminURL( "/home/i/small-logo.gif")%>"></td>
        <td align="right"><a href="javascript:openHelp(400,400);" class="HelpMenu">Help</a></td>
    </tr>
</table>

<form name="theForm" action="commentsAdmin.jsp" method="post">

<!-- Bar across the top -->
<table width="625" border="0" cellpadding="0" cellspacing="0">
    <tr>
        <td width="475" class="Title">&nbsp;<%= AlphaBlox.getLocalizedString(english, AlphaBlox.COMMENTS_ADMIN_MANAGEMENT)%>&nbsp;</td>
        <td width="125" class="Title" align="right" valign="middle">
        <!-- <a href="javascript:closeButton();"><img src="/AlphabloxAdmin/home/i/button-close.gif" width="60" height="20" border="0" align="middle"></a>&nbsp; -->
        </td>
    </tr>
    <tr><td class="Border" colspan="2">&nbsp;</td></tr>
    <tr><td class="BorderNoColor">&nbsp;</td></tr>
</table>

<!-- Body of the whole doc -->
<table width="625" border="0" cellpadding="0" cellspacing="0">
<tr rowspan="11">
   <td class="CommentsBackground" align="center" VALIGN="top">
    <table height="100%" width="250">
        <tr><td colspan="2"><br /></td></tr> <!-- spacer -->
        <tr>
            <td class="LabelsText" colspan="2"><%= AlphaBlox.getLocalizedString(english, AlphaBlox.COMMENTS_ADMIN_DATASOURCE)%>:</td>
        </tr>
        <tr>
            <td class="FormLabel"><label for="_dsnSelect"><%=AlphaBlox.getLocalizedString(english, AlphaBlox.COMMENTS_ADMIN_NAME)%>:</label></td>
            <td>
            <select id="_dsnSelect" name="dsnSelect" onChange="changeRdbDataSource();" taborder="1">
                <option <%= (commentsAdminBean.getRdbDataSourceName()==null) ? "selected" : ""%>>
                    <%= AlphaBlox.getLocalizedString(english, AlphaBlox.COMMENTS_ADMIN_SELECT_A_DATASOURCE) %>...</option>
                <%
                for(int i = 0; i < rdbDataSources.size(); i++) {
                    String dsName = (String) rdbDataSources.elementAt(i);
                    String selected = dsName.equals(commentsAdminBean.getRdbDataSourceName()) ? " selected" : "";
                %>
                    <option<%= selected %> value="<%= dsName %>"><%= dsName %></option>
                <% } %>
            </select>
            </td>
        </tr>
        <tr>
            <td class="FormLabel"><label for="_username"><%= AlphaBlox.getLocalizedString(english, AlphaBlox.COMMENTS_ADMIN_USERNAME)%>:</label></td>
            <td>
                <input type="text" style="width: 100%"  taborder="2" id="_username"
                    name="username" value="<%= CommentsAdmin.valueToString(commentsAdminBean.getUsername()) %>">
                </input>
            </td>
        </tr>
        <tr>
            <td class="FormLabel"><label for="_password"><%= AlphaBlox.getLocalizedString(english, AlphaBlox.COMMENTS_ADMIN_PASSWORD)%>:</label></td>
            <td>
                <input type="password"  style="width: 100%" taborder="3" id="_password"
                    name="password"value="<%= CommentsAdmin.valueToString(commentsAdminBean.getPassword()) %>">
                </input>
            </td>
        </tr>
        <tr>
            <!-- Connect Button -->
            <td colspan="2" align="center">

		  <!-- mini BLACK BUTTON TABLE -->
          <%
            String disabled = (!commentsAdminBean.isConnected() ? "true" : "false");
          %>
          <jsp:include page="button.jsp" flush="true">
                <jsp:param name="id" value="tableConnect"/>
                <jsp:param name="label" value="connect"/>
                <jsp:param name="href" value="javascript:connectToDataSource();"/>
                <jsp:param name="disabled" value="<%= disabled %>" />
          </jsp:include>

		  <!-- mini BLACK BUTTON TABLE -->

            </td>
        </tr>
	 </table>

     <table border="0" cellpadding="0" cellspacing="0" style="padding-left:4px;">
	   <tr><td class=LabelsText><label for="commentsCollectionName"><%= AlphaBlox.getLocalizedString(english, AlphaBlox.COMMENTS_ADMIN_COLLECTION)%>:</label></td></tr>
       <tr><td class=CommentsBackground align="center">
       <table border="0" cellpadding="0" cellspacing="0" >
         <tr> <!-- First Row--->
		   <td class=CommentsBackground align="center">
                <select id="commentsCollectionName" name="commentsCollectionName" size="16" style="width:250px;"
                        onDblClick="editCollection();" taborder="5">
                 <%
                     BloxContextImpl bloxContextImpl = (BloxContextImpl)BloxContextFactory.getBloxContext(request, response);
                     BloxRequest bloxRequest = bloxContextImpl.registerRequest(request, response);
                     BloxResponse bloxResponse = bloxRequest.getBloxResponse();
                     String collectionNamesAsOptions = commentsAdminBean.getCollectionNamesAsOptions(bloxRequest, bloxResponse);
                 %>
                <%= collectionNamesAsOptions %>
                </select>
	       </td>
   		   <td class="CommentsBackground" align="left" valign="top">
<!--
     			<table border="0" cellpadding="0" cellspacing="0" >
      				<tr><td class=CommentsBackground align="center">
	    				<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td><a href="javascript: upButton()">
  								<img src="/AlphabloxAdmin/home/i/button-up.gif" width="24" height="20" border="0"></a>
								</td>
							</tr>
            				<tr>
								<td><a href="javascript: downButton()">
  								<img src="/AlphabloxAdmin/home/i/button-down.gif" width="24" height="20" border="0"></a>
								</td>
							</tr>
						</table>
	   				</td></tr>
	 			</table>
 -->
			</td>
		 </tr>

       <tr> <!--- Second Row--->
        <td class=CommentsBackground align="center">
          <!-- Buttons -->
          <table border="0" cellpadding="4" cellspacing="4">
          <tr>
            <td>

		  <!-- mini BLACK BUTTON TABLE -->
          <jsp:include page="button.jsp" flush="true">
                <jsp:param name="id" value="tableCreate"/>
                <jsp:param name="linkId" value="createLink"/>
                <jsp:param name="label" value="create"/>
                <jsp:param name="href" value="javascript:void(0);"/>
          </jsp:include>

		  <!-- mini BLACK BUTTON TABLE -->

			</td>
            <td>

		  <!-- mini BLACK BUTTON TABLE -->
          <jsp:include page="button.jsp" flush="true">
                <jsp:param name="id" value="tableEdit"/>
                <jsp:param name="linkId" value="editLink"/>
                <jsp:param name="label" value="edit"/>
                <jsp:param name="href" value="javascript:void(0);"/>
          </jsp:include>

		  <!-- mini BLACK BUTTON TABLE -->

			</td>
          </tr>
          <tr>
            <td colspan="2" align="center">

		  <!-- mini BLACK BUTTON TABLE -->
          <jsp:include page="button.jsp" flush="true">
                <jsp:param name="id" value="tableDelete"/>
                <jsp:param name="linkId" value="deleteLink"/>
                <jsp:param name="label" value="delete"/>
                <jsp:param name="href" value="javascript:void(0);"/>
          </jsp:include>

		  <!-- mini BLACK BUTTON TABLE -->

			</td>
          </tr>
          </table>
         </td>
		<td class=CommentsBackground>&nbsp;</td>
       </tr>

	 </table>
	</td>

    <!-- End of left hand panel -->

    </tr>
    </table>
</td>
    <!-- Column for the details of a single comments collection -->
  <td id="rightColumn" name="rightColumn" class=Folder width="400">

    </td>
</tr>
</table>
</form>

</body>
</html>
