<%@ page contentType="text/html; charset=UTF-8" %>
<!--
    Copyright 2002 Alphablox, Inc. All rights reserved.
-->
<%@ page import="com.alphablox.blox.CommentsBlox,
                 com.alphablox.blox.comments.*,
                 java.util.Arrays,
                 com.alphablox.server.Server,
                 com.alphablox.resource.AlphaBlox,
                 com.alphablox.blox.repository.DataSource,
                 java.util.Vector,
                 java.util.Collections,
                 com.alphablox.util.ObjectComparator,
                 com.alphablox.blox.BloxContextFactory,
                 com.alphablox.blox.BloxContext,
                 com.alphablox.blox.BloxRequest,
                 java.util.Locale"%>
<%@ page import="com.alphablox.net.URLFactory"%>
<%@ taglib uri="bloxtld" prefix="blox" %>
<blox:bloxContext/>

<jsp:useBean id="adminBlox" class="com.alphablox.blox.AdminBlox" scope="session" />

<%
    final Locale[] english = new Locale[]{Locale.ENGLISH};
    CommentsAdmin commentsAdminBean = (CommentsAdmin) session.getAttribute("commentsAdminBean");

    String collectionName = CommentsAdmin.stringToValue( request.getParameter("collectionName") );
    commentsAdminBean.setCurrentCollectionName(collectionName);

    CommentsBlox commentsBlox = commentsAdminBean.openCommentsBlox(bloxRequest, bloxResponse);

    String[] dimensions = commentsBlox.getDimensions();
    String[] fieldNames = commentsBlox.getFieldNames();

    Arrays.sort(dimensions, ObjectComparator.getStringComparator(bloxContext.getLocale()));
    Arrays.sort(fieldNames, ObjectComparator.getStringComparator(bloxContext.getLocale()));

    // Get a list of MDB data sources
    DataSource[] dataSources = adminBlox.getDataSources();
    Vector mdbDataSources = new Vector();

    for (int idx = 0; idx < dataSources.length; idx++) {
        if (dataSources[idx].isMDB())
            mdbDataSources.add( dataSources[idx].getName() );
    }
    Collections.sort(mdbDataSources);
%>

    <table width="100%" height="100%">
    <!-- First section is collection name -->
    <tr>
        <td width="100%">
        <table id="_collectionNameTable" class="TableForFields" cellpadding="3" cellspacing="2" width="100%">
            <tr>
            <td class="TableFieldHeader">Name:</td>
            <td class="TableFieldValue"><%= commentsBlox.getCollectionName()%></td>
            </tr>
        </table>
        </td>
    </tr>

    <tr>
        <td width="100%">
        <table id="_collectionFields" class="TableForFields" cellpadding="3" width="100%">
            <tr>
            <td class="TableFieldHeader">Fields:</td>
            <td colspan="2">

          <!-- Plus and Minus Button -->
          <table border="0" >
          <tr>
            <td>

		  <!-- mini BLACK BUTTON TABLE -->
          <jsp:include page="button.jsp" flush="true">
                <jsp:param name="id" value="tablePlus"/>
                <jsp:param name="label" value="add"/>
                <jsp:param name="disabled" value="false" />
                <jsp:param name="href" value="javascript:addField();"/>
          </jsp:include>

		  <!-- mini BLACK BUTTON TABLE -->

			</td>
            <td>

		  <!-- mini BLACK BUTTON TABLE -->
		  <jsp:include page="button.jsp" flush="true">
                <jsp:param name="id" value="tableMinus"/>
                <jsp:param name="label" value="delete"/>
                <jsp:param name="disabled" value="false" />
                <jsp:param name="href" value="javascript:removeFields();"/>
          </jsp:include>

		  <!-- mini BLACK BUTTON TABLE -->

			</td>
          </tr>
		 </table>

                <!-- Inner table for the field names, etc. -->
                <table id="fieldsTable" name="fieldsTable" class="FieldsTable" width="100%">
				<thead>
                <tr>
                    <td class="TableFieldValue" style="font-weight:bold;text-align:center;">Select</td>
                    <td class="TableFieldValue" style="font-weight:bold;text-align:center;">Name</td>
                    <td class="TableFieldValue" style="font-weight:bold;text-align:center;">Description</td>
                </tr>
				</thead>
				<tbody>
                <tr>
                    <td class="TableFieldValue"></td>
                    <td class="TableFieldValue">Author</td>
                    <td class="TableFieldValue"></td>
                </tr>
                <tr>
                    <td class="TableFieldValue"></td>
                    <td class="TableFieldValue">Timestamp</td>
                    <td class="TableFieldValue"></td>
                </tr>
                <tr>
                    <td class="TableFieldValue"></td>
                    <td class="TableFieldValue">CommentText</td>
                    <td class="TableFieldValue"></td>
                </tr>

                <%
                    // We've already added in the three protected field names... now we add the rest
                    int fieldIndex=3;
                    for (int i = 0; i < fieldNames.length; i++) {
                        // Already done the default fields.
                        if (!CommentsBlox.isProtectedField(fieldNames[i])) {  %>
                        <tr>
                        <td class="TableFieldValue" style="font-style:italic; text-align:center;"><label title="delete<%= fieldIndex %>"><input type="checkbox" id="delete<%= fieldIndex %>" ></label></td>
                        <td fieldIndex="<%= fieldIndex %>" fieldProperty="0" class="TableFieldValue" style="font-style:italic;"><%= fieldNames[i] %></td>
                        <td fieldIndex="<%= fieldIndex %>" fieldProperty="1" class="TableFieldValue" style="font-style:italic;"><%= CommentsAdmin.valueToString(commentsBlox.getFieldDescription(fieldNames[i])) %></td>
                        </tr> <%
                            fieldIndex++;
                        }
                    }
                %>

				</tbody>

                <jsp:include page="button.jsp" flush="true">
                    <jsp:param name="id" value="addCellValueField"/>
                    <jsp:param name="label" value="add CellValue field"/>
                    <jsp:param name="disabled" value="false" />
                    <jsp:param name="href" value="javascript:addCellValueField();"/>
                </jsp:include>

                </table>
            </td>
            </tr>
        </table>
        </td>
    </tr>

    <!-- Third section is Dimensions -->
        <tr>
        <td width="100%">
        <table id="_dimensionsTable" class="TableForFields" cellpadding="3" cellspacing="2" width="100%">
            <tr>
	            <td rowspan="3" class="TableFieldHeader">Dimensions:</td>
				<td class="TableFieldValue" align="center" style="font-weight:bold;">
                    <img align="right" src="<%= URLFactory.getServerURL( "/theme/i/helpHelp_active.gif") %>" height="18"
                        alt="To enable comments on cells for multi-dimensional data displayed in a grid, choose the MDB data source and select the dimensions which will be used to save comments." />
                    Enable Cell Comments
				</td>
			</tr>
			<tr>
				<td class="TableFieldValue">
                <table id="mdbDataSourceTable">
                <tr>
                    <td class="TableFieldValue"><b><label for="dsnMdbSelect">Data Source:</label></b></td>
                    <td>
                    <select name="dsnMdbSelect" id="dsnMdbSelect" onChange="changeMdbDataSource();">
                        <option selected>Select a data source...</option>
                        <%
                        for(int i=0; i<mdbDataSources.size(); i++) {
                            String dsName = (String) mdbDataSources.elementAt(i);
                            %>
                            <option value="<%= dsName %>"><%= dsName %></option>    <%
                        } %>
                    </select>
                    </td>
                </tr>
                <tr>
                    <td class="TableFieldValue"><label for="_mdbUsername"><%= AlphaBlox.getLocalizedString(english, AlphaBlox.COMMENTS_ADMIN_USERNAME ) %>:</label></td>
                    <td>
                        <input id="_mdbUsername" type="text" style="width: 100%;"
                            name="mdbUsername" value="<%= CommentsAdmin.valueToString(commentsAdminBean.getUsername()) %>">
                        </input>
                    </td>
                </tr>
                <tr>
                    <td class="TableFieldValue"><label for="_mdbPassword"><%= AlphaBlox.getLocalizedString(english, AlphaBlox.COMMENTS_ADMIN_PASSWORD) %>:</label></td>
                    <td>
                        <input id="_mdbPassword" type="password"  style="width: 100%"
                            name="mdbPassword"value="<%= CommentsAdmin.valueToString(commentsAdminBean.getPassword()) %>">
                        </input>
                    </td>
                </tr>
                <tr>
                    <!-- Connect Button -->
                    <td colspan="2" align="center">

                  <!-- mini BLACK BUTTON TABLE -->
                    <jsp:include page="button.jsp" flush="true">
                        <jsp:param name="id" value="tableMdbConnect"/>
                        <jsp:param name="label" value="connect"/>
                        <jsp:param name="href" value="javascript:connectToMdbDataSource();"/>
                        <jsp:param name="disabled" value="true" />
                    </jsp:include>

                  <!-- mini BLACK BUTTON TABLE -->

                    </td>
                </tr>

                </table>
			</td>
			</tr>
			<tr>
				<td class="TableFieldValue"><label for="mdbDimensions" style="display:none"></label>
				<select name="mdbDimensions" id="mdbDimensions" multiple size="7" style="width: 100%">
                <%
                    for (int x = 0; x < dimensions.length; x++) {
                %>
                        <option selected value="<%= dimensions[x] %>"><%= dimensions[x] %></option>
                <%
                    }
                %>
				</select>
				</td>
			</tr>
        </table>
        </td>
    </tr>
    </table>
</td>
</tr>

<tr>
    <td align="center">

    <!-- Save and Cancel buttons -->
      <table id="saveCancelButtonTable" border="0" cellpadding="4" cellspacing="4">
      <tr>
        <td>

      <!-- mini BLACK BUTTON TABLE -->
      <jsp:include page="button.jsp" flush="true">
                <jsp:param name="id" value="tableSave"/>
                <jsp:param name="label" value="save"/>
                <jsp:param name="disabled" value="false" />
                <jsp:param name="href" value="javascript:saveExistingCollection();"/>
      </jsp:include>
      <!-- mini BLACK BUTTON TABLE -->

        </td>
        <td>

      <!-- mini BLACK BUTTON TABLE -->
      <jsp:include page="button.jsp" flush="true">
                <jsp:param name="id" value="tableCancel"/>
                <jsp:param name="label" value="cancel"/>
                <jsp:param name="disabled" value="false" />
                <jsp:param name="href" value="javascript:cancelNewCollection();"/>
      </jsp:include>
      <!-- mini BLACK BUTTON TABLE -->

        </td>
      </tr>
     </table>

    </td>
</tr>

</table>

<input type="hidden" name="collectionName" id="_collectionName" value="<%= commentsBlox.getCollectionName()%>" />
