
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="com.alphablox.server.Server,
                 com.alphablox.admin.tools.essbase.*,
                 java.io.*" %>


<html>

<%
    final String TITLE = "Hyperion Essbase Setup Utility";
    Server server = Server.getServer();
    boolean hasEssbase = server.isEssbaseSupported();
%>

<head>
    <title><%= TITLE %></title>
    <link href="/AlphabloxAdmin/admin/dialog.css" rel="stylesheet" type="text/css">
</head>

<body class="default" style="background-color: #DDDDDD;">


<center>
<h3><%= TITLE %></h3>

<hr width="50%" />
</center>

<%
    if (hasEssbase) {
        String nativeVersion = ChangeEssbaseTool.getOldEssbaseVersion();
        String edsVersion = ChangeEssbaseTool.getOldEDSVersion();

        String alphabloxHome = server.getInstallDirectory();
        File essSetupScript = new File(alphabloxHome, "bin/essbasesetup.bat");
        if (!essSetupScript.exists())
            essSetupScript = new File(alphabloxHome, "bin/essbasesetup.sh");

        String oldEssPath = null;
        try {
            FileReader fr = new FileReader(essSetupScript);
            BufferedReader reader = new BufferedReader(fr);

            String arborpathText = "ARBORPATH=";
            String line = reader.readLine();
            while (line != null) {
                line = line.trim();
                int pos = line.indexOf(arborpathText);
                if (pos != -1) {
                    pos += arborpathText.length();
                    line = line.substring(pos);

                    if (line.indexOf("AAS_HOME") >= 0)
                        continue;

                    if ((line.charAt(0) == '"') && (line.endsWith("\"")))
                        line = line.substring(1, line.length() - 1);

                    oldEssPath = line;
                    break;
                }

                line = reader.readLine();
            }

            reader.close();
            fr.close();
        }
        catch (Exception e) {
            // ignore any errors.  just for convenience anyways
        }
%>
<br />

<table class="default" width="96%" border="0" cellpadding="0" cellspacing="0">

<tr><td>
This wizard configures Alphablox to communicate with your Hyperion Essbase
installation.  Before using this utility, the required Essbase Client
Libraries must be installed on this system.
</td></tr>

<tr><td>&nbsp;</td></tr>

<tr><td><center><hr width="50%" /></center></td></tr>

<tr><td>
<b>Current configuration:</b>
<ul>
   <li>Native Client Version:  <%= nativeVersion %></li>
   <li>EDS Client Version:  <%= edsVersion %></li>
<%
   if (oldEssPath != null)
       out.println("<li>Current client location:  " + oldEssPath + "</li>");
%>
</ul>
</td></tr>

</table>

<br />

<center>
    <a href="<%= ChangeEssbaseWizard.START_PAGE %>">Launch Utility</a>
</center>
<%
    }
    else {
%>
        <h3>This tool is only for use with Alphablox platforms that support Hyperion Essbase data sources.</h3>
<%
    }
%>

<table width="100%" border="0" cellpadding="0" cellspacing="0">
    <tr><td align="left"><img src="/AlphabloxAdmin/home/i/small-logo.gif"></td></tr>
</table>

</body>
</html>
