
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="com.alphablox.server.Server,
                 com.alphablox.admin.tools.migration.tomcat.*" %>


<html>

<%
    final String TITLE = "Alphablox Application Migration Utility for Tomcat 5.5";
    boolean isTomcat = Server.getServer().isTomcat();
%>

<head>
    <title><%= TITLE %></title>
    <link href="/AlphabloxAdmin/admin/dialog.css" rel="stylesheet" type="text/css">
</head>

<body class="default" style="background-color: #DDDDDD;">


<center>
<h3><%= TITLE %></h3>

<hr width="50%" />
</center>

<%
    if (isTomcat) {
%>
<br />

<table class="default" width="96%" border="0" cellpadding="0" cellspacing="0">

<tr><td>
This utility migrates selected
IBM Alphablox applications from Tomcat 3.2.4 to Tomcat 5.5.  The utility will
perform the following tasks on each application selected:

<ul>
<li>Copy the application (if needed) to the <code>webapps</code> directory of
this Alphablox installation <font color="red">*</font></li>
<li>Deploy the application to Tomcat 5.5</li>
<li>Import the application to Alphablox (if needed)</li>
<li>Update the Alphablox TLDs for the current release</li>
<li>Update the application's web.xml to the Servlet 2.4 specification</li>
</ul>

<br />
<h6> <font color="red">*</font> <b>Note: </b> If the Web applications directory
selected is the same as the target directory, the existing applications will be
updated to support Tomcat 5.5.  Before continuing, make certain to create backup
copies of your applications.</h6>
</td></tr>

</table>

<br />

<center>
    <a href="<%= TomcatAppMigrationWizard.START_PAGE %>">Launch Utility</a>
</center>
<%
    }
    else {
%>
        <h3>This tool is for use with Tomcat 5.5 only.</h3>
<%
    }
%>

<table width="100%" border="0" cellpadding="0" cellspacing="0">
    <tr><td align="left"><img src="/AlphabloxAdmin/home/i/small-logo.gif"></td></tr>
</table>

</body>
</html>
