/**
 *	Copyright 2001-2002 AlphaBlox Corporation. All rights reserved.
 *
 *	Script to disable Ctrl-Key macros
 *
 *	@version $Revision: 6 $
 *	@author  $Author: Kbrown $
 */

function disableMacros(evnt) {
	// stop macros from within dialog
	if (MSIE) {
		if (event.ctrlKey) {
			switch (event.keyCode) {
				case 65: // A - select all		: doesn't seem to disable!
					return false;
				case 66: // B - bookmarks
					return false;
				case 69: // E - search panel
					return false;
				case 70: // F - find dialog		: doesn't seem to disable!
					return false;
				case 73: // I - favorites panel
					return false;
				case 78: // N - new window
					return false;
				case 79: // O - open dialog		: doesn't seem to disable!
					return false;
				case 80: // P - print			: doesn't seem to disable!
					return false;
				case 82: // R - reload
					return false;
				default :
					return true;
			}
		}
	}
	else if (NETSCAPE) {
		// TODO: FIX THIS!!
		// Nothing disables in Netscape
		// The macro fires before any method is executed
		if (evnt.modifiers == Event.CONTROL_MASK) {
			switch (evnt.which) {
				case 97: // A - select all
					return false;
				case 98: // B - bookmarks
					return false;
				case 102: // F - find
					return false;
				case 103: // H - history
					return false;
				case 104: // I - page info
					return false;
				case 105: // N - new window
					return false;
				case 110: // O - open
					return false;
				case 111: // P - print
					return false;
				case 114: // R - reload
					return false;
				case 113: // Q - quit
					return false;
				case 112: // S - save as
					return false;
				case 115: // S - save as
					return false;
				case 117: // U - view source
					return false;
				case 119: // W - quit
					return false;
				case 91: // [ - decrease font
					return false;
				case 93: // ] - increase font
					return false;
				default :
					return true;
			}
		}
	}
}

// takes both of these for MSIE
document.onkeydown = disableMacros;
document.onkeyup = disableMacros;

// A Netscape attempt
document.onkeypress = disableMacros;