/**
 *	Copyright 2001-2002 AlphaBlox Corporation. All rights reserved.
 *
 *	(Bugfix 12233)
 *	Script to enable manipulation of the timestamp 
 *	and savedstate of a URL from the same code library
 *
 *	@version $Revision: 5 $
 *	@author  $Author: Kbrown $
 */

function removeSavedstate( windowLocation, searchString ) {

	var search = (searchString == null) ? windowLocation.search : searchString;
	var prefix,post,suffix;

	if (search != "") {
		var index = search.toLowerCase().indexOf( "savedstate=" );
		var index2 = search.toLowerCase().indexOf( "&savedstate=" );
		if ( index != -1 )	{
			if ( index2 != -1 ) {
				prefix = search.substring( 0, index2 );
				post = search.substring( index2 + 12 );
				suffix = (post.indexOf("&") != -1) ? post.substring(post.indexOf("&")):"";
				search = prefix + suffix;
			}
			else {
				prefix = search.substring( 0, index );
				post = search.substring( index );
				suffix = (post.indexOf("&") != -1) ? post.substring(post.indexOf("&") + 1):"";
				search = prefix + suffix;
			}
		}
	}
	
	return search;
	
}

function updateTimestamp( windowLocation, searchString ) {

	var search = (searchString == null) ? windowLocation.search : searchString;
	
	// Bugfix 10843 adding code that adds/modifies a timestamp to the
	// URL in order to force a complete refresh

	var index3 = search.toLowerCase().indexOf( "aas_qz=" );
	var index4 = search.toLowerCase().indexOf( "&aas_qz=" );
	
	var now = new Date();
	var timestamp = now.getTime();
	
	var prefix,post,suffix;

	if (search != "" && search != "?") {
		if ( index3 != -1 )	{
			if ( index4 != -1 ) {
				prefix = search.substring( 0, index4 + 8 );
				post = search.substring( index4 + 8 );
				suffix = (post.indexOf("&") != -1) ? post.substring(post.indexOf("&")):"";
				search = prefix + timestamp + suffix;
			}
			else {
				prefix = search.substring( 0, index3 + 7 );
				post = search.substring( index3 + 7 );
				suffix = (post.indexOf("&") != -1) ? post.substring(post.indexOf("&") ):"";
				search = prefix + timestamp + suffix;
			}
		}
		// TODO: fix
		else { // if (search.indexOf("&") != -1 || search.indexOf("=") != -1)
			search += "&AAS_QZ=" + timestamp;
		}
	}
	else if (search == "" || search == "?") {
		search = "?AAS_QZ=" + timestamp;
	}

	return search;

}

function updateTimestampAndRemoveSavedstate( windowLocation ) {

	var protocol = windowLocation.protocol;
	var network = "//";
	var host = windowLocation.host;
	var pathname = windowLocation.pathname;
	var hash = windowLocation.hash;
	var search = windowLocation.search;
	
	// Bugfix 10233 - force reload of window
	// by adding timestamp in url
	search = updateTimestamp( windowLocation, search );
	
	// If there is a &savedstate=xxx in the URL, then remove it
	search = removeSavedstate( windowLocation, search );

	windowLocation.href = protocol + network + host + pathname + search + hash;
//	return protocol + network + host + pathname + search + hash;
	
}