<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page import="com.alphablox.server.Server,
                 com.alphablox.resource.Messages,
                 com.alphablox.blox.*"%>
<%@ taglib uri='bloxtld' prefix='blox'%>

<blox:resourceBundle bundle="com.alphablox.resource.AlphaBloxBundle" />
<%--
Title: cellCommentsDisplay.jsp

Default commentsBlox UI for a GridBlox with comments on cells.
--%>

<blox:bloxContext />
<%
    String context = request.getParameter("context");
    String bloxName = request.getParameter("bloxName");
	String themeName = request.getParameter("themeName");
%>
<html>
<head>
    <title><blox:message key="DISPLAYCOMMENTS"/></title>
    <%= AbstractBlox.renderHtmlHeader(bloxRequest, bloxResponse) %>
	<link href="comments.css" rel="stylesheet" type="text/css">

    <style>
    #listDiv {
        position: relative;
        height: 50%;
        width: 100%;
    }
    #commentDiv {
        position: relative;
        height: 50%;
        width: 100%;
    }
    </style>
    <script language="JavaScript" src="commentUI.js"></script>
    <script language="JavaScript">
        // Setup the js variables defined in commentUI.js.
        context = "<%= context %>";
		_themeName = "<%= themeName %>";

        // Setup the client blox so we can refresh the client immediatly.
        if (window.opener.<%= bloxName %> != null) {
            blox = window.opener.<%= bloxName %>;
        } else {
            blox = window.opener.opener<%= bloxName %>;
        }

        noCommentTextMessage = '<%= Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NO_COMMENT_TEXT) %>';
        confirmCommentDeleteMessage = '<%= Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_CONFIRM_COMMENT_DELETE) %>';
    </script>
</head>

<body style="margin: 0 0 0 0;" class="csCmpBg csCmpBrdr csWndwClr">
    <div id="listDiv">
    <jsp:include page="commentsList.jsp" flush="true">
        <jsp:param name="context" value="<%=context%>" />
    </jsp:include>
    </div>

    <div id="commentDiv">
    </div>
</body>
</html>