<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page import="com.alphablox.blox.comments.CommentSet,
                 com.alphablox.blox.comments.Comment,
                 java.util.Map,
                 java.util.Arrays,
                 com.alphablox.blox.CommentsBlox,
                 com.alphablox.util.TextFormat,
                 com.alphablox.resource.Messages,
                 com.alphablox.server.Server,
                 com.alphablox.util.ObjectComparator"%>
<%@ taglib uri='bloxtld' prefix='blox'%>

<blox:bloxContext />
<blox:resourceBundle bundle="com.alphablox.resource.AlphaBloxBundle" />
<%
    String context = request.getParameter("context");
    String commentIndexString = request.getParameter("commentIndex");

    if (context == null || commentIndexString == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_DISPLAY_INVALID_PARAMS, new Object[] {context, commentIndexString}));

    int commentIndex = Integer.parseInt(commentIndexString);

    CommentSet commentSet = (CommentSet) session.getAttribute(context + ".Comments.currentCommentSet");
    if (commentSet == null)
        throw new IllegalStateException(Messages.getLocalizedMessage(bloxContext.getLocales(), Messages.COMMENTS_UI_NO_COMMENT_FOUND, new Object[]{"commentDisplay.jsp"}));

    Comment comment = commentSet.getComments()[commentIndex];
%>

<div class="cmntWrpr" style="position:relative; height:100%; overflow:auto">

<table cols="3" border="0" cellpadding="2" cellspacing="1" align="center" class="clsMenuOptions" >
    <tr>
        <td width="10%" class="heading"><blox:message key="COMMENTS_DIALOG_AUTHOR"/>:</td><td><%=comment.getAuthor()%></td>
        <td align="right"><span class="heading"><blox:message key="COMMENTS_DIALOG_TIMESTAMP"/>: </span><%=comment.getTimestamp()%></td>
        <%
            if (comment.getField(Comment.FIELD_CELLVALUE) != null) {
                String cellValue=comment.getField(Comment.FIELD_CELLVALUE);
                if (cellValue.length() == 0)
                    cellValue="&nbsp;&nbsp;&nbsp;";
        %>
        <td align="right"><span class="heading"><blox:message key="COMMENTS_DIALOG_CELLVALUE"/>: </span><%= cellValue %></td>
        <% } %>
    </tr>

<%
    Map fields = comment.getFields();
    String[] fieldNames = (String[]) fields.keySet().toArray(new String[0]);
    Arrays.sort(fieldNames, ObjectComparator.getStringComparator(bloxContext.getLocale()));
    for (int i = 0; i < fieldNames.length; i++) {
        String name = fieldNames[i];
        String value = (String) fields.get(name);

        if (!CommentsBlox.isProtectedField(name) &&
                !Comment.FIELD_CELLVALUE.equals(name)) {   %>
            <tr>
            <td width="10%" class="heading"><%= deHTMLify(name) %>:</td>
            <td colspan="2"><%= deHTMLify(value) %></td>
            </tr>
 <%
        }
    }

    String commentText = comment.getCommentText();
    String commentHTML;

     if (commentText.trim().length() > 0)
         commentHTML = deHTMLify(commentText);
     else
         commentHTML = "&nbsp;";
%>

    <tr>
    <td colspan="4" class="clsDataCell" style="white-space:normal; text-align:left; border:thin groove;">
    <%= commentHTML %>
    </td>
    </tr>
</table>
</div>

<%!
    static private String[][] entities = {
        {"&", "&amp;"},     // This must be first, because this array is used to do substitutions, and we can't
        {"\"", "&quot;"},   // have & being substituted in the following strings.
        {"<", "&lt;"},
        {">", "&gt;"}
    };

    public String deHTMLify(String s) {
        for (int idx = 0; idx < entities.length; idx++) {
            String[] entity = entities[idx];

            if (s.indexOf(entity[0]) >= 0) {
                s= TextFormat.replace(s, entity[0], entity[1]);
            }
        }

        return s;
    }
%>