<%@ page import="com.alphablox.render.view.pdfreport.PdfPageContext,
                 java.text.DateFormat,
                 java.util.Date,
                 java.io.StringWriter,
                 java.io.PrintWriter,
                 com.alphablox.util.TextFormat,
                 com.alphablox.server.request.DecodedServletRequest" %>

<%-- Import the Blox custom tag libraries --%>
<%@ taglib uri="bloxtld" prefix="blox"%>

<%!
    String exceptionToString(Throwable t) {
        final String SPACE = "     ";
        StringWriter buf = new StringWriter();
        PrintWriter pw = new PrintWriter(buf);

        t.printStackTrace(pw);
        pw.close();

        String tabbedStack = buf.toString();
        String formattedStack = TextFormat.replace(tabbedStack, "\t", SPACE);

        return "<pre id='preExceptionString'>" + formattedStack + "</pre>";
    }

    String handleException(HttpSession session, final String bloxName, final String appName, Throwable t) {
        String exceptionString = t.getClass().getName();
        String now = DateFormat.getDateTimeInstance().format(new Date());

        session.setAttribute("AASPDFException", exceptionToString(t));
        session.setAttribute("AASPDFErrorBlox", bloxName);
        session.setAttribute("AASPDFErrorApp", appName);
        session.setAttribute("AASPDFErrorTime", now);

        if (exceptionString.lastIndexOf('.') >= 0) {
            exceptionString = exceptionString.substring(exceptionString.lastIndexOf('.') + 1);
        }

        session.setAttribute("AASPDFExceptionClass", exceptionString);

        return exceptionString;
    }
%>

<html>
<head>
<meta http-equiv="Pragma" content="no-cache">

<blox:header/>

<%
    // Because the incoming title is in UTF-8 and because the web server messes with
    // it, this code is neccessary to get a Unicode version of the title that can be
    // inserted into the HTML page (then translated back to UTF-8).
    DecodedServletRequest decodedRequest = new DecodedServletRequest( );
    decodedRequest.initialize(bloxRequest);

    final String BLOX_NAME = decodedRequest.getParameter("bn");
    final String APP_NAME = decodedRequest.getParameter("an");

    session.removeAttribute("AASPDFException");
    session.removeAttribute("AASPDFExceptionClass");
    session.removeAttribute("AASPDFErrorBlox");
    session.removeAttribute("AASPDFErrorApp");
    session.removeAttribute("AASPDFErrorTime");

    PdfPageContext pdfPageContext = new PdfPageContext();
    String exceptionString = null;
%>

<script language="JavaScript1.2">
   function processReport() {
    var done = false;
    var count = 0;
    var newWidth = 0;
    var width = 0;
    var widestTable= null;

    while (!done) {
      var table = document.getElementById("blox" + count);

      if(table != null){
      	  //this adds a delay, use the width first
          newWidth = ""+table.clientWidth;
      }
      if (table == null) {
        done = true;
      }
      else {
        if (newWidth > width) {
          width = newWidth;
          widestTable = "blox" + count;
        }
      }
      count++;
    }
    var result = widestTable + "_" + width;

    parent.setWidth(result);
  }

  function handleError(error) {
    parent.closeButton.style.visibility="visible";
    parent.waitText.innerHTML = "<a href='#' onClick='javascript:handleError();'>'" +
                                 error + "' occurred. Click for more information.</a>";
  }

</script>
</head>


<body>
<div id="renderingDiv" class="renderingDiv">
 <%
     try {
         pdfPageContext.handleReportFit(BLOX_NAME, APP_NAME, bloxRequest, bloxResponse, out);
     }
     catch (Throwable t) {
         exceptionString = handleException(session, BLOX_NAME, APP_NAME, t);
     }

 %>
 </div>

<%
    if (exceptionString == null) { %>
<script language="JavaScript1.2"> processReport(); </script>
<%
    }
    else { %>
<script language="JavaScript1.2"> handleError("<%= exceptionString %>"); </script>
<%
    }
%>
</body>
</html>
