/*
 * Copyright 2001 AlphaBlox Corporation. All rights reserved.
 */

var HIDE_COMMAND		= "hide";
var SHOW_COMMAND		= "show";
var GROUP_COMMAND 		= "addbreak";
var REMOVE_GROUP_COMMAND	= "removebreak";
var SORT_COMMAND		= "sort";
var SWITCH_COMMAND		= "order";
var EDIT_COMMAND		= "edit";
var AGGREGATION_COMMAND	= "aggregation";
var STYLES_COMMAND		= "styles";
var REFRESH_COMMAND     = "refresh";

function refreshReport( target ) {
        _hideMenu();
        sendCommandToServer( target, REFRESH_COMMAND, "");
        return false;
}

function hide( target ) {
	sendCommandToServer( target, HIDE_COMMAND, target.getAttribute("columnIndex") );
	return false;
}

function showAll( target ) {
	sendCommandToServer( target, SHOW_COMMAND, "all" );
	return false;
}

function group( target ) {
	sendCommandToServer( target, GROUP_COMMAND, target.getAttribute("columnIndex") );
	return false;
}

function removeGroup( target ) {
	sendCommandToServer( target, REMOVE_GROUP_COMMAND, target.getAttribute("levelIndex") );
	return false;
}

function removeAllGroups( target ) {
	sendCommandToServer( target, REMOVE_GROUP_COMMAND, "all" );
	return false;
}

function sort( target ) {
	sendCommandToServer( target, SORT_COMMAND, target.getAttribute("columnIndex") );
	return false;
}

function moveLeft( target ) {
	 var report = getReport( target );
	 var sourceIndex = target.getAttribute("columnIndex");
	 if(sourceIndex > 0)
	     switchColumns(report, sourceIndex, sourceIndex - 1);
	 return false;
}

function moveRight (target ) {
 	 var report = getReport( target );
	 var sourceIndex = target.getAttribute("columnIndex");
	 var length = parseInt(target.parentNode.cells.length);
	 if(sourceIndex < length - 1 )
         {
	     var targetIndex = parseInt(sourceIndex) + 1;
	     switchColumns(report, sourceIndex, targetIndex);
	 }
	 return false;
}

function switchColumns( report, source, target ) {
	if( source != target ) {
		var args = new Array( );
		args[0] = source;
		args[1] = target;
		sendCommandToServer( report, SWITCH_COMMAND, args );
	}
}

function storeText( item, text ) {
	if(item != null) {
		var args = getTargetArgs( item );
		var tempText =  text.replace("%", "%25");
		args[args.length]  = tempText.replace("'", "&#39;");
		sendCommandToServer( item, EDIT_COMMAND,  args );
	}
}

function getTargetArgs( item ) {
	var levelIndex = item.getAttribute("levelIndex") != null ? item.getAttribute("levelIndex") : "-1";
	var columnIndex = item.getAttribute("columnIndex") != null ? item.getAttribute("columnIndex") : "-1";

	var args = [ levelIndex, columnIndex ];
	return args;
}

function setAggregation( target, aggregation ) {
	var args = [ target.getAttribute("columnIndex"), aggregation ];
	sendCommandToServer( target, AGGREGATION_COMMAND,  args );
	return false;
}

function applyStyles( target, scope, style ) {
	var args = [scope, style];
	sendCommandToServer( target, STYLES_COMMAND,  args );
}


function onDataChanged( targetName, newTable ) {
	initializeEditor( targetName );

	var report = getElement( targetName );

	report.innerHTML = newTable;

	commandPending = false;
}

var commandPending = false;  // indicates that we are waiting for a page refresh TODO - don't need this ?

function sendCommandToServer( target, action, args ) {
    var report  = null;
    if(action ==  REFRESH_COMMAND) {
        var items   = "";
		for( var i = 0; i < document.all.length; i++ )
		{
		    if( document.all.item(i).id == target )
			{
			    report = document.all.item(i);
			}

		}
	}
	else {
	    report = getReport( target );
	}
	var url = getUpdatePage( report.getAttribute('id') );

    var parameter = "";
    parameter += "<body>";
    parameter += "<form id='sendform' action='" + url + "' method='GET'>";
    parameter += "<input type='hidden' name='action' value='" + action + "'>";
    parameter += "<input type='hidden' name='target' value='" + report.id + "'>";

	if( args != null ) {
		if( typeof args == "object" ) {
			for( var i = 0; i < args.length; i++ ) {
                parameter += "<input type='hidden' name='arg" + i + "' value='" + args[i] + "'>";
			}
		}
		else {
            parameter += "<input type='hidden' name='arg0' value='" + args + "'>";
		}
	}
	parameter += "</form>";

	commandPending = true;

	if(isIE()) {
	    parameter += "<script>setTimeout(\"document.getElementById( 'sendform' ).submit();\", 0);</script>";
    	parameter += "</body>";

		report.rpc.document.write(parameter);
	}
	else {
	    parameter += "<script>document.getElementById( 'sendform' ).submit();</script>";
	    parameter += "</body>";

	    report.rpc.contentDocument.open();
	    report.rpc.contentDocument.write(parameter);
	    report.rpc.contentDocument.close();
	}
}


function encode(arg) {
    var encoded = encodeURIComponent(arg);
    return encoded;
}

function getUpdatePage( target ) {
	var updatePage = SERVLET_PREFIX[target] + "/cmd?target=" + target;
	return updatePage;
}

