<!--
    IBM Confidential
    OCO Source Materials
    5724-L14
    (c) Copyright IBM Corp. 2007
    The source code for this program is not published or otherwise divested of its trade secrets,
    irrespective of what has been deposited with the U.S. Copyright Office.
-->

<%@ page contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>

<%@ page import="com.alphablox.server.request.DecodedServletRequest" %>
<%@ page import="com.alphablox.resource.Messages"%>
<%@ page import="java.util.Enumeration"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.Locale"%>
<%@ page import="com.alphablox.util.Message"%>
<%@ page import="com.alphablox.server.service.BloxBuilderService" %>
<%@ page import="com.ibm.alphablox.bloxbuilder.core.util.BloxBuilderUtils" %>
<%@ page import="com.ibm.alphablox.bloxbuilder.core.BloxBuilderManager" %>
<%@ page import="com.alphablox.server.Constants" %>
<%@ page import="com.ibm.alphablox.bloxbuilder.core.report.ReportDefinitionFactory"%>
<%@ page import="com.ibm.alphablox.bloxbuilder.core.query.QueryDefinitionFactory"%>
<%@ page import="com.ibm.alphablox.bloxbuilder.core.application.ApplicationDefinitionFactory"%>

<%@ taglib uri='bloxtld' prefix='blox' %>

<html>
<head>
<blox:header />
    <title>Blox Builder Object Delete</title>
</head>
<body>

<%!
    static private final String REPORT_PREFIX = ReportDefinitionFactory.REPORTS_CONTAINER + "/";
    static private final String QUERY_PREFIX = QueryDefinitionFactory.QUERY_CONTAINER + "/";
    static private final String APPLICATION_PREFIX = ApplicationDefinitionFactory.APPLICATIONS_CONTAINER + "/";
%>

<%
    DecodedServletRequest decodedRequest = new DecodedServletRequest();
    decodedRequest.initialize(bloxRequest);
    String objectID = decodedRequest.getParameter( "objectName" );

    if ( objectID == null || "/".equals(objectID) || objectID.indexOf("..") != -1) { // Not allowed
        throw new ServletException(getMessage(request, Messages.TOOLING_BAD_BLOX_BUILDER_NAME, new Object[] { objectID } ));
    }

    try {
        BloxBuilderService bloxBuilderService = BloxBuilderUtils.getBloxBuilderService();
        BloxBuilderManager bloxBuilderManager = (BloxBuilderManager)bloxBuilderService.getManager();

        String topic = null;

        if ( objectID.startsWith( REPORT_PREFIX ) ) {
            topic = Constants.CONTROLTOPIC_REPORT;
            objectID = objectID.substring( REPORT_PREFIX.length() );
        }
        else if ( objectID.startsWith( QUERY_PREFIX ) ) {
            topic = Constants.CONTROLTOPIC_QUERY;
            objectID = objectID.substring( QUERY_PREFIX.length() );
        }
        else if ( objectID.startsWith( APPLICATION_PREFIX ) ) {
            topic = Constants.CONTROLTOPIC_BLOXBUILDERAPP;
            objectID = objectID.substring( APPLICATION_PREFIX.length() );
        }
        else
           throw new ServletException(getMessage(request, Messages.TOOLING_BAD_BLOX_BUILDER_OBJECT_TYPE, new Object[] { objectID } ));

        if ( objectID.indexOf( '/', 1 ) != -1 && !objectID.startsWith( "/" ) )
            objectID = "/" + objectID;

        bloxBuilderManager.deleteDefinition( topic, objectID );
    }
    catch (Exception e) {
        new Message(Message.ERROR, "ReportServlet", e).send();
        throw new ServletException(e);
    }
%>

<jsp:forward page="success.jsp" />

<%!
    private String getMessage(HttpServletRequest request, int messageId, Object[] parameters) {
        try {
            Enumeration localeEnumeration = request.getLocales();
            List localeList = new ArrayList();
            while (localeEnumeration.hasMoreElements())
                localeList.add(localeEnumeration.nextElement());
            Locale[] locales = (Locale[]) localeList.toArray(new Locale[localeList.size()]);

            return Messages.getLocalizedMessage(locales, messageId, parameters);
        }
        catch (Exception e) {
            new Message(Message.ERROR, "ReportServlet", e).send();
            return "Error number " + messageId + " could not be translated";
        }
    }
%>

</body>
</html>
