package com.ibm.alphablox.tooling.querytools;

/*
 * Copyright (c) 2003 Alphablox Corporation. All rights reserved.
 */

import com.alphablox.blox.DataBlox;
import com.alphablox.blox.uimodel.core.ComponentContainer;
import com.alphablox.blox.uimodel.core.Controller;
import com.alphablox.blox.uimodel.core.Edit;

/**
 * change the query text,
 * where to find the edit component;
 * where to get the value;
 * when should we change it
 * @author hujianh@cn.ibm.com
 *
 */
public class ChangeQueryTextHandle{
    private DataBlox dataBlox;

    private ComponentContainer container;
    
    private boolean textSynchronized = true;
    
    public ChangeQueryTextHandle(DataBlox db){
        dataBlox = db;
    }
    
    /**
     * connect the EventListener to the container,
     * 
     * @param container
     */
    public void setContainer(ComponentContainer container){
        this.container = container;
        Controller controller = container.getController();
        DesignerController qtdController = (DesignerController)controller;
//        qtdController.setTextHandle(this);
    }
    
    public boolean isTextSynchronized(){
        return textSynchronized;
    }
    
    public void setTextSynchronized(boolean textSynchronized){
        this.textSynchronized=textSynchronized;
    }
    
    public void change(){
        if( textSynchronized ){
            textSynchronized = false;
            return;
        }
        try{
            String str = dataBlox.generateQuery();
            Edit queryEdit = container.getEdit("query");
            queryEdit.setValue(str);
            queryEdit.changed();
        }catch(Exception ex){
            System.out.println("ChangeQueryTextHandle:");
            ex.printStackTrace();
        }
    }
}