/**
 * Copyright 2002 Alphablox Corporation. All rights reserved.
 * User: hujianh
 * Date: Oct 22, 2007
 */
package com.ibm.alphablox.tooling.relational.view;

import com.alphablox.blox.DataBlox;
import com.alphablox.blox.uimodel.core.ComponentContainer;
import com.alphablox.blox.uimodel.core.Edit;
import com.alphablox.blox.uimodel.core.ModelException;
import com.ibm.alphablox.tooling.relational.Messages;
import com.ibm.alphablox.tooling.relational.RMBConstants;

/**
 * @author hujianh@cn.ibm.com
 *
 */
public class DBItemInfoContainerBuilder implements IViewPartBuilder {

    private ComponentContainer itemInfoContainer;

    /* (non-Javadoc)
     * @see com.ibm.alphablox.tooling.relational.view.IViewPartBuilder#build(java.lang.Object, int, int, java.lang.String)
     */
    public ComponentContainer build(int h, int w, String style) throws ModelException{
        itemInfoContainer = new ComponentContainer(RMBConstants.DBITEM_INFO_CONTAINER_ID);
        itemInfoContainer.setHeight(h);
        itemInfoContainer.setWidth(w);
        itemInfoContainer.setScrollingEnabled(true);
        itemInfoContainer.setStyle(style);
        
        Edit itemInfoEdit = new Edit(RMBConstants.DBITEM_INFO_ID,
                Messages.getString("DBItemInfoContainerBuilder.NoInfo")); //$NON-NLS-1$
        itemInfoContainer.add(itemInfoEdit);
        
        itemInfoEdit.setDisabled(true);
        itemInfoEdit.setLines(3);
        itemInfoEdit.setCharactersPerLine(94);
        return itemInfoContainer;
    }

    /* (non-Javadoc)
     * @see com.ibm.alphablox.tooling.relational.view.IViewPartBuilder#setDataBlox(com.alphablox.blox.DataBlox)
     */
    public void setDataBlox(DataBlox db) {
        // TODO Auto-generated method stub
        
    }

    
}
