/**
 * Copyright 2002 Alphablox Corporation. All rights reserved.
 * User: hujianh
 * Date: Oct 22, 2007
 */
package com.ibm.alphablox.tooling.relational.view;

import com.alphablox.blox.DataBlox;
import com.alphablox.blox.uimodel.core.Button;
import com.alphablox.blox.uimodel.core.ComponentContainer;
import com.alphablox.blox.uimodel.core.ModelException;
import com.alphablox.blox.uimodel.core.Spacer;
import com.alphablox.blox.uimodel.core.VerticalLayout;
import com.ibm.alphablox.tooling.relational.Messages;
import com.ibm.alphablox.tooling.relational.RMBConstants;

/**
 * @author hujianh@cn.ibm.com
 *
 */
public class OperatorContainerBuilder implements IViewPartBuilder {

//    private String gifBase = "D:\\development\\Berlin\\build\\Alphablox\\system\\AlphabloxPlatform\\AlphabloxTooling\\querytool\\"; //$NON-NLS-1$

    /* (non-Javadoc)
     * @see com.ibm.alphablox.tooling.relational.view.IViewPartBuilder#build(java.lang.Object, int, int, java.lang.String)
     */
    public ComponentContainer build(int h, int w, String style) throws ModelException{
        ComponentContainer opContainer = 
            new ComponentContainer(RMBConstants.OPERATOR_CONTAINER_ID);
        opContainer.setLayout(new VerticalLayout());
        opContainer.setHeight(h);
        opContainer.setWidth(w);
        opContainer.setScrollingEnabled(true);
        opContainer.setStyle(style);
        
        Button insert = new Button(RMBConstants.ACTION_INSERT,"->"); //$NON-NLS-1$
        insert.setTooltip(Messages.getString("OperatorContainerBuilder.InsertSQL")); //$NON-NLS-1$
        insert.setWidth(w-5);
        
        opContainer.add(insert);
        opContainer.add(new Spacer(10,10));
        Button newButton = new Button(RMBConstants.ACTION_NEW_QUERY, "Select *"); //$NON-NLS-1$
        newButton.setTooltip(Messages.getString("OperatorContainerBuilder.NewSQL")); //$NON-NLS-1$
        newButton.setWidth(w-5);
        
        opContainer.add(newButton);
        opContainer.add(new Spacer(10,10));
        
        return opContainer;
    }

    /* (non-Javadoc)
     * @see com.ibm.alphablox.tooling.relational.view.IViewPartBuilder#setDataBlox(com.alphablox.blox.DataBlox)
     */
    public void setDataBlox(DataBlox db) {
        // TODO Auto-generated method stub
        
    }

}
