<%@ page import="com.alphablox.blox.*,
                 com.alphablox.blox.uimodel.*,
                 com.alphablox.blox.uimodel.core.*,
                 com.alphablox.blox.data.MetaData,
                 com.alphablox.blox.data.rdb.RDBMetaData,
                 com.alphablox.server.service.BloxBuilderService,
                 com.alphablox.server.service.ServiceManager,
                 com.alphablox.blox.uimodel.MemberFilterBloxModel,
                 com.alphablox.blox.uimodel.MemberFilterBrixController,
                 com.alphablox.blox.uimodel.MemberFilterBrixModel,
                 com.alphablox.blox.uimodel.memberfilter.MemberFilterComponent,
                 com.alphablox.blox.filter.MemberSelectFilter,
                 com.alphablox.blox.filter.MemberSelectEvent,
                 com.alphablox.blox.event.MemberSelectListener,
                 com.alphablox.blox.uimodel.memberfilter.MemberFilterChanged,
                 com.ibm.alphablox.bloxbuilder.common.proxy.BloxProxy,
                 com.ibm.alphablox.bloxbuilder.common.proxy.DataBloxProxy,
                 com.ibm.alphablox.bloxbuilder.tooling.querytools.QueryToolsBlox,
                 com.alphablox.blox.repository.DataSource"%>
                 
<%@ page import="com.ibm.alphablox.tooling.querytools.*"%>
<!--
    IBM Confidential
    OCO Source Materials
    5724-L14
    (c) Copyright IBM Corp. 2007
    The source code for this program is not published or otherwise divested of its trade secrets,
    irrespective of what has been deposited with the U.S. Copyright Office.
-->
<% boolean debug = (request.getParameter("debug")=="true");%>
<jsp:useBean id="appContext" class="com.ibm.alphablox.tooling.AppContext" scope="session">
<%
  appContext.init(pageContext);
%>
</jsp:useBean>
<%@ page pageEncoding="ISO-8859-1" %> <!-- encoding this page was written in -->
<%@ page contentType="text/html;charset=UTF-8" %>  <!-- encoding for response -->
<%@ taglib uri='bloxtld' prefix='blox'%>

<html>
<head>
    <meta http-equiv="Pragma" content="no-cache">    
    <title>Query Tools: Metadata</title>
    <blox:header />
    <script language="JavaScript">
    function forceSqlEditorLostFocus()
    {
    }
    </script>
</head>
<body>

<blox:admin id="dsAdminBlox2" />

<%
    final String bloxWidth = "100%";
    final String bloxHeight = "90%";
    request.setCharacterEncoding("UTF-8"); // encoding for request
    final DataBlox queryToolsDataBlox = new DataBlox();
    final ViewBlox memberFilterBlox = new MemberFilterBlox();
    final BloxContext context = BloxContextFactory.getBloxContext( request, response);
%>

<blox:container id="queryToolsContainer_metadata" width="100%" height="10%" visible="false">
<%
    initContainer(queryToolsContainer_metadata,appContext);
%>
</blox:container>

<%
    //get blox proxy
    final String idPrefix = "querytools_m";
    final String uniqueId = request.getParameter("ObjectId");
    
    final BloxBuilderService manager = (BloxBuilderService) ServiceManager.getService(ServiceManager.SVC_BLOXBUILDER, null);
    final QueryToolsBlox qtBlox = (QueryToolsBlox) manager.getTempData(uniqueId);
    
    final BloxProxy proxy = qtBlox.getBloxProxy();
    
    try {
        String dsName = proxy.getStringValue("DataSourceName");
        //System.out.println("datasource name="+dsName);
        DataSource ds = dsAdminBlox2.getDataSource(dsName);
        int at = ds.getAdapterType();
        if( at==1 ){//RDB
            request.getRequestDispatcher("rMetadataBrowser.jsp").forward(request,response);
            return;
        }
        // MDB
        BloxProxy defaultProxy = (BloxProxy) proxy.clone();
        AbstractBlox defaultDataBlox; //it is useless, but we cannot remove it
        defaultDataBlox = new DataBlox();
        // get the default properties into a default proxy
        defaultDataBlox.init(context, idPrefix + System.currentTimeMillis());
        defaultProxy.setBlox(defaultDataBlox);
        qtBlox.setDefaultBloxProxy(defaultProxy);

        //set properties of the query into the datablox
        queryToolsDataBlox.init(context, idPrefix + "d" + System.currentTimeMillis());
        proxy.setBlox(queryToolsDataBlox);
        
    } catch (Throwable t) {
%><h3>Error: <%=t.getClass().getName()%>: <%=t.getLocalizedMessage()%></h3><%
        t.printStackTrace();
        return;
    }
%>

<blox:display bloxRef="queryToolsContainer_metadata"/>

<jsp:useBean id="queryToolsBean" class="com.ibm.alphablox.tooling.querytools.QueryDesignerBean"  scope="session" >
<%
    queryToolsBean.init(request, response, appContext);
%>
</jsp:useBean>

<%
    try {
        queryToolsDataBlox.setConnectOnStartup(false);
        //memberFilter init
        memberFilterBlox.init(context, idPrefix + "g"+ System.currentTimeMillis());
        ((DataViewBlox) memberFilterBlox).setDataBlox(queryToolsDataBlox);
        MetadataBrowserHandler eventHandler = new MetadataBrowserHandler(qtBlox);
        boolean initialized = eventHandler.initialize(memberFilterBlox,queryToolsBean,
                              queryToolsContainer_metadata.getBloxModel());
        if (!initialized) {
            throw new Exception(
            "The MetadataBrowser cannot be initialized,"
            + "this is most probably caused by the failure to connect to a DataSource!");
        }
        final MemberFilterBloxModel mfbModel = (MemberFilterBloxModel) memberFilterBlox.getBloxModel();
        memberFilterBlox.render(bloxRequest, out, null, bloxWidth, bloxHeight);
    } catch (Throwable t) {
%><h3>Error: <%=t.getClass().getName()%>: <%=t.getLocalizedMessage()%></h3><%
    t.printStackTrace();
    }
%>

</body>
</html>
<%!
    final String CUBES_EDIT_NAME = "cubes";

    void initContainer(ContainerBlox container, com.ibm.alphablox.tooling.AppContext appContext) throws Exception{
        BloxModel bloxModel = container.getBloxModel();
        bloxModel.setLayout(new GridLayout(5));
        Style style = new Style();
        style.setBorder(true);
        bloxModel.setStyle(style);

        String cubesLabelText = appContext.getString("QUERY_CUBES_LABEL");
        Static label = new Static("CubeStatic", cubesLabelText);

        ComboBox cubeList = new ComboBox(CUBES_EDIT_NAME);
        cubeList.setWidth(100);

        Spacer spacer = new Spacer();
        spacer.setWidth(20);

        Spacer sp = new Spacer();
        sp.setWidth(1);

        bloxModel.add(label);
        bloxModel.add(sp);
        bloxModel.add(cubeList);
        bloxModel.add(spacer);
    }    
%>
