<%@ page import="com.alphablox.blox.*,
				 com.alphablox.blox.uimodel.*,
				 com.alphablox.blox.uimodel.core.*,
                 com.alphablox.server.service.BloxBuilderService,
                 com.alphablox.server.service.ServiceManager,
                 com.ibm.alphablox.tooling.querytools.*,
                 com.ibm.alphablox.bloxbuilder.common.proxy.BloxProxy,
                 com.ibm.alphablox.bloxbuilder.common.proxy.DataBloxProxy,
                 com.ibm.alphablox.bloxbuilder.tooling.querytools.QueryToolsBlox,
                 com.alphablox.blox.repository.DataSource"%>

<!--
    IBM Confidential
    OCO Source Materials
    5724-L14
    (c) Copyright IBM Corp. 2007
    The source code for this program is not published or otherwise divested of its trade secrets,
    irrespective of what has been deposited with the U.S. Copyright Office.
-->
<jsp:useBean id="appContext" class="com.ibm.alphablox.tooling.AppContext" scope="session">
<%
	appContext.init(pageContext);
%>
</jsp:useBean>

<%@ page pageEncoding="ISO-8859-1" %> <!-- encoding this page was written in -->
<%@ page contentType="text/html;charset=UTF-8" %>  <!-- encoding for response -->
<%@ taglib uri='bloxtld' prefix='blox'%>

<%
    final String bloxWidth = "100%";
    final String bloxHeight = "90%";

    request.setCharacterEncoding("UTF-8");  // encoding for request

    final BloxBuilderService manager = (BloxBuilderService)ServiceManager.getService(ServiceManager.SVC_BLOXBUILDER, null);
%>

<html>
<head>
	<meta http-equiv="Pragma" content="no-cache">
    <title>Query Tools: Query Designer</title>
    <blox:header />
    <script language="JavaScript">
    function forceSqlEditorLostFocus()
    {
    }
    </script>
</head>
<body>
<blox:admin id="dsAdminBlox" />
<%
 	final DataBlox queryToolsDataBlox = new DataBlox();
 	final ViewBlox presentBlox = new PresentBlox();
 	final DesignerController controller = new DesignerController();
 	//final AllDataBloxEventListener dataBloxEventListener = new AllDataBloxEventListener(queryToolsDataBlox);

	String idPrefix = "querytools_m";
    final String uniqueId = request.getParameter("ObjectId");
    final QueryToolsBlox qtBlox = (QueryToolsBlox)manager.getTempData(uniqueId);
    final BloxProxy proxy = qtBlox.getBloxProxy();
    final BloxContext context = BloxContextFactory.getBloxContext(request, response);
    final String queryText;
    Object queryObj = proxy.getPropertyValue("Query");
    if(queryObj != null) {
        queryText = queryObj.toString();
    } else {
        queryText = "";
    }
    try{
        String dsName = proxy.getStringValue("DataSourceName");
        DataSource ds = dsAdminBlox.getDataSource(dsName);
        int at = ds.getAdapterType();
        if( at==1 ){//RDB
            request.getRequestDispatcher("rMetadataBrowser.jsp").forward(request,response);
            return;
        }
    }catch(Exception ex)
    {
        ex.printStackTrace();
    }
%>

<%!
final static String CUBES_EDIT_NAME="cubes";
%>

<blox:container id="queryToolsContainer" width="100%" height="10%">
<%
	BloxModel bloxModel = queryToolsContainer.getBloxModel();
	bloxModel.setLayout( new GridLayout(5) );
	Style style = new Style();
	style.setBorder(true);
	bloxModel.setStyle(style);
	
	String cubesLabelText = appContext.getString("QUERY_CUBES_LABEL");
	Static label = new Static("CubeStatic",cubesLabelText);
	
	ComboBox cubeList = new ComboBox(CUBES_EDIT_NAME);
	cubeList.setWidth(100);

	//cubeList.add("cube1");
	//cubeList.add("cube2");
	
	Spacer spacer = new Spacer();
	spacer.setWidth(20);
	
	Spacer sp = new Spacer();
	sp.setWidth(1);
	
	String butRunDefaultQuery = appContext.getString("QUERY_RUN_DEFAULT_QUERY");
	Button defaultQueryButton = new Button("runDefaultQuery",butRunDefaultQuery);
	
	bloxModel.add(label);
	bloxModel.add(sp);
	bloxModel.add(cubeList);
	bloxModel.add(spacer);
	bloxModel.add(defaultQueryButton);
%>
</blox:container>

<%
	try{
	    AbstractBlox defaultDataBlox;
	    BloxProxy defaultProxy=(BloxProxy)proxy.clone();
		    
	    defaultDataBlox = new DataBlox();
	    // get the default properties into a default proxy
	    defaultDataBlox.init(context, idPrefix + System.currentTimeMillis());
	    defaultProxy.setBlox(defaultDataBlox);
	    qtBlox.setDefaultBloxProxy(defaultProxy);
		
		//set properties of the query into the datablox
		queryToolsDataBlox.init(context,idPrefix +"d"+ System.currentTimeMillis());
		proxy.setBlox(queryToolsDataBlox);
		
		queryToolsDataBlox.connect(false);
		//System.out.println("queryToolsDataBlox.connect(false);OK");
	}catch(Exception t){
		%><h3>Error: <%= t.getClass().getName() %>: <%= t.getLocalizedMessage() %></h3><%
        t.printStackTrace();
		System.out.println("The DataBase cannot be connected to, please check your datasource!");
        return;
	}
%>

<jsp:useBean id="queryToolsBean" class="com.ibm.alphablox.tooling.querytools.QueryDesignerBean"  scope="session" >
<%
    queryToolsBean.init(request, response, appContext);
%>
</jsp:useBean>
<%
	try{
		queryToolsDataBlox.setConnectOnStartup(false);
		//PresentBlox init
        presentBlox.init(context, idPrefix+ "g" + System.currentTimeMillis());
		
        ((DataViewBlox)presentBlox).setDataBlox(queryToolsDataBlox);
		
        controller.initialize(presentBlox,queryToolsBean,queryToolsContainer.getBloxModel());
        
        ((PresentBlox)presentBlox).getChartBlox().setVisible(false);
        final String[] removedButtons = new String[]{ModelConstants.FILE_EXPORT_TO_EXCEL,
                                                     ModelConstants.FILE_EXPORT_TO_PDF,
                                                     ModelConstants.FILE_MENU};
        presentBlox.getBloxModel().removeNamedActions(removedButtons);
        
        presentBlox.render(bloxRequest, out, null, bloxWidth, bloxHeight);
        
        queryToolsDataBlox.connect();
        
    }catch(Exception t){
    	%><h3>Error: <%= t.getClass().getName() %>: <%= t.getLocalizedMessage() %></h3><%
        t.printStackTrace();
	}
%>

</body>
</html>
