<?xml version="1.0" ?>

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/TR/xhtml1/strict">

<xsl:strip-space elements="report-list name"/>

<xsl:output method="xml" indent="yes" encoding="utf-8"/>

<xsl:template match="report-list">

 <html>
   <head>
      <meta HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=UTF-8" />
     <title>
	Alphablox Blox Builder Report Management       
     </title>
   </head>
   <body>
	<table border="1" cellpadding="2">
		<tr>
			<th>Report Name</th>
			<th>Description</th>
			<th>Operations</th>
		</tr>
       	<xsl:apply-templates select="report">
         	<xsl:sort select="display-name" />
       	</xsl:apply-templates>

	</table>
	<br />

	<a href="/AlphabloxTooling/tooling.jsp">Return to tooling home</a>
   </body>
 </html>
</xsl:template>

<xsl:template match="report">
    <xsl:variable name="theid" select="id"/>
    <xsl:variable name="thename" select="display-name"/>
	<tr>
	   <td>
    	      <xsl:value-of select="$thename"/> 
	   </td>
	   <td>
    	      <xsl:value-of select="description"/> 
	   </td>
	   <td>
	      <a href="/AlphabloxTooling/PreviewReport.jsp?reportName={$theid}">view</a>
	      <a href="/AlphabloxTooling/TraceReport.jsp?reportName={$theid}">trace</a>
	      <a href="/AlphabloxTooling/reports/{$theid}">download</a>
	      <a href="/AlphabloxTooling/DeleteObject.jsp?objectName=reports/{$theid}">delete</a>
	   </td>
	</tr>
</xsl:template>


</xsl:stylesheet>
