package fastforward;

import com.alphablox.blox.DataViewBlox;
import com.alphablox.blox.uimodel.GridBrixCellModel;
import com.alphablox.blox.uimodel.core.MessageBox;
import com.alphablox.blox.uimodel.core.event.DoubleClickEvent;
import com.alphablox.blox.uimodel.core.event.IEventHandler;
import com.alphablox.blox.uimodel.core.event.RightClickEvent;
import com.alphablox.blox.uimodel.core.grid.Grid;
import com.alphablox.blox.uimodel.core.grid.GridCell;
import com.alphablox.blox.uimodel.tags.layout.AbstractLayout;

/**
 * Copyright 2003 Alphablox Corporation. All rights reserved.
 * User: CEUBANKS
 * Date: Apr 12, 2003 8:29:51 PM
 */
public class LockedColumnLayout extends AbstractLayout {


    protected String getFormatName() {
        return "Locked Columns Layout";
    }


    /**
     * Add an event handler to control right click and double click events.
     * @param gridCell
     * @param dataViewBlox
     * @throws Exception
     */
    protected void layoutCell(GridCell gridCell, DataViewBlox dataViewBlox) throws Exception {
        Grid grid = gridCell.getGrid();
        grid.getController().addEventHandler(new ClickControl());
    }

}

/**
 * Prevent double click events, only allow right click on row header cells.
 */
class ClickControl implements IEventHandler {
    public boolean handleDoubleClickEvent(DoubleClickEvent event) throws Exception {
        GridBrixCellModel gridModel = (GridBrixCellModel) event.getComponent();
        if (gridModel.isRowHeader())
            return false;
        //TODO I18N
        MessageBox.message(event.getComponent(), "Double Click", "Double clicking only allowed on row headers for this report");
        return true;
    }

    public boolean handleRightClickEvent(RightClickEvent event) {
        GridBrixCellModel gridModel = (GridBrixCellModel) event.getComponent();
        if (gridModel.isRowHeader())
            return false;
        //TODO I18N        
        MessageBox.message(event.getComponent(), "Right Click", "The menu is only available on row headers for this report");
        return true;
    }
}