/**
 * Copyright 2002 Alphablox Corporation. All rights reserved.
 * User: CEUBANKS
 * Date: Nov 20, 2002 4:05:35 PM
 */
package fastforward;

import com.alphablox.blox.uimodel.core.ModelException;
import com.alphablox.blox.form.FormBlox;
import com.alphablox.blox.ContainerBlox;
import com.alphablox.blox.BloxContext;
import com.alphablox.blox.BloxContextFactory;
import com.alphablox.blox.BloxRequest;
import com.alphablox.blox.form.IFormBlox;

import javax.servlet.jsp.PageContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.io.PrintWriter;

import fastforward.Report;
import fastforward.Parameter;

public class TemplateHelper {

    public static void applySavedParameters(PageContext pageContext) throws ModelException {
        HttpSession session = pageContext.getSession();
        BloxContext bloxContext = (BloxContext)session.getAttribute(BloxContext.BLOX_CONTEXT_ATTR);
        HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();
        Report report = (Report) request.getAttribute("report");
        TemplateImpl template = (TemplateImpl) request.getAttribute("template");
        Parameter[] parameters = template.getParameters();
        for (int i = 0; parameters != null && i < parameters.length; i++) {
            Parameter parameter = parameters[i];
            IFormBlox formBlox = (IFormBlox) bloxContext.getBlox(parameter.getName());
            String[] values = report.getParameterValues(parameter.getName());
            if (formBlox != null && values != null && values.length > 0) {
                formBlox.setFormValues(report.getParameterValues(parameter.getName()));
                formBlox.changed();
            }
        }
    }

    public static void renderControls(PageContext pageContext) throws Exception {
        PrintWriter out = pageContext.getResponse().getWriter();
        HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();
        TemplateImpl template = (TemplateImpl) request.getAttribute("template");
        Parameter[] parameters = template.getParameters();
        int count = 0;
        for (int i = 0; parameters != null && i < parameters.length; i++) {
            Parameter parameter = parameters[i];
            // for now, blowoff MDBQueryEdit....
            ContainerBlox blox = (ContainerBlox) pageContext.getAttribute(parameter.getName());
            if (blox instanceof FormBlox) {
                FormBlox formBlox = (FormBlox) blox;
                String currStyle = count % 2 == 0 ? "clsFFParamEven" : "clsFFParamOdd";
                out.print("<tr class=\""+currStyle+"\"><td>"+nobreak(parameter.getLabel())+"&nbsp;</td><td width=\"80%\">");
                BloxContext bloxContext = BloxContextFactory.getBloxContext(pageContext.getRequest(), pageContext.getResponse());
                BloxRequest bloxRequest = bloxContext.registerRequest(pageContext.getRequest(), pageContext.getResponse());
                formBlox.render(bloxRequest, out);
                out.println("</td></tr>");
                count++;
            }
        }
    }

    private static String nobreak(String in) {
        StringBuffer out = new StringBuffer(in.length());
        for (int i = 0; i < in.length(); i++) {
            if (in.charAt(i) == ' ') {
                out.append("&nbsp;");
            }
            else out.append(in.charAt(i));
        }
        return out.toString();
    }
}
