@echo off
setlocal
REM ***************************************************************
REM  Licensed Material - Property of IBM
REM 
REM  5724-M24 
REM 
REM  Copyright IBM Corp. 2010.  All rights reserved.
REM 
REM  US Government Users Restricted Rights - Use, duplication or
REM  disclosure restricted by GSA ADP Schedule Contract with IBM
REM  Corp.
REM ***************************************************************


REM ***************************************************************
REM  Be sure to update updateAlphablox.properties to your configuration
REM ***************************************************************

FOR /F "tokens=*" %%i in ('find /v"#" ^< updateAlphablox.properties') do SET %%i

SET                                                        

REM ******************************************************
@echo -                            
@echo  START of update task execution
REM ******************************************************


SET CURRENT_DIR="%CD%"
CD.. 
SET WBM_LOC="%CD%"
CD %CURRRNT_DIR%
         
REM ******************************************************
REM  Copy files to the Deployment Manager 
REM ******************************************************

@echo -                            
@echo -                            
@echo move the WAS plugins to be used
if exist %WBM_LOC%\plugins erase %WBM_LOC%\plugins /Q
mkdir %WBM_LOC%\plugins
if %WAS_VERSION% == 61 copy %WBM_LOC%\abx.62.plugins\plugins %WBM_LOC%\plugins 
if %WAS_VERSION% == 70 copy %WBM_LOC%\abx.70.plugins\plugins %WBM_LOC%\plugins 
@echo move logging support jar
copy %WBM_LOC%\temp\was602\lib\wbminstall_log.jar %WAS_LOC%\lib  
if [%ERRORLEVEL%] GTR [0] GOTO END 


@echo -                            
@echo -                            
@echo Install files task                            
call %WAS_LOC%\bin\ws_ant -Dwbm.portdash.installed.id=700 -Dwbm.install.instance.id=70 -Dwbm.installType.PortalDashboard=installNewPortalDashboard -Dinstall.widgets.nativePortlets=%DASHBOARD_INSTALL% -Dwbm.install.abx.portalviews="true" -Dwas602.install.root=%WAS_LOC% -Dwas.install.root=%WBM_LOC% -Dportal.install.root=%WBM_LOC% -Dportal.profileType=deploymentManager -DtraceLevel=all -f %WBM_LOC%\actions\CopyPortalDashboardFiles.ant
if [%ERRORLEVEL%] GTR [0] GOTO END 
@echo -                            
@echo -                            
@echo Initialize new plugins
call %WAS_PROFILE_PATH%\bin\osgiCfgInit.bat

REM the location variable
if "%PROFILE_TYPE%" == ""standAlone"" GOTO NEXT3
GOTO END

:NEXT3
REM ******************************************************
@echo -                            
@echo -                           
@echo  Update Alphablox service ears
REM ******************************************************
 
call %WAS_LOC%\bin\ws_ant -Dportal.profile.name=%WAS_PROFILE% -Dwbm.install.abx.portalviews="true" -Dwas602.install.root=%WAS_LOC% -Dwas.install.root=%WBM_LOC% -Dportal.install.root=%WBM_LOC% -Dportal.profile.path=%WAS_PROFILE_PATH% -DtraceLevel=all -f %WBM_LOC%\actions\UpdateABXears.ant
if [%ERRORLEVEL%] == [0] GOTO NEXT4
  echo "check log %WAS_LOC%\profiles\%WAS_PROFILE%\logs\updateABXears.log"  
  GOTO END


:NEXT4
@echo -                            
@echo - 
 
:END
endlocal
@echo on


