######################################################################
#
#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2008, 2009. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#  
######################################################################

# Profile Template related directories
washome = "[washome]"
templatePath = "[templatePath]"
moncommonPath = "[commonPath]"
monserverPath = "[monserverPath]"
dmsServicePath = "[dmsServicePath]"
mondashPath = "[mondashPath]"
monadminPath = "[monadminPath]"
mondatabasePath = "[mondatabasePath]"
restServicesPath = "[restServicesPath]"
vmmServicePath = "[vmmServicePath]"
cbebrowserPath = "[cbebrowserPath]"
systemAppPath = "[systemAppPath]"
restproxyPath = "[restproxyPath]"



#
#JVM heap size constants
#
productionMinHeapSize = "512"
productionMaxHeapSize = "1536"
uteMinHeapSize = "128"
uteMaxHeapSize = "1024"

#
# Overall constants
#
busAliasUsername = "[busAliasUsername]"
busAliasPassword = "[busAliasPassword]"
cellName = "[cellName]"
nodeName = "[nodeName]"
serverName = "[serverName]"
clusterName = "[clusterName]"
isUTE = "[isUTE]"
ndType = "[ndType]"
monitorHome = "[monitorHome]"
busAliasName = "MonitorBusAuth"
busDesc = "'Bus for Monitor'"
ceiAlreadyDeployed ="[ceiAlreadyDeployed]"
ceiDbAlreadyConfigured = "[ceiDbAlreadyConfigured]"
enableAdminSecurity = "[enableAdminSecurity]"

#
# Database and database related constants.
#
dbType = "[dbType]"
S_COMMON_DB_DERBY_EMBEDDED = "DERBY_EMBEDDED"
S_COMMON_DB_DB2 = "DB2_Universal"
S_COMMON_DB_ORACLE_11g = "Oracle11g"
S_COMMON_DB_DB2_ZOS_8 = "DB2UDBOS390_V8_1"
S_COMMON_DB_DB2_ZOS_9 = "DB2UDBOS390_V9_1"
jdbcProviderName = "MonitorDBProvider"
jdbcProviderDesc = "[jdbcProviderDesc]"
jdbcProviderImplClass = "[jdbcProviderImplClass]"
dmsJdbcProviderName = "MonitorDMSDBProvider"
dmsJdbcProviderDesc = "[dmsJdbcProviderDesc]"
dmsJdbcProviderImplClass = "[dmsJdbcProviderImplClass]"
jdbcProviderClassPath = "[jdbcProviderClassPath]"
DB2_JDBC_DRIVER_NATIVEPATH = "[DB2_JDBC_DRIVER_NATIVEPATH]"
JDBC_DRIVER_PATH = "[JDBC_DRIVER_PATH]"

databaseName = "[databaseName]"
derbyDBLocation = "[derbyDBLocation]"
datasourceDriverType = "[datasourceDriverType]"
datasourceServerName = "[datasourceServerName]"
datasourcePortNumber = "[datasourcePortNumber]"
datasourceAdminAuthAliasUsername = "[datasourceAdminAuthAliasUsername]"
datasourceAdminAuthAliasPassword = "[datasourceAdminAuthAliasPassword]"
datasourceAuthAliasUsername = "[datasourceAuthAliasUsername]"
datasourceAuthAliasPassword = "[datasourceAuthAliasPassword]"
datasourceHelperClassname = "[datasourceHelperClassname]"

datasourceName = "Monitor_Database"
datasourceDesc = "XA DataSource for Monitor Database"
datasourceJndi = "jdbc/wbm/MonitorDatabase"
datasourceMaxConnections = "100"

routingDatasourceName = "Monitor_" + cellName + "_Routing_Database"
routingDatasourceDesc = "XA DataSource for Monitor Routing Database"
routingDatasourceJndi = "jdbc/wbm/" + cellName + "/MonitorDatabase"

datasourceAdminAuthAliasName = "Monitor_Admin_JDBC_Alias"
datasourceAdminAuthAliasDesc = "Authentication for " + datasourceAdminAuthAliasName

datasourceAuthAliasName = "Monitor_JDBC_Alias"
datasourceAuthAliasDesc = "Authentication for " + datasourceAuthAliasName

#
# DMS data store constants
#
dmsDatasourceName = "Monitor_DMS_Database"
dmsDatasourceDesc = "Non XA DataSource for Monitor DMS Database"
dmsDatasourceJndi = "jdbc/wbm/MonitorDMSDatabase"
# REST Services Proxy config values
restServicesHost = "[restServicesHost]"
restServicesPort = "[restServicesPort]"
restServicesSecurePort = "[restServicesSecurePort]"
bspaceServicesHost = "[bspaceServicesHost]"
bspaceServicesPort = "[bspaceServicesPort]"
bspaceServicesSecurePort = "[bspaceServicesSecurePort]"

#
# Message Store type 
#
msFileStore="[msFileStore]"
msDataStore="[msDataStore]"

#
# Messaging engine's data store constants
#
meDatasourceName = "Monitor_ME_Database"
meDatasourceDesc = "XA DataSource for Monitor Messaging Engine Database"
meDatasourceJndi = "jdbc/wbm/MonitorMEDatabase"
dataStoreDefaultDataSource ="[dataStoreDefaultDataSource]"
dataStoreExistingDataSource = "[dataStoreExistingDataSource]"
dataStoreJndiName="[dataStoreJndiName]"
dataStoreDefaultSchemaName = "IBMWSSIB"
dataStoreDefaultWBMSchemaName = "MONME00"
dataStoreDefaultCEISchemaName = "MONCM00"
dataStoreSchemaName="[dataStoreSchemaName]"
dataStoreAuthAlias = "[dataStoreAuthAlias]"
dataStoreCreateTables = "[dataStoreCreateTables]"

#
# Messaging engine's file store constants.
#
meLogDirectory = "[meLogDirectory]" 
mePermanentStoreDirectory = "[mePermanentStoreDirectory]"
meTemporaryStoreDirectory = "[meTemporaryStoreDirectory]"

#
# Monitor Queue Constants
#
qcfAuthAliasName = "MonitorQueueConnectionFactoryAuth"
qcfAuthAliasDesc = "Authentication for " + qcfAuthAliasName + ".  Set if security enabled"
qcfAuthAliasUsername = "[qcfAuthAliasUsername]"
qcfAuthAliasPassword = "[qcfAuthAliasPassword]"


#
# Event Emitter constants
#
eeAuthAliasName = "EventEmitterAlias"
eeAuthAliasDesc = "Event Emitter Authentication Alias"
eeAuthAliasUsername = "[eeAuthAliasUsername]"
eeAuthAliasPassword = "[eeAuthAliasPassword]"

adminDatasourceName = "Monitor_Admin_Database"
adminDatasourceDesc = "XA DataSource for Monitor Admin Database"
adminDatasourceJndi = "jdbc/wbm/MonitorAdminDatabase"

emitterFactoryName = "MonitorEmitterFactory"
emitterFactoryJndi = "com/ibm/monitor/MonitorEmitterFactory"
emitterFactoryDesc = "Emitter Factory for the Monitor Application"
emitterFactorySyncJndi = "com/ibm/events/configuration/bus-transmission/Default"

#
# Define Lifecycle WorkManager constants
#
lcwmName  = "MonitorLifecycleWorkManager"        
lcwmJndi  = "wm/wbm/Lifecycle"        
lcwmDesc  = "Monitor Lifecycle WorkManager"        
lcwmIsGrowable = "true"   
lcwmMinThreads = 2 
lcwmMaxThreads = 12 
lcwmThreadPriority = 5
lcwmServiceNames = "security"
monitorHomeProperty = "mon.install.root"

# Define ActionManager constants
aamEarName = "monactionmgr"
aamAppname = "IBM_WBM_ACTIONSERVICES"
aamQConnFactoryName = "Action Services QueueConnFactory"
aamQConnFactoryJndi = "jms/ActionManager/QueueConnFactory"
aamQDestName = "ActionManagerQueueDestination"
aamQName = "Action Services Queue"
aamQJndi = "jms/ActionManager/Queue"
aamActivationSpecName = "Action Services ActivationSpec"
aamActivationSpecJndi = "jms/ActionManager/ActivationSpec"
aamEventGroupName = "Action Services Group Profile"
aamEventSelectorString = "CommonBaseEvent[extendedDataElements/@name = 'BusinessSituationName']"

# Define Events Record constants
erEventGroupName = "Monitor Event Archiving"
erEventSelectorString = "jdbc/wbm/MonitorDatabase:MONITOR:true"
erCompatibilityDescription = "Compatibility mode with previous event service transmission protocol"
erSelectorClassDescription = "Fully qualified name of a custom event selector filter class"
erSelectorClass = "com.ibm.wbimonitor.router.record.ceiext.EventRecordingSelector"
    
# Define DMSService constants
dmsServiceEarName = "MonitorDataServices"
dmsServiceAppname = "IBM_WBM_DATA_SERVICES"

# Define MSSService constants
mssServiceEarName = "IBM_WBM_MSS_SERVICE"
mssServiceAppname = " IBM_WBM_MSS_SERVICE"

# Define Dashboard constants
webDashboardEarName = "WBMDashboardWeb"
webDashboardAppname = "IBM_WBM_WEB_DASHBOARD" 
webDashboardRolename1 = "Administrator"

# Define Mobile Dashboard constants
webMobileDashboardEarName = "MobileDashboard"
webMobileDashboardAppname = "IBM_WBM_MOBILE_DASHBOARD" 
webMobileDashboardRolename1 = "Administrator"

# Define ABX WEB Dashboard constants
abxWebDashboardEarName = "WBMDashboardABX"
abxWebDashboardAppname = "IBM_WBM_ABX_WEB_DASHBOARD" 

# Define Dashboard REST Services Proxy constants
dashboardRestProxyEarName = "WBMDashboardRESTProxy"
dashboardRestProxyAppname = "IBM_WBM_REST_PROXY"
dashboardRestProxyTargetPropertyName = "DashboardRESTServiceTarget"
dashboardRestProxyTargetPropertyValue = "localhost:9080"
dashboardRestProxySecureTargetPropertyName = "DashboardRESTServiceSecureTarget"
dashboardRestProxySecureTargetPropertyValue = "localhost:9443"
dashboardBSpaceProxyTargetPropertyName = "BusinessSpaceTarget"
dashboardBSpaceProxyTargetPropertyValue = "localhost:9080"
dashboardBSpaceProxySecureTargetPropertyName = "BusinessSpaceSecureTarget"
dashboardBSpaceProxySecureTargetPropertyValue = "localhost:9443"

# Define REST Services constants
restServicesEarName = "MonitorRestServices"
restServicesWarName = "restservices"
restServicesAppname = "IBM_WBM_REST_SERVICES" 

# Define Emitter REST Services constants
emitterRestServicesEarName = "EmitterServices"
emitterRestServicesWarName = "eventEmitter"
emitterRestServicesAppname = "IBM_WBM_EMITTER_SERVICES" 

# Define VMM Services constants
wimEarName = "wim"
wimAppName = "wim"
wimwmmEarName = "wimwmm"
wimwmmAppName = "wimwmm"

# Define CBE Browser constants
cbebrowserEarName = "cbebrowser"
cbebrowserAppName = "cbebrowser"

# Define Human Task constants
wpsHost = "[wpsHost]"
wpsRMIPort = "[wpsRMIPort]"
configureHumanTask= "[configureHumanTask]"
humanTaskEarName = "GlobalHTMMApplication"
humanTaskAppname = "IBM_WBM_HUMAN_TASK_MONITOR_MODEL" 

# Define Global Process constants
configureGlobalProcessTask= "[configureGlobalProcessTask]"
globalProcessTaskEarName = "GlobalProcessMonitorApplication"
globalProcessTaskAppname = "IBM_WBM_GLOBAL_PROCESS_MONITOR" 

# Define REST Services Proxy constants
restproxyEarName = "WBMDashboardRESTProxy"
restproxyAppName = "IBM_WBM_REST_PROXY"

# Define Monitor Model constants
monitorModelDBDir = "[monitorModelDBDir]"

# Define Business Space constants
bspaceDatasourceName = "Business Space Datasource"
bspaceDatasourceDesc = "DataSource for Business Space Database"
bspaceDatasourceJndi = "jdbc/bpm/BusinessSpace"
bspaceEarName = "com.ibm.bspace.manager"
bspaceAppname = "Business Space Manager EAR"

