######################################################################
# IBM Confidential
# OCO Source Materials
# 5724-M24
# (C) Copyright IBM Corporation 2005, 2009
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
######################################################################

import java

#
# imports for the logger
#
from com.ibm.wbmonitor.install.common.log import LogFactory
from com.ibm.wbmonitor.install.common.log import ILogger
from com.ibm.wbmonitor.install.common.log import ITracer
from com.ibm.wbmonitor.install.common.log import LogConstants

#
# set up the logger
#
trc = LogFactory.createTracer(LogConstants.WBM_INSTALL_GROUP_NAME, LogConstants.PORTDASH)
log = LogFactory.createLogger(LogConstants.WBM_INSTALL_GROUP_NAME, LogConstants.PORTDASH)



# get line separator 
lineSeparator = java.lang.System.getProperty('line.separator') 

class UtilWsadminHolder:
	AdminConfig = None
	AdminTask = None


class BusInfo:
# instance variables are.... They are created in __init__ so they don't end up Class variables
#	name
#	desc
#	authAliasName

	def __init__(self, name, desc, authAliasName):
		self.name = name
		self.desc = desc
		self.authAliasName = authAliasName

class AuthAliasInfo:
# instance variables are.... They are created in __init__ so they don't end up Class variables
#	name
#	desc
#	userId
#	password
	
	def __init__(self, name, desc, userId, password):
		print  "--- parms for datasourceAuthAliasInfo"
		print  "datasourceAuthAliasName         =  " + name
		print  "datasourceAuthAliasDesc         =  " + desc
		print  "datasourceAuthAliasUsername     =  " + userId
		print  "datasourceAuthAliasPassword     =  " + "******"
		self.name = name
		self.desc = desc
		self.userId = userId
		self.password = password

class JdbcProviderInfo:
# instance variables are.... They are created in __init__ so they don't end up Class variables
#	name
#	desc
#	implClass
#	driverFile
	
	def __init__(self, name, desc, implClass, driverFile):
		print  "--- parms for jdbcProviderInfo"
		print  "jdbcProviderName                =  " + name
		print  "jdbcProviderDesc                =  " + desc
		print  "jdbcProviderImplClass           =  " + implClass
		print  "jdbcProviderClasspath           =  " + driverFile
		self.name = name
		self.desc = desc
		self.implClass = implClass
		self.driverFile = driverFile

class DatasourceInfo:
# instance variables are.... They are created in __init__ so they don't end up Class variables
#	name
#	desc
#	jndiName
#	helperClassname
#	maxConnections
#	props #map
#	providerName
#	authAliasName
	
	def __init__(self, name, desc, jndiName, helperClassname, maxConnections, props, providerName, authAliasName):
		print  "--- parms for DatasourceInfo"
		print  "datasourceName                 =  " + name
		print  "datasourceDesc                 =  " + desc
		print  "datasourceJndi                 =  " + jndiName
		print  "datasourceHelperClassname      =  " + helperClassname
		print  "datasourceMaxConnections       =  " + maxConnections
		#print  "datasourceProps               =  " + props
		print  "jdbcProviderName               =  " + providerName
		print  "datasourceAuthAliasName        =  " + authAliasName
		self.name = name
		self.desc = desc
		self.jndiName = jndiName
		self.helperClassname = helperClassname
		self.maxConnections = maxConnections
		self.props = props
		self.providerName = providerName
		self.authAliasName = authAliasName
	
	def getProps(self):
		ret = []
		nameValPairs = self.props.items()
		for i in range(len(nameValPairs)):
			ret.append([["name", nameValPairs[i][0]], ["value", nameValPairs[i][1]]])
		return ret

class CmpFactoryInfo:
# instance variables are.... They are created in __init__ so they don't end up Class variables
#	name
#	providerName
#	datasourceName
#	authAliasName
	
	def __init__(self, name, providerName, datasourceName, authAliasName):
		self.name = name
		self.providerName = providerName
		self.datasourceName = datasourceName
		self.authAliasName = authAliasName

class EmitterFactoryInfo:
# instance variables are.... They are created in __init__ so they don't end up Class variables
#	name
#	jndi
#	desc
#	asyncJndi
#	syncJndi
	
	def __init__(self, name, jndi, desc, asyncJndi, syncJndi):
		self.name = name
		self.jndi = jndi
		self.desc = desc
		self.asyncJndi = asyncJndi
		self.syncJndi = syncJndi

class WorkManagerInfo:
# instance variables are.... They are created in __init__ so they don't end up Class variables
# name                     "MyScheduler WorkManager"                      
# jndi                     "wm/MySchedWorkManager"                        
# desc                     "Monitor Lifecycle WorkManager"                        
# minThreads               3                                              
# maxThreads               10                                             
# isGrowable               true                                          
# threadPriority           5                                              
# serviceNames             security 

	def __init__(self, name, jndiName, desc, minThreads, maxThreads, isGrowable, threadPriority, serviceNames):
		self.name             = name          
		self.jndiName         = jndiName          
		self.desc             = desc          
		self.minThreads       = minThreads   
		self.maxThreads       = maxThreads   
		self.isGrowable       = isGrowable    
		self.threadPriority   = threadPriority
		self.serviceNames     = serviceNames

class Scope:
	CLUSTER_SCOPE = 1
	CELL_SCOPE = 2
	NODE_SCOPE = 3
	SERVER_SCOPE = 4
# instance variables are...
#	cell
#	node
#	server
#	cluster
	
	def __init__(self, cluster, cell, node, server):
		self.cluster = cluster
		self.cell = cell
		self.node = node
		self.server = server
		self.containmentPathMap = {}
		self.containmentPathMap[Scope.CLUSTER_SCOPE] = "/Cell:" + cell + "/Cluster:" + cluster + "/"
		self.containmentPathMap[Scope.CELL_SCOPE] = "/Cell:" + cell + "/"
		self.containmentPathMap[Scope.NODE_SCOPE] = "/Cell:" + cell + "/Node:" + node + "/"
		self.containmentPathMap[Scope.SERVER_SCOPE] = "/Cell:" + cell + "/Node:" + node + "/Server:" + server + "/"

	def getConfigId(self, scopeLevel):
		return UtilWsadminHolder.AdminConfig.getid(self.getContainmentPath(scopeLevel))

	def getContainmentPath(self, scopeLevel):
		return self.containmentPathMap[scopeLevel]



def doesBusExist(busName):
	try:
		print "Looking for bus " + busName
		UtilWsadminHolder.AdminTask.showSIBus("-bus " + busName)
		print "Bus " + busName + "exists"
		return "true"
	except: 
		print "Bus " + busName + " not found"
		return None

def createBus(busInfo):
	# this seems to automatically add the server as a bus member
	busCreateArgs = "-bus " + busInfo.name + " -interEngineAuthAlias " + busInfo.authAliasName + " -description " + busInfo.desc
	print "Create Bus with:", busCreateArgs
	UtilWsadminHolder.AdminTask.createSIBus(busCreateArgs)

def removeBus(busName):
	UtilWsadminHolder.AdminTask.deleteSIBus("-bus " + busName)

def getAuthenticationAliasConfigId(aliasName):
	print "List all Aliases"
	allAuthAliasString = UtilWsadminHolder.AdminConfig.list("JAASAuthData")
	allAuthAliasArray = allAuthAliasString.split(lineSeparator)
	aliasConfigId = None
	
	print "Checking Aliases for a match to " + aliasName
	for i in range(len(allAuthAliasArray)):
		print "allAuthAliasArray[i]="+str(allAuthAliasArray[i])
		if(len(allAuthAliasArray[i]) > 0):
			if (UtilWsadminHolder.AdminConfig.showAttribute(allAuthAliasArray[i], "alias") == aliasName):
				print "Found Alias: " + allAuthAliasArray[i]
				aliasConfigId = allAuthAliasArray[i]
	
	return aliasConfigId

def createAuthenticationAlias(authAliasInfo):
	aliasConfigId = getAuthenticationAliasConfigId(authAliasInfo.name)
	
	if (aliasConfigId == None): # go ahead and create it
		aliasCreateArgs = [["alias", authAliasInfo.name], ["description", authAliasInfo.desc], ["userId", authAliasInfo.userId], ["password", authAliasInfo.password]]
		parent = UtilWsadminHolder.AdminConfig.getid("/Security:/")
		print "Create Alias with: alias: " + authAliasInfo.name + " description: " + authAliasInfo.desc + " userId: " + authAliasInfo.userId
		aliasConfigId = UtilWsadminHolder.AdminConfig.create("JAASAuthData", parent, aliasCreateArgs)
	
	return aliasConfigId

def getJdbcProviderConfigId(scope, scopeLevel, providerName):
	providerConfigId = UtilWsadminHolder.AdminConfig.getid(scope.getContainmentPath(scopeLevel) + "JDBCProvider:" + providerName + "/")
	
	if (providerConfigId == ""):
		print "Did not find JDBC Provider: " + providerName
		return None
	else:
		print "Found JDBC Provider: " + providerConfigId
		return providerConfigId

def createJdbcProvider(scope, scopeLevel, providerInfo):
	providerConfigId = getJdbcProviderConfigId(scope, scopeLevel, providerInfo.name)
	
	if (providerConfigId == None): # go ahead and create it
		db2ProviderImplClass = "com.ibm.db2.jcc.DB2XADataSource"
		providerCreateArgs = None
		if (providerInfo.implClass == db2ProviderImplClass):
			providerCreateArgs = [["name", providerInfo.name], ["description", providerInfo.desc], ["implementationClassName", providerInfo.implClass], ["classpath", providerInfo.driverFile], ["nativepath", "${DB2UNIVERSAL_JDBC_DRIVER_NATIVEPATH}"]]
		else:
			providerCreateArgs = [["name", providerInfo.name], ["description", providerInfo.desc], ["implementationClassName", providerInfo.implClass], ["classpath", providerInfo.driverFile]]
		parent = scope.getConfigId(scopeLevel)
		print "Create JDBC Provider with:", providerCreateArgs
		providerConfigId = UtilWsadminHolder.AdminConfig.create("JDBCProvider", parent, providerCreateArgs)
	
	return providerConfigId

# Queries WAS for datasource existance
def getDatasourceConfigId(scope, scopeLevel, providerName, datasourceName):
	trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "getDatasourceConfigId", "Entry")
	datasourceConfigId = UtilWsadminHolder.AdminConfig.getid(scope.getContainmentPath(scopeLevel) + "JDBCProvider:" + providerName + "/DataSource:" + datasourceName + "/")
	if (datasourceConfigId == ""):
        	trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "getDatasourceConfigId", "Did not find Datasource: " + datasourceName + " under " + providerName)
		print "Did not find Datasource: " + datasourceName + " under " + providerName
		return None
	else:
        	trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "getDatasourceConfigId", "Found Datasource: " + datasourceConfigId + " under " + providerName)
		print "Found Datasource: " + datasourceConfigId + " under " + providerName
		return datasourceConfigId
	
def createDatasource(scope, scopeLevel, datasourceInfo):
	print ">> createDatasource"
	datasourceConfigId = getDatasourceConfigId(scope, scopeLevel, datasourceInfo.providerName, datasourceInfo.name)
	
	if (datasourceConfigId == None): # go ahead and create it
		nameAttr = ["name", datasourceInfo.name]
		descAttr = ["description", datasourceInfo.desc]
		jndiAttr = ["jndiName", datasourceInfo.jndiName]
		statementCacheSizeAttr = ["statementCacheSize","100"]
		helpAttr = ["datasourceHelperClassname", datasourceInfo.helperClassname]
		authAttr = ["authDataAlias", datasourceInfo.authAliasName]
		authMechAttr = ["authMechanismPreference", "BASIC_PASSWORD"]
		mappingAttr = ["mapping", [["authDataAlias", datasourceInfo.authAliasName], ["mappingConfigAlias", "DefaultPrincipalMapping"]]]
		
		datasourceCreateArgs = [nameAttr, descAttr, jndiAttr, statementCacheSizeAttr, helpAttr, authAttr, authMechAttr, mappingAttr]
		
		providerId = getJdbcProviderConfigId(scope, scopeLevel, datasourceInfo.providerName)
		if (providerId != None):
			print "Got the provider"
			print "Create Datasource with:", datasourceCreateArgs
			datasourceConfigId = UtilWsadminHolder.AdminConfig.create("DataSource", providerId, datasourceCreateArgs)
			
			# now update the pool
			print "Update the pool for:", datasourceCreateArgs
			datasourcePool = UtilWsadminHolder.AdminConfig.list("ConnectionPool", datasourceConfigId)
			UtilWsadminHolder.AdminConfig.modify(datasourcePool, [["maxConnections", datasourceInfo.maxConnections]])
			
			# now update the properties
			print "Update the properties for:", datasourceCreateArgs
			propSetConfigId = UtilWsadminHolder.AdminConfig.create("J2EEResourcePropertySet", datasourceConfigId, [])
			props = datasourceInfo.getProps()
			for i in range(len(props)):
				UtilWsadminHolder.AdminConfig.create("J2EEResourceProperty", propSetConfigId, props[i])

def createCmpFactory(scope, scopeLevel, cmpFactoryInfo):
	print "List all Resource Adapters"
	resourceAdapterString = UtilWsadminHolder.AdminConfig.list("J2CResourceAdapter", scope.getConfigId(scopeLevel))
	resourceAdapterArray = resourceAdapterString.split(lineSeparator)
	resourceAdapterConfigId = None
	
	print "Checking Resource Adapters for a match to " + "WebSphere Relational Resource Adapter"
	for i in range(len(resourceAdapterArray)):
		if (resourceAdapterArray[i].find("WebSphere Relational Resource Adapter") != -1):
			print "Found Resource Adapter: " + "WebSphere Relational Resource Adapter"
			resourceAdapterConfigId = resourceAdapterArray[i]
	
	nameAttr = ["name", cmpFactoryInfo.name]
	authMechAttr = ["authMechanismPreference", "BASIC_PASSWORD"]
	dataAttr = ["cmpDatasource", getDatasourceConfigId(scope, scopeLevel, cmpFactoryInfo.providerName, cmpFactoryInfo.datasourceName)]
	authAttr = ["authDataAlias", cmpFactoryInfo.authAliasName]
	
	cmpFactoryCreateArgs = [nameAttr, authMechAttr, dataAttr, authAttr]

	print "Create CMP Factory with", cmpFactoryCreateArgs
	try:
	    cmpFactoryConfigId = UtilWsadminHolder.AdminConfig.create("CMPConnectorFactory", resourceAdapterConfigId, cmpFactoryCreateArgs)
	except:
	    print "error: CMP create failed."
	
	return cmpFactoryConfigId

def getEmitterFactory(scope, scopeLevel, emitterFactoryName):
	emitterFactoryConfigId = UtilWsadminHolder.AdminConfig.getid(scope.getContainmentPath(scopeLevel) + "EventInfrastructureProvider:EventInfrastructureProvider/EmitterFactoryProfile:" + emitterFactoryName + "/")
	
	if (emitterFactoryConfigId == ""):
		print "Did not find Emitter Factory: " + emitterFactoryName
		return None
	else:
		print "Found Emitter Factory: " + emitterFactoryConfigId
		return emitterFactoryConfigId

def createEmitterFactory(scope, scopeLevel, emitterFactoryInfo):
	emitterFactoryConfigId = getEmitterFactory(scope, scopeLevel, emitterFactoryInfo.name)
	
	if (emitterFactoryConfigId == None):
		nameAttr = ["name", emitterFactoryInfo.name]
		jndiAttr = ["jndiName", emitterFactoryInfo.jndi]
		descAttr = ["description", emitterFactoryInfo.desc]
		syncAttr = ["synchronousTransmissionProfileJNDIName", emitterFactoryInfo.syncJndi]
		filtAttr = ["filteringEnabled", "false"]
		
		emitterFactoryCreateArgs = [nameAttr, jndiAttr, descAttr, syncAttr, filtAttr]
		
		parentId = UtilWsadminHolder.AdminConfig.getid(scope.getContainmentPath(scopeLevel) + "EventInfrastructureProvider:EventInfrastructureProvider/")
		print "Create Emitter Factory Profile with", emitterFactoryCreateArgs
		emitterFactoryConfigId = UtilWsadminHolder.AdminConfig.create("EmitterFactoryProfile", parentId, emitterFactoryCreateArgs)

	return emitterFactoryConfigId


def getWorkManager(scope, scopeLevel, workManagerName):
	workManagerConfigId = UtilWsadminHolder.AdminConfig.getid("/WorkManagerInfo:" + workManagerName + "/" )
	
	if (workManagerConfigId == ""):
		print "Did not find WorkManager: " + workManagerName
		return None
	else:
		print "Found WorkManager: " + workManagerConfigId
		return workManagerConfigId

def createWorkManager(scope, scopeLevel, workManagerInfo):
	workManagerConfigId = getWorkManager(scope, scopeLevel, workManagerInfo.name)
	
	if (workManagerConfigId == None):
		nameAttr            = ["name"            , workManagerInfo.name            ]
		jndiNameAttr        = ["jndiName"        , workManagerInfo.jndiName        ]
		descAttr            = ["description"     , workManagerInfo.desc            ]
		minThreadsAttr      = ["minThreads"      , workManagerInfo.minThreads      ]
		maxThreadsAttr      = ["maxThreads"      , workManagerInfo.maxThreads      ]
		isGrowableAttr      = ["isGrowable"      , workManagerInfo.isGrowable      ]
        threadPriorityAttr  = ["threadPriority"  , workManagerInfo.threadPriority  ]
        serviceNamesAttr    = ["serviceNames"    , workManagerInfo.serviceNames    ]
        
        workManagerCreateArgs = [nameAttr, jndiNameAttr, descAttr, minThreadsAttr, maxThreadsAttr, isGrowableAttr, threadPriorityAttr, serviceNamesAttr]
        
        parentContainment = scope.getContainmentPath(scopeLevel) + "WorkManagerProvider:WorkManagerProvider/"
        parentId = UtilWsadminHolder.AdminConfig.getid(parentContainment)

        print "Create WorkManager with", workManagerCreateArgs, "under parent", parentId, "based on containment", parentContainment
        workManagerConfigId = UtilWsadminHolder.AdminConfig.create("WorkManagerInfo", parentId, workManagerCreateArgs)

	return workManagerConfigId

###################################################
#
# setSystemProperties
#
###################################################
def setSystemProperties(scope, props):
	trc.entry("MonitorSeverUtil", "setSystemProperties")
	if (props == None):
		return
	
	trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "setSystemProperties", "INFO: scope=", scope)
	trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "setSystemProperties", "INFO: props=", props)
	
        trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "setSystemProperties", "INFO: Get server config Id")
	serverCfgId = scope.getConfigId(Scope.SERVER_SCOPE)
	
	trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "setSystemProperties", "INFO: Find the JVM")
	myJVM = UtilWsadminHolder.AdminConfig.list("JavaVirtualMachine", serverCfgId)
	
	if (myJVM == None):
		# print "No suitable JVM was found for Cell=" + scope.cell + ", Node=" + scope.node + ", Server=" + scope.server
		trc.trace(ITracer.TYPE_LEVEL1, "MonitorSeverUtil", "setSystemProperties", "WARNING: No suitable JVM was found for Cell=" + scope.cell + ", Node=" + scope.node + ", Server=" + scope.server)
	else:
		trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "setSystemProperties", "INFO: Setting system porperties for Cell=" + scope.cell + ", Node=" + scope.node + ", Server=" + scope.server)
		nameValPairs = props.items()
		for i in range(len(nameValPairs)):
			currProperty = [["name", nameValPairs[i][0]], ["value", nameValPairs[i][1]]]
			#print "Setting:", currProperty
			trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "setSystemProperties", "INFO: Setting: ", currProperty)
			UtilWsadminHolder.AdminConfig.create("TypedProperty", myJVM, currProperty)
	
	trc.exit("MonitorSeverUtil", "setSystemProperties")
	return
#enddef	

###################################################
#
# removeSystemProperties
#
###################################################
def removeSystemProperties(scope, props):
	trc.entry("MonitorSeverUtil", "removeSystemProperties")

	if (props == None):
		return
	
	trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "removeSystemProperties", "INFO: scope=", scope)
	trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "removeSystemProperties", "INFO: props=", props)
	
        trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "removeSystemProperties", "INFO: Get server config Id")
	serverCfgId = scope.getConfigId(Scope.SERVER_SCOPE)
	
	trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "removeSystemProperties", "INFO: Find the JVM")
	myJVM = UtilWsadminHolder.AdminConfig.list("JavaVirtualMachine", serverCfgId)
	
	if (myJVM == None):
		# print "No suitable JVM was found for Cell=" + scope.cell + ", Node=" + scope.node + ", Server=" + scope.server
		trc.trace(ITracer.TYPE_LEVEL1, "MonitorSeverUtil", "removeSystemProperties", "WARNING: No suitable JVM was found for Cell=" + scope.cell + ", Node=" + scope.node + ", Server=" + scope.server)
	else:
		trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "removeSystemProperties", "INFO: Removing system porperties for Cell=" + scope.cell + ", Node=" + scope.node + ", Server=" + scope.server)
		allPropsString = UtilWsadminHolder.AdminConfig.list("TypedProperty", myJVM)
		allPropsArray = allPropsString.split(lineSeparator)
		propConfigId = None
		
		nameValPairs = props.items()
		# print "Checking", allPropsArray, " for a match to",  props
		trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "removeSystemProperties", "INFO: Checking ", allPropsArray)
		trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "removeSystemProperties", "INFO: for a match to ",  props)
		for i in range(len(allPropsArray)):
			if (allPropsArray[i] == ""):
				continue
			
			currPropertyName = UtilWsadminHolder.AdminConfig.showAttribute(allPropsArray[i], "name")
			for j in range(len(nameValPairs)):
				currCheckPropertyName = nameValPairs[j][0]
				# print "Checking: " + currPropertyName + " against " + currCheckPropertyName
				trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "removeSystemProperties", "INFO: Checking: " + currPropertyName + " against " + currCheckPropertyName)
				if (currPropertyName == currCheckPropertyName):
					# print "Matched"
					trc.trace(ITracer.TYPE_LEVEL3, "MonitorSeverUtil", "removeSystemProperties", "INFO: Match found for "+currPropertyName)
					UtilWsadminHolder.AdminConfig.remove(allPropsArray[i])
					
	trc.exit("MonitorSeverUtil", "removeSystemProperties")

	return
#enddef	


###################################################
#
# setJVMHeapSize 
#
###################################################
def setJVMHeapSize (scope, minJvmHeap, maxJvmHeap):
	serverCfgId = scope.getConfigId(Scope.SERVER_SCOPE)
	myJVM = UtilWsadminHolder.AdminConfig.list("JavaVirtualMachine", serverCfgId)
	
	if (myJVM == None):
		print "No suitable JVM was found for Cell=" + scope.cell + ", Node=" + scope.node + ", Server=" + scope.server
	else:
		try:
			print "Setting JVM Heap size with the following properties "
			minAttr = ["initialHeapSize",minJvmHeap]
			maxAttr = ["maximumHeapSize",maxJvmHeap]
			properties = [minAttr,maxAttr]
			print str(properties)
			UtilWsadminHolder.AdminConfig.modify(myJVM,properties)
		except: 
			print "Error: Setting JVM Heap size failed."

