######################################################################
# IBM Confidential
# OCO Source Materials
# 5724-M24
# (C) Copyright IBM Corporation 2005, 2007
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
######################################################################

import java

#
# imports for the logger
#
from com.ibm.wbmonitor.install.common.log import LogFactory
from com.ibm.wbmonitor.install.common.log import ILogger
from com.ibm.wbmonitor.install.common.log import ITracer
from com.ibm.wbmonitor.install.common.log import LogConstants

#
# set up the logger
#
trc = LogFactory.createTracer(LogConstants.WBM_INSTALL_GROUP_NAME, LogConstants.PORTDASH)
log = LogFactory.createLogger(LogConstants.WBM_INSTALL_GROUP_NAME, LogConstants.PORTDASH)
className = "uninstallHumanTask_py"

#############################################################
# main
#
# Install & Configure the REST Service Proxy Application on
# The WAS 6.0.2 server.  
#
#############################################################

methodName = "main"

trc.entry(className, methodName)

if ((len(sys.argv) != 1)):
        trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "This script (uninstallHumanTask.py) requires 1 parameter: profilePath")
        trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "e.g.: uninstallHumanTask.py /opt/WebSphere/Monitor/profiles/MonSrv01")
        raise ValueError	

# get the profile path
profilePath = sys.argv[0]
trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "profilePath="+profilePath)

# Load the installation parameters 
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')

# parameters needed from presets
trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "INFO: Parameters ==> clusterName="+clusterName+", cellName="+cellName+", nodeName="+nodeName+", serverName="+serverName)
trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "INFO: Parameters ==> wpsHost="+wpsHost+", wpsRMIPort="+wpsRMIPort)

installStep = "Portal Dashboard HumanTask"

# uninstall Human Task
log.msg(ILogger.TYPE_INFO, className, methodName, "CWMLP0010I", installStep)
trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "INFO: Uninstalling "+installStep+"...")

if(wpsHost != "None" and wpsRMIPort != "None"):
    if (ndType == "managed"):
        try:
            cellName = AdminControl.getCell()
        except:
            print "warning: AdminControl may not be available."    

    execfile(moncommonPath+'/MonitorServerUtil.py')
    
    # set custom jvm properties for human task
    jvmProperties = {}
    jvmProperties["DashboardBPCHost"] = wpsHost
    jvmProperties["DashboardBPCRMIPort"] = wpsRMIPort
    trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "INFO: Custom Property jvmProperties[DashboardBPCHost]    : " + jvmProperties["DashboardBPCHost"])
    trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "INFO: Custom Property jvmProperties[DashboardBPCRMIPort] : " + jvmProperties["DashboardBPCRMIPort"])
       
    UtilWsadminHolder.AdminConfig = AdminConfig
    UtilWsadminHolder.AdminTask = AdminTask

    # remove custom properties        
    scope = Scope(clusterName, cellName, nodeName, serverName)
    trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "INFO: scope=" + str(scope))
    trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "INFO: Removing Custom Properties.")
    removeSystemProperties(scope, jvmProperties)
    trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "INFO: Custom Properties removed.")

    trc.trace(ITracer.TYPE_LEVEL3, className, methodName, "INFO: Save the configuration changes")
    AdminConfig.save()
    
#endif

log.msg(ILogger.TYPE_INFO, className, methodName, "CWMLP0011I", installStep)

trc.exit(className, methodName)
       