/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.MashupFileDataStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.MashupFileDataStore"] = true;
dojo.provide("com.ibm.data.MashupFileDataStore");

dojo.require( "com.ibm.data.CatalogMixin" );
dojo.require("com.ibm.data.MashupHubStore");

dojo.declare("com.ibm.data.MashupFileDataStore", 
		[com.ibm.data.MashupHubStore,com.ibm.data.CatalogMixin],
		{	
				/********************************/
				/**                            **/
				/**                            **/
				/**  catalog extension point   **/
				/**                            **/
				/**                            **/
				/********************************/
				
			mapItem: function(/*item*/item){
				var map = {};
				map["id"] = this.getValue(item, "id", null);
				map["label"] = this.getValue(item, "catalogName", "untitled");
				map["description"] = this.getValue(item, "catalogDescription", "");
				map["tags"] = this.getValues(item, "catalogTags", "");
				map["rating"] = this.getValue(item, "catalogRating", 0.0);
				map["url"] = this.getValue(item, "catalogDownloadURL", "");
				map["type"] = this.getValue(item, "category", "");
				map["thumbnail"] = this.getValue(item, "catalogIcon", "");
				if(!map.thumbnail && builderConfig.builderPath) map["thumbnail"] = builderConfig.builderPath + "/images/gray_generic_feed_icon.png";
				return map;
			},
				
			prepareQuery: function(keywordArgs) {
				if(keywordArgs.query.keywords) {
					keywordArgs.query.searchTerms = keywordArgs.query.keywords.join(" ");
					keywordArgs.query.searchType = "";
					delete keywordArgs.query.keywords;
				}
				else if(keywordArgs.query.tags && keywordArgs.query.tags.length > 0) {
					keywordArgs.query.searchTerms = keywordArgs.query.tags[0];
					keywordArgs.query.searchType = "tag";
					delete keywordArgs.query.tags;
				}
				else {
					keywordArgs.query.searchTerms = "*";
					keywordArgs.query.searchType = "";
				}

				keywordArgs.query.nologin = "true";
				
				if(keywordArgs.sort&& keywordArgs.sort.length > 0) {
					switch(keywordArgs.sort[0].attribute) {
						case "date": 
							keywordArgs.query.sortBy = "updated";
							break;
						default:
							keywordArgs.query.sortBy = keywordArgs.sort[0].attribute;
					}
					keywordArgs.query.sortOrder = "asc";
					if(keywordArgs.sort[0].descending == true) {
						keywordArgs.query.sortOrder = "desc";
					}
				}
				
				if(keywordArgs.count) {
					keywordArgs.query.count = keywordArgs.count;
					if(keywordArgs.start == null) {
						keywordArgs.start = 0;
					}
					keywordArgs.query.startIndex = keywordArgs.start;
				}
				
				return keywordArgs;
			},
			
			validateSelf: function(){
				// summary: validates this datastore, if it does not validate the source will not be used
				// returns true for validation and false otherwise
				if(this.url.indexOf("undefined") < 0) return true
				else return false;
			}
});

}
