/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.data.resolver.OpenSearchPocHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.resolver.OpenSearchPocHandler"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.data.resolver.OpenSearchPocHandler");

dojo.require("com.ibm.data.resolver.AtomPocHandler");
dojo.require("com.ibm.query.rules.OpenSearch");

dojo.declare("com.ibm.data.resolver.OpenSearchPocHandler",
	com.ibm.data.resolver.AtomPocHandler,
	{
		bodyQueryRules: dojo.mixin({}, 
			com.ibm.data.resolver.AtomPocHandler.prototype.bodyQueryRules, 
			com.ibm.query.rules.OpenSearch.common
		),
		
		namespaces: dojo.mixin({}, 
			com.ibm.data.resolver.AtomPocHandler.prototype.namespaces,
			com.ibm.query.rules.OpenSearch.namespaces),
		
		processFetch: function(/*DOMDoc*/ xmlDoc, /*Request*/ request) {
			// summary: Extension point for descendants or consumers of this store to handle
			//		responses from server requests for data.  Most subclasses can leave this
			// 		function as-is, but if special handling is required that cannot be done
			// 		with other extension points, this can be overridden as well.
			// 		Must call onBegin, onItem, and onComplete callbacks correctly as 
			// 		specified by dojo.data.api.Read.  The onError callback is handled elsewhere.
			// xmlDoc: DOMDoc of the response from an IO request
			// request: Request used to fetch the result
			var composite = this.inherited(arguments);
			composite.meta.resultSize = this.engine.getByRule(composite.meta.root, this.bodyQueryRules["totalResults"]).value;
			composite.meta.nextURL = this.engine.getByRule(composite.meta.root, this.bodyQueryRules["nextLink"]).value;
			composite.meta.startIndex = this.engine.getByRule(composite.meta.root, this.bodyQueryRules["startIndex"]).value;
			composite.meta.itemsPerPage = this.engine.getByRule(composite.meta.root, this.bodyQueryRules["itemsPerPage"]).value;
			return composite;
		}
	}
);

}
