/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.lang.RequestQueue"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.lang.RequestQueue"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.lang.RequestQueue");

dojo.require("dojo.DeferredList");

dojo.declare("com.ibm.lang.RequestQueue",
	null,
	{
		parallel: true,
		
		constructor: function(args) {
			dojo.mixin(this, args);
			this._requests = [];
			this.fired = false;
		},
		
		add: function(/*String*/ method, /*dojo.__XhrArgs*/ args, /*Boolean?*/ hasBody) {
			var d = new dojo.Deferred();
			d.addCallback(dojo.hitch(this, function(){
				var myIdx = dojo.indexOf(this._requests, d);
				if(myIdx > -1) {
					this._requests.splice(myIdx, 1);  
				}
				return dojo.xhr(method, args, hasBody);
			}));
			this._requests.push(d);
			if(!this.parallel && this._requests.length > 1) {
				this._requests[this._requests.length - 2].addBoth(function(){d.callback();});
			}
			
			if(this.fired && this.parallel) {
				d.callback();
			}
			return this._createRetDeferred(d);
		},
		fire: function() {
			if(this.fired) throw new Error("Already fired!");
			else if(this.parallel) {
				for(var i=0; i<this._requests.length; i++) {
					this._requests[i].callback();
				}
			}
			else if(this._requests.length > 0){
				this._requests[0].callback();
			}
			this.fired = true;
		},
		_createRetDeferred: function(/*Deferred*/ def) {
			return (new dojo.DeferredList([def])).addCallback(function(resultArr){
				return resultArr[0][1];
			});
		}
	}
);

}
