<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:thr="http://purl.org/syndication/thread/1.0" 
    xmlns:atom="http://www.w3.org/2005/Atom" 
    xmlns:xhtml="http://www.w3.org/1999/xhtml" 
    xmlns:model="http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model-elements" 
    xmlns:base="http://www.ibm.com/xmlns/prod/websphere/portal/v6.0/ibm-portal-composite-base" 
    xmlns:portal="http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model" 
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >
<xsl:output method='html' version='1.0' encoding='UTF-8' indent='yes'/>

<xsl:param name="lmgrPrefix"/>

<xsl:key name="children" match="atom:entry" use="thr:in-reply-to/@portal:uri"/>

<!-- should only be one feed element per document -->
<xsl:template match="/atom:feed">
    <!-- get all the parent nodes and apply templates to them -->
    <!--xsl:apply-templates select="atom:entry[atom:link[@rel='replies']]" /-->
    <xsl:apply-templates select="atom:entry[1]" />
</xsl:template>

<!-- UnlayeredContainer-H -->
<xsl:template match="atom:entry[atom:content[model:layout-container[model:templateName='UnlayeredContainer-H']]]" >
    <div>
        <xsl:attribute name="id"><xsl:value-of select="$lmgrPrefix" /><xsl:value-of select="atom:id"/></xsl:attribute>
        <xsl:attribute name="containerType">UCH</xsl:attribute>
        <xsl:attribute name="modifiableFlag"><xsl:value-of select="atom:content/model:layout-container/model:modifiableFlag" /></xsl:attribute>
        <xsl:apply-templates select="key('children',atom:id)" />
    </div>
</xsl:template>

<!-- UnlayeredContainer-V -->
<xsl:template match="atom:entry[atom:content[model:layout-container[model:templateName='UnlayeredContainer-V']]]">
    <div>
        <xsl:attribute name="id"><xsl:value-of select="$lmgrPrefix" /><xsl:value-of select="atom:id"/></xsl:attribute>
        <xsl:attribute name="containerType">UCV</xsl:attribute>
        <xsl:attribute name="modifiableFlag"><xsl:value-of select="atom:content/model:layout-container/model:modifiableFlag" /></xsl:attribute>
        <xsl:apply-templates select="key('children',atom:id)" />
    </div>
</xsl:template>

<!-- Control -->
<xsl:template match="atom:entry[atom:content[model:layout-control[model:templateName='Control']]]" >
    <div>
        <xsl:attribute name="portletTitle"><xsl:value-of select="atom:title" /></xsl:attribute>
        <xsl:attribute name="skin"><xsl:value-of select="atom:link[@portal:rel='skin']/@portal:uri" /></xsl:attribute>
        <xsl:attribute name="containerType">C</xsl:attribute>
        <xsl:attribute name="id"><xsl:value-of select="$lmgrPrefix" />dndSrc<xsl:value-of select="atom:id"/></xsl:attribute>
    </div>
</xsl:template>

</xsl:stylesheet>
