/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.aggregation.PortletDojoSupport"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.aggregation.PortletDojoSupport"] = true;
dojo.provide( "com.ibm.portal.aggregation.PortletDojoSupport" );

dojo.require( "dijit._Widget" );

com.ibm.portal.aggregation.PortletDojoSupport = {
	globalObj: window,
	init: function () {
		// we don't need to handle ondijitclick events because underneath the covers
		// it used an onclick handler (which was already catch below) and then adds
		// some other handlers for onmouseup, onkeyup, etc which we don't need to care
		// about since we don't catch those in a special way
		//dojo.connect( dijit._Widget.prototype, "connect", com.ibm.portal.aggregation.PortletDojoSupport.dijitConnect );
		
		//dojo.connect
		this._oldconnect = dojo.connect;
		// dojo.connect in IE works fine in CSA because of the way dojo adds the event handlers
		if(!dojo.isIE) dojo.connect = dojo.hitch( this, this.dojoConnect );
		//dojo.disconnect
		this._olddisconnect = dojo.disconnect;
		if(!dojo.isIE) dojo.disconnect = dojo.hitch( this, this.dojoDisconnect );
		//dojo.addOnLoad
		this._oldaddonload = dojo.addOnLoad;
		dojo.addOnLoad = dojo.hitch( this, this.dojoAddOnLoad );
	},
	dijitConnect: function ( element, event, method ) {
		if ( event == "onclick" || event == "ondijitclick" ) {
			if ( event == "ondijitclick") { event = "onclick"; }
			if ( typeof method == "string") {
				element[event] = dojo.hitch( this, this[method] );
			}
			else {
				element[event] = dojo.hitch(this, method);
			}
		}	
	},
	dojoConnect: function ( element, event, context, method ) {
		// we need the connection handle itself, so we need to
		// actually connect the event handler, but we may be disconnecting
		// it later if it's an onclick handler and we handle it ourselves
		var connection = this._oldconnect( element, event, context, method);
		if ( event == "onclick" ) {
			// dojo.connect creates different types of connection handles, and it's hard to get that perfectly
			// right for every case, so we'll just let dojo do it for us, then immediately disconnect it if it's
			// for an onclick handler (so we won't have the onclick executed twice)
			// we need to copy it because dojo.disconnect actually modifies the passed in array, but we want the
			// caller to get the original so that it doesn't break anything later
			var copy = new Array();
			for(var i = 0; i < connection.length; i++) {
				copy[i] = connection[i];
			}
			this._olddisconnect(copy);
			element = element || dojo.global;
			if ( context == null ) { context = this.globalObj; }
			var handler = dojo.hitch( context, method );
			var wrappedHandler = function (e) {
				if ( !e ) {
					e = window.event;
				}
				e = dojo.fixEvent(e, element);
				return handler(e);
			}
			if(element[event]) {
				// if there is already a handler here, create a chain of additional handlers
				if(!element._onclickChain) {
					element._onclickChain = new Array();
				}
				element._onclickChain.push(wrappedHandler);
			}
			else {
				element[event] = wrappedHandler;
			}
			connection._csaHandler = wrappedHandler;
		}
		return connection;
	},
	dojoDisconnect: function ( handle ) {
		var element = null;
		var event = "";
		if ( handle && handle.length >= 2 ) {
			element = handle[0];
			event = handle[1];
		}	
		if ( event == "onclick" ) {
			// do not use dojo.disconnect on onclick handlers because we already disconnected them beforehand in
			// the dojo.connect overwritten function - so just clear the event handler from the node itself
			if(element[event] != handle._csaHandler && element._onclickChain) {
				// if the first handler isn't this one, iterate through the onclick chain to remove the right one
				for(var i = 0; i < element._onclickChain.length; i++) {
					if(element._onclickChain[i] == handle._csaHandler) {
						element._onclickChain.splice(i, 1);
						return;	// return now since we found the right one and don't want to go through the rest
					}
				}
			}
			else {
				if(element._onclickChain && element._onclickChain.length > 0) {
					// since we removed the first handler, check if there are others after it
					// if so, reset the base first handler to the next handler (which is the first on the onclick chain)
					element[event] = element._onclickChain.splice(0,1)[0];
				}
				else {
					element[event] = null;
				}
			}
		}
		else {
			this._olddisconnect( handle );
		}
	},
	dojoAddOnLoad: function ( obj, func ) {
		var handler = null;
		if(!func) handler = obj;
		else {
			handler = dojo.hitch(obj, func);
		}

		
		if ( window.addEventListener ) {
			window.addEventListener( "load", handler, false );
		}
		else if ( window.attachEvent ) {
			window.attachEvent( "onload", handler );
		}
		else {
			this._oldaddonload( handler );
		}
	}
}

com.ibm.portal.aggregation.PortletDojoSupport.init();

//dojo.subscribe( "/portal/PortletMarkup/updated", null, function ( args ) { dojo.parser.parse( args["newMarkup"] ); } );

	
	
	

}
