/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.aggregation.event.NamedAnchorHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.aggregation.event.NamedAnchorHandler"] = true;
dojo.provide( "com.ibm.portal.aggregation.event.NamedAnchorHandler");

dojo.require( "com.ibm.portal.utilities.html" );
dojo.require( "com.ibm.portal.aggregation.event" );

dojo.declare( "com.ibm.portal.aggregation.event.NamedAnchorHandler",
			  null,
			  {
			  	// summary: Handles the case where an anchor points to a place inside the current 
			  	//		document.
			  	// description: This handler is specifically designed for the JSP based portlet
			  	//		helps which open in a new window. In Firefox, clicking on one of the 
			  	//		named anchors actually causes a  full page refresh. So this handler 
			  	//		emulates the same behavior while preventing a full page refresh.
			  	
			  	handle: function ( /*Event?*/e ) {
			  		// summary: Handles a click event, looking for named anchors as the target.
			  		// e: the event object.
			  		ibm.portal.debug.entry( "NamedAnchorHandler.handle", [ e ] );
			  		
			  		e = com.ibm.portal.aggregation.event.normalizeEvent(e);
			  		
			  		//Check to see if an anchor link is the target of this event.
			  		var targetElement = e.target;
			  		if ( targetElement.nodeName.toLowerCase() == "a" ) {
			  			var hrefValue = targetElement.getAttribute( "href" );
			  			//Check to see if the href is pointing at an internal link.
			  			if ( hrefValue.indexOf("#") == 0  ) {
			  				//Chop off the hash mark.
			  				var namedValue = hrefValue.substring(1);
			  				//Find the targetted element, calculate it's position, and 
			  				//scroll to that position.
			  				var elem = targetElement.ownerDocument.getElementsByName( namedValue )[0];
			  				//Need to calculate the position in a window/document independent manner.
			  				//The dojo functions for doing this are very dependent on the document/window.
			  				var x = com.ibm.portal.utilities.html.getX( elem );
			  				var y = com.ibm.portal.utilities.html.getY( elem );
			  				//dojo.html.getElementWindow( elem ).scrollTo( x, y );
							// RES: could this use dijit.scrollIntoView(elem) ?
			  				dijit.getDocumentWindow( elem.ownerDocument ).scrollTo( x, y );

							//Cancel the event.
			  				e.stopPropagation();
			  				e.preventDefault(); 
			  			}
			  		}
			  		
			  		ibm.portal.debug.exit( "NamedAnchorHandler.handle" );
			  	}
			  }
);			  

}
