/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.portal.aggregation.skin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.portal.aggregation.skin"] = true;
dojo.provide( "com.ibm.portal.aggregation.skin" );

dojo.require( "dojox.data.dom" );
dojo.require( "dojo.fx" );

dojo.require( "com.ibm.portal.navigation.controller");
dojo.require( "com.ibm.portal.xslt" );
dojo.require("dojo.i18n");

dojo.declare( "com.ibm.portal.aggregation.PortletLoadingDecoration",
              null,
              {
                  // summary: Abstract representation of a loading decoration to show when a portlet is loading or
                  //        refreshing to indicate progress to the user.
                  // description: All loading decorations should inherit from this class and override the _doShow
                  //        and _doHide functions to implement the actual decoration behavior.
                  constructor: function ( portletid ) {
                      this.id = portletid;
                      this._resourceBase = dojo.moduleUrl("com", "ibm/portal/aggregation/");
                      this._isIE = dojo.isIE;
                  },
                  show: function (/*Object*/args) {
                      // summary: Shows the loading decoration.
                      // args: the arguments passed from the startFragment event
                      ibm.portal.debug.entry( "PortletLoadingDecoration.show");
                      
                      if ( this.id.indexOf( args["id"] ) >= 0 ) {
                          //Call the implementation function.
                          this._doShow();
                          
                          //Hide any select boxes in IE. Otherwise they will appear on top
                          //of any overlaid div.
                          if ( this._isIE ) {
                                this._hideSelectBoxes();
                          }
                      }    

                      ibm.portal.debug.exit( "PortletLoadingDecoration.show" );   
                  },
                  _doShow: function () {
                      // summary: Performs the actual display of the loading decoration.
                      dojo.unimplemented( "PortletLoadingDecoration._doShow" );
                  },
                  hide: function ( /*Object*/args) {
                      // summary: Hides the loading decoration.
                      // args: the arguments passed from the endFragment event
                      ibm.portal.debug.entry( "PortletLoadingDecoration.hide");
                      if ( this.id.indexOf( args["id"] ) >= 0 ) {
                          //Call the implementation function.
                          this._doHide();
                          
                          //Restore the select boxes.                      
                          if ( this._isIE ) {
                              this._showSelectBoxes();
                          }
                      }    
                      
                      ibm.portal.debug.exit( "PortletLoadingDecoration.hide" );
                  },
                   _doHide: function () {
                      // summary: Performs the hiding of the loading decoration.
                      dojo.unimplemented( "PortletLoadingDecoration._doHide" );
                  },
                  _getWpsPortletElement: function () {
                      // summary: Get the skin element with the wpsPortlet class.
                      return dojo.query( ".wpsPortlet", this._getRootPortletElement() )[0]; // HTMLElement  
                  },
                   _getWpsPortletBodyElement: function () {
                      // summary: Get the skin element with the wpsPortletBody class.
                      return dojo.query( ".wpsPortletBody", this._getRootPortletElement() )[0]; // HTMLElement  
                  },
                  _getRootPortletElement: function () {
                      // summary: Get the root element for the skin.
                      return dojo.byId( "portlet_" + this.id );    
                  },
                  _hideSelectBoxes: function () {
                      // summary: Hides all select boxes in the portlet/skin markup since IE will
                      //        render those on top of any overlaid elements.
                      var elem = this._getRootPortletElement();
                      var selectBoxes = elem.getElementsByTagName( "SELECT" );
                      
                      for ( var i = 0; i < selectBoxes.length; i++ ) {
                          selectBoxes[i]._hiddenByCsa = true;
                          selectBoxes[i].style.visibility = "hidden";
                      }
                  },
                  _showSelectBoxes: function () {
                      // summary: Restore all the hidden select boxes.
                      var elem = this._getRootPortletElement();
                      var selectBoxes = elem.getElementsByTagName( "SELECT" );
                      
                      for ( var i = 0; i < selectBoxes.length; i++ ) {
                          if ( selectBoxes[i]._hiddenByCsa ) {
                              selectBoxes[i].style.visibility = "visible";
                              selectBoxes[i]._hiddenByCsa = null;
                          }    
                      }    
                  }  
              }
);

dojo.declare( "com.ibm.portal.aggregation.Skin",
    null,
    {
        constructor: function( /*String*/resourceRoot, /*String*/skinId, /*String*/ xslt ) {
            this._resourceRoot = resourceRoot;
            this._skinId = skinId;
            this._xslt = xslt;
            this._fullPortletId = null;
            this._parentControl = null;
            this._atomEntryXml = null;
            this._loadingDecorator = null;
            this._resourceBaseURL = dojo.moduleUrl( "com", "ibm/portal/aggregation/");
            this.isRendered = false;
            this.isInstance = false;
            this._topics = new Array();
            
            this._startFragmentHandle = null;
            this._endFragmentHandle = null;
        },
        renderSkin: function(){
            ibm.portal.debug.entry("Skin.renderSkin");
            var trf = com.ibm.portal.xslt.TRANSFORMER_FACTORY.newTransformer(this._xslt);
            if (trf == null) {
            ibm.portal.debug.text("XSL transformer is null");
            }
            var xmlDoc = this._atomEntryXml;
            if ( dojo.isIE ) {
                // make sure we have a valid XML document
                var xml = dojox.data.dom.innerXML(this._atomEntryXml);
                xmlDoc = dojox.data.dom.createDocument( xml );
            }
            var xsltParams = { "loadingImagePath": this._resourceBaseURL + "progress-anim.gif"};
            var node = dojo.byId( "portlet_"+this._fullPortletId );
            trf.transformToRegion(xmlDoc, xsltParams, node, document);
            this.isRendered = true;
            ibm.portal.debug.exit( "Skin.renderSkin" );
        },
        updateSkin: function ( pInfo ) {
            ibm.portal.debug.entry( "Skin.updateSkin", [ pInfo ] );
            ibm.portal.debug.exit( "Skin.updateSkin" );
        },
        getActiveDiv: function () {
            // summary: Returns the div which portlet markup updates should go in (for inline mode changes).                    
            ibm.portal.debug.entry( "getActiveDiv" );
            var result = dojo.byId( this._fullPortletId );
            ibm.portal.debug.exit( "getActiveDiv", result );
            return result;
        },
        instance: function (fullPortletId, parentControl, atomEntryXml){
            //summary: factory function to create an instance of this skin template that is tied to a specific portlet on a page.
            //TODO: add an isInstance flag and throw an error if the skin template is used directly
            var newInstance = new com.ibm.portal.aggregation.Skin(this._resourceRoot, this._skinId, this._xslt);
            newInstance._fullPortletId = fullPortletId;
            newInstance._parentControl = parentControl;
            newInstance._atomEntryXml = atomEntryXml;
            newInstance._isInstance = true;
            newInstance._loadingDecorator = new com.ibm.portal.aggregation.InitialPortletLoadingDecoration( fullPortletId );
            newInstance._startFragmentHandle = com.ibm.portal.EVENT_BROKER.startFragment.register( newInstance._loadingDecorator, "show" );
            newInstance._endFragmentHandle = com.ibm.portal.EVENT_BROKER.endFragment.register( newInstance._loadingDecorator, "hide" );
            return newInstance;
        },
        destroy: function () {
            //Even though the loading decorator may not be used, we want to leave this at this level for safety's sake.
            //We ALWAYS need any registered events unregistered otherwise we'll have unwanted references in the event topic code.
            if ( this._loadingDecorator != null ) {
                com.ibm.portal.EVENT_BROKER.startFragment.unregister( this._startFragmentHandle );
                com.ibm.portal.EVENT_BROKER.endFragment.unregister( this._endFragmentHandle );
            } 
            
            for(var i = 0; i < this._topics.length; i++) {
                dojo.unsubscribe(this._topics[i]);
            }
        },
        validate: function() {
            //summary: checks to see that all required properties are non-null and non-empty.
            result = true;
            if (this._resourceRoot == null || this._resourceRoot == "") result = false;
            if (this._skinId == null || this._skinId == "") result = false;
            if (this._xslt == null) result = false;
            return result;
        },
        hideLoadingIfNecessary: function () {
            // summary: Called to ensure that the loading decoration is hidden before the 
            //        portlet's markup is changed.
            if ( this._loadingDecorator != null ) {
                this._loadingDecorator.hide({id: this._fullPortletId});
            }
        }

}
);

dojo.declare( "com.ibm.portal.aggregation.OpaquePortletRefreshingDecoration",
              com.ibm.portal.aggregation.PortletLoadingDecoration,
              {
                  // summary: Overlays a transparent div with an animated gif and the 
                  //        word "Refreshing..." on top of the portlet.
                  _thread: null,
                  _doShow: function () {
                      ibm.portal.debug.entry( "PortletLoadingDecoration._doShow");
                      var elem = dojo.byId( "loading_" + this.id );
                        if( !elem ) { 
                            elem = document.createElement( "DIV" );
                            elem.style.backgroundColor = "#3c3c3c";
                            elem.style.color = "white";
                            elem.style.fontFamily = "ARIAL";
                            elem.style.fontSize = "13";
                            elem.style.fontWeight = "bold";
                            dojo.style(elem, "opacity", 0.85);
                            elem.style.zIndex = 100;
                            elem.style.position = "absolute";
                            elem.id = "loading_" + this.id;
                            var text = document.createElement( "DIV" );
                            text.style.position = "relative";
                            text.style.top = "50%";
                            text.style.left = "50%";
                            text.innerHTML = "<img src='" + this._resourceBase + "/loading-dk.gif' />&nbsp;" + dojo.i18n.getLocalization("com.ibm.portal", "v3theme", csaUserLocale)["loading"];
                            elem.appendChild( text );
                            document.body.appendChild( elem );
                            
                        } 
                        else { 
                            elem.style.display="block";
                        }
                        
                      //Since the size of the portlet could change at any point in time
                      //(browser window resize, contents of other portlets reflowing, etc),
                      //we need to constantly check our overlay to see if it needs to be
                      //resized (only while it's showing of course).
                      this.resize();
                      
                      if ( this._thread == null ) {
                          var me = this;
                          this._thread = setInterval( function() { me.resize(); }, 10 );
                      }
                                                 
                      ibm.portal.debug.exit( "PortletLoadingDecoration._doShow" );   
                  },
                  _doHide: function () {
                      ibm.portal.debug.entry( "PortletLoadingDecoration._doHide");
                      var elem = dojo.byId( "loading_" + this.id );
                      if ( elem ) {
	                      elem.style.display = "none";
	                      //Clear the resizing interval
	                      clearInterval( this._thread );
	                      this._thread = null;    
	                      ibm.portal.debug.exit( "PortletLoadingDecoration._doHide" );
                      }    
                  },
                  resize: function () {
                      // summary: Resizes the overlaid div so that it is 1px less than
                      //        the entire portlet.
                      ibm.portal.debug.entry( "PortletLoadingDecoration.resize" );
                      
                      var elem = dojo.byId( "loading_" + this.id );
                      ibm.portal.debug.text( elem.style.display );
                      //Failsafe
                      if ( elem.style.display == 'none' ) {
                          ibm.portal.debug.text( 'clearing timeout: ' + this._thread );
                          clearTimeout( this._thread );
                      }
                      else {
                          var refNode = this._getWpsPortletElement();
                          //The dojo.html.getAbsoluteX and getAbsoluteY functions appear to work slightly differently
                          //in FF and IE. In FF, we don't want the scroll and in IE we do.
                          // PK70437 - evidently Firefox fixed above behavior in a subsequent fixpack so
                          // make everything work like IE
                          // elem.style.top = (dojo.coords(refNode, dojo.isIE).y + 1) + "px";
                          // elem.style.left = (dojo.coords(refNode, dojo.isIE).x + 1)  + "px";
                          elem.style.top = (dojo.coords(refNode, true).y + 1) + "px";
                          elem.style.left = (dojo.coords(refNode, true).x + 1) + "px"
                          
                          var size = dojo.contentBox( refNode );
                          elem.style.height = (size.h - 2) + "px";
                          elem.style.width = (size.w - 2) + "px";
                      }    
                      ibm.portal.debug.exit( "PortletLoadingDecoration.resize" );
                  }  
              }
);

dojo.declare( "com.ibm.portal.aggregation.InitialPortletLoadingDecoration",
              com.ibm.portal.aggregation.PortletLoadingDecoration,
              {
                  // summary: Since the page reflows so significantly during the initial page 
                  //        loading, the overlaid div looks horrible constantly resizing. Instead,
                  //        we will use the simple loading message described here which does not 
                  //        have to be absolutely positioned, meaning it will flow properly with the
                  //        page changes.
                  _doShow: function () {
                      var elem = this._getWpsPortletBodyElement();
                      //We can't simply blow the existing markup away in case we are in the middle of a form
                      //submission or something similar. The _doShow function gets called when the portlet
                      //starts to update (before the actual request has even been sent). So if we blow away
                      //the existing markup, it will cause the form to disappear (except for the reference to 
                      //the actual form node) and the inputs will no longer exist (at least in IE).
                      dojo.forEach( elem.childNodes, function(item) { if ( item.style ) { item.style.display = 'none'; } } );
                      //Interestingly, using innerHTML+= here in IE blows away the markup that we just set display to none in the
                      //statement above. Using the W3C methods works correctly. Go figure.
                      //elem.innerHTML += "<span style='font-family: arial; font-weight: bold;'><img src='" + this._resourceBase + "/loading.gif' />&nbsp;Loading...</span>";
                      //Create the span to set our font styles.
                      var span = document.createElement( "SPAN" );
                      span.style.fontFamily = "arial";
                      span.style.fontWeight = "bold";
                      //Create the loading image.
                      var img = document.createElement( "IMG" );
                      img.src = this._resourceBase + "/loading.gif";
                      //...And the actual text.
                      var text = document.createTextNode(" " + dojo.i18n.getLocalization("com.ibm.portal", "v3theme", csaUserLocale)["loading"]);
                      span.appendChild( img );
                      span.appendChild( text );
                      elem.appendChild( span );
                  },
                  _doHide: function () {
                      //do nothing...
                  }        
              }
);

dojo.declare( "com.ibm.portal.aggregation.IbmSkinUIState",
              null,
              {
                // summary: Maintains the state of the UI for the IBM Skin.
                // description: The IBM Skin contains several complex UI areas and the state of one
                //      can effect the behavior of another. This object maintains the state of each of
                //      these complex UI areas so that this state is separated from the actual display
                //      properties of the UI. This allows non-synchronous operations to be used in transition
                //      effects for individual areas (the most obvious example is using an animation to 
                //      open or close the actions shelf). The complex areas that we want to maintain state
                //      for are the following:
                //          Portlet Actions Shelf: the area in the skin which shows the portlet modes and other actions (e.g. Delete)
                //                                 it can be expanded or collapsed.
                //          Portlet Inline Mode Container: the area which shows a portlet mode other than View inline above view mode
                //                                  visibility can be toggled when the user clicks on the active mode (e.g. Personalize)
                // EXPANDED: constant that indicates the EXPANDED state
                // COLLAPSED: constant that indicates the COLLAPSED state
                // VISIBLE: constant that indicates the VISIBLE state
                // HIDDEN: constant that indicates the HIDDEN state
                // PORTLET_ACTIONS_SHELF_STATE: constant for the state key for the portlet actions shelf state
                // INLINE_MODE_CONTAINER_STATE: constant for the state key for the inline mode container state
                //
                // NOTE: This state does NOT make any changes to the actual display/CSS. It merely maintains what should
                //       be the state of various elements so that dependent elements can adjust accordingly without having
                //       to wait for any animations to finish, etc. The skin controller object has the responsibility of 
                //       actually updating the display/CSS properties based on the UI state.
                //_properties: {},
                EXPANDED: 1,
                COLLAPSED: 0,
                VISIBLE: 1,
                HIDDEN: 0,
                //Key for the state of the Portlet Actions shelf (i.e. the shelf area that displays the different portlet modes)
                PORTLET_ACTIONS_SHELF_STATE: "ibmSkin.actionsShelf",
                //Key for thes state of the inline mode container (the inline mode display state can be toggled by clicking on the
                //active mode name in the portlet actions shelf.
                INLINE_MODE_CONTAINER_STATE: "ibmSkin.inlineModeContainer",
                constructor: function () {
                    this._properties = {};
                },
                setState: function ( /*String*/property, /*Object*/state ) {
                    // summary: Sets the state value for the given property.
                    // property: the property name or key
                    // state: the state value for the given property
                    ibm.portal.debug.entry( "IbmSkinUIState.setState", [ property, state ] );
                    this._properties[ property ] = state;
                    ibm.portal.debug.exit( "IbmSkinUIState.setState" );
                },
                getState: function ( /*String*/ property ) {
                    // summary: Retrieves the state for the given property.
                    // returns: the state for the given property
                    ibm.portal.debug.entry( "IbmSkinUIState.getState", [ property ] );
                    var retVal = ( this._properties[ property ] ? this._properties[ property ] : false );
                    ibm.portal.debug.exit( "IbmSkinUIState.getState", retVal );
                    return retVal;  // Object
                },
                setPortletActionsShelfState: function ( /*EXPANDED or COLLAPSED*/state ) {
                    // summary: Sets the state for the portlet actions shelf.
                    // state: use the EXPANDED or COLLAPSED constants on this IbmSkinUIState object
                    ibm.portal.debug.entry( "IbmSkinUIState.setPortletActionsShelfState", [ state ] );
                    this.setState( this.PORTLET_ACTIONS_SHELF_STATE, state );
                    ibm.portal.debug.exit( "IbmSkinUIState.setPortletActionsShelfState" );
                },
                setPortletActionsShelfExpanded: function () {
                    // summary: Sets the portlet actions shelf state to EXPANDED
                    ibm.portal.debug.entry( "IbmSkinUIState.setPortletActionsShelfExpanded" );
                    this.setPortletActionsShelfState( this.EXPANDED );
                    ibm.portal.debug.exit( "IbmSkinUIState.setPortletActionsShelfExpanded" );
                },
                setPortletActionsShelfCollapsed: function () {
                    // summary: Sets the portlet actions shelf state to COLLAPSED
                    ibm.portal.debug.entry( "IbmSkinUIState.setPortletActionsShelfCollapsed" );
                    this.setPortletActionsShelfState( this.COLLAPSED );
                    ibm.portal.debug.exit( "IbmSkinUIState.setPortletActionsShelfCollapsed" );
                },
                isPortletActionsShelfExpanded: function () {
                    // summary: Indicates if the portlet actions shelf is in the EXPANDED state
                    // returns: true if the shelf is expanded, false if it is collapsed
                    ibm.portal.debug.entry( "IbmSkinUIState.isPortletActionsShelfExpanded" );
                    var retVal = ( this.getState( this.PORTLET_ACTIONS_SHELF_STATE ) == this.EXPANDED );
                    ibm.portal.debug.exit( "IbmSkinUIState.isPortletActionsShelfExpanded", retVal );
                    return retVal;  // boolean
                },
                setInlineModeContainerState: function ( /*VISIBLE or HIDDEN*/state ) {
                    // summary: Sets the inline mode container's state to VISIBLE or HIDDEN
                    // state: use the VISIBLE or HIDDEN constants on this IbmSkinUIState object
                    ibm.portal.debug.entry( "IbmSkinUIState.setInlineModeContainerState", [ state ] );
                    this.setState( this.INLINE_MODE_CONTAINER_STATE, state );
                    ibm.portal.debug.exit( "IbmSkinUIState.setInlineModeContainerState" );
                },
                setInlineModeContainerVisible: function () {
                    // summary: Sets the inline mode container's state to VISIBLE
                    ibm.portal.debug.entry( "IbmSkinUIState.setInlineModeContainerVisible" );
                    this.setInlineModeContainerState( this.VISIBLE );
                    ibm.portal.debug.exit( "IbmSkinUIState.setInlineModeContainerVisible" );
                },
                setInlineModeContainerHidden: function () {
                    // summary: Sets the inline mode container's state to HIDDEN
                    ibm.portal.debug.entry( "IbmSkinUIState.setInlineModeContainerHidden" );
                    this.setInlineModeContainerState( this.HIDDEN );
                    ibm.portal.debug.exit( "IbmSkinUIState.setInlineModeContainerHidden" );
                },
                isInlineModeContainerVisible: function () {
                    // summery: Indicates if the inline mode container is in the VISIBLE state
                    // returns: true if the container is visible, false if it is hidden
                    ibm.portal.debug.entry( "IbmSkinUIState.isInlineModeContainerVisible" );
                    var retVal = ( this.getState( this.INLINE_MODE_CONTAINER_STATE ) == this.VISIBLE );
                    ibm.portal.debug.exit( "IbmSkinUIState.isInlineModeContainerVisible", retVal );
                    return retVal;
                }
              }
);

dojo.declare( "com.ibm.portal.aggregation.IbmSkin",
    com.ibm.portal.aggregation.Skin,
    {
        constructor: function( /*String*/resourceRoot, /*String*/skinId, /*String*/xslt ) {
            //NOTE: this constructor should not be called directly (except for during skin registration)! Instances of the IbmSkin object
            //      should be obtained using the IbmSkin.instance function after registration at bootstrap time.
            ibm.portal.debug.entry( "IbmSkin.constructor", arguments );
            
            //Call the parent class' constructor to initialize common properties
            com.ibm.portal.aggregation.IbmSkin.superclass.constructor( resourceRoot, skinId, xslt );
            //Array of supported directions the portlet can be moved in
            this.moveDirectionsArray = new Array();
            
            //The active DIV element. This is supplied to the contained portlet so that alternate modes
            //than VIEW can be rendered in separate locations.
            this._activeDiv = null;
            
            //State information about the portlet's mode and window state.
            this._previousWindowState = null;
            this._currentWindowState = null;
            this._currentMode=null;

            //Indicates whether the actions have been requested yet. They are only requested when the user
            //mouses over the portlet.
            this.actionsLoaded = false;
            //Indicates if this is the initial rendering of the skin.
            this._firstRendering = true;
            
            //NLS bundles            
            this._v3themeProperties = dojo.i18n.getLocalization("com.ibm.portal", "v3theme", csaUserLocale);
            this._titlebarProperties = dojo.i18n.getLocalization("com.ibm.portal", "titlebar", csaUserLocale);
            this._engineProperties = dojo.i18n.getLocalization("com.ibm.portal", "engine", csaUserLocale);
            
            //IDs of layout nodes that could be targeted during a move operation.
            this._leftMoveTargetId = null;
            this._rightMoveTargetId = null;
            this._upMoveTargetId = null;
            this._downMoveTargetId = null;
            
            //Event handles to disconnect when destroyed. These are initialized in the factory instance function
            //which constructs the IbmSkin object.
            this._startFragmentHandle = null;
            this._endFragmentHandle = null;
            
            //Initialize the UI state object.
            this._UIState = new com.ibm.portal.aggregation.IbmSkinUIState();
            this._UIState.setInlineModeContainerHidden();
            this._UIState.setPortletActionsShelfCollapsed();
            
            ibm.portal.debug.exit( "IbmSkin.constructor" );
        },
        instance: function (fullPortletId, parentControl, atomEntryXml){
            // summary: Factory function for constructing new instances of the IbmSkin object.
            ibm.portal.debug.entry( "IbmSkin.instance", [ fullPortletId, parentControl, atomEntryXml ] );
            
            var newInstance = new com.ibm.portal.aggregation.IbmSkin(this._resourceRoot, this._skinId, this._xslt);
            newInstance._fullPortletId = fullPortletId;
            newInstance._portletWindowId = com.ibm.portal.utilities.getControlId( fullPortletId );
            newInstance._parentControl = parentControl;
            newInstance._atomEntryXml = atomEntryXml;
            //The loading decorator object handles the UI display for the skin while new portlet markup is being retrieved.
            //Initially, we use a very simple decoration (see the InitialPortletLoadingDecoration object comments for more info).
            //After the skin is rendered the first time, the decorator is switched to use a more appealing decoration.
            newInstance._loadingDecorator = new com.ibm.portal.aggregation.InitialPortletLoadingDecoration( fullPortletId );
            //These events tell the skin when a request to update the contained portlet's markup is sent and when it is done
            //updating. We need to listen to these events so that we can display the loading decoration to the user while the
            //request is pending.
            newInstance._startFragmentHandle = com.ibm.portal.EVENT_BROKER.startFragment.register( function(args) {
                if(!newInstance._isHidden(newInstance._getPortletContainer())) {
                    newInstance._loadingDecorator.show(args);
                } 
            });
            newInstance._endFragmentHandle = com.ibm.portal.EVENT_BROKER.endFragment.register( function(args) {
                if(!newInstance._isHidden(newInstance._getPortletContainer())) {
                    newInstance._loadingDecorator.hide(args);
                } 
            });

            //Need to unsubscribe to these in destroy()
            if(!newInstance._topics) newInstance._topics = new Array();
            newInstance._topics.push(dojo.subscribe( 
                "/portal/Skin/maximized/"+newInstance._fullPortletId, 
                newInstance, 
                "_doMaximize"));
            newInstance._topics.push(dojo.subscribe( 
                "/portal/Skin/minimized/"+newInstance._fullPortletId, 
                newInstance, 
                "_doMinimize"));
            newInstance._topics.push(dojo.subscribe( 
                "/portal/Skin/normal/"+newInstance._fullPortletId, 
                newInstance, 
                "_doRestore"));
            newInstance._topics.push(dojo.subscribe(
                "/portal/Skin/ClearMenu/"+newInstance._fullPortletId,
                newInstance, 
                "clearMenuContents"));
            newInstance._topics.push(dojo.subscribe(
                "/portal/Skin/MoveMenu/"+newInstance._fullPortletId,
                newInstance, 
                "movePortlet"));
            newInstance._topics.push(dojo.subscribe(
                "/portal/Skin/RefreshSkins/",
                newInstance, 
                "refreshSkins"));

            ibm.portal.debug.exit( "IbmSkin.newInstance", newInstance );
            return newInstance;     // IbmSkin 
        },
        getActiveDiv: function () {
            // summary: Returns the div which portlet markup updates should go in from the current response.
            // description: The portlet control calls this function to retrieve the container which should end
            //      up with the portlet markup from the current portlet response. This allows the markup to be
            //      distributed based on the portlet mode, for example.
            ibm.portal.debug.entry( "IbmSkin.getActiveDiv" );
            
            var result = null;
            if( this._activeDiv != null ) {
                if( this._activeDiv == "clientModeHandling" ) {
                    ibm.portal.debug.text( "getActiveDiv: Client mode handling being used without update." );
                    return result;
                }
                else {
                    result= dojo.byId( this._activeDiv );
                }
            } else {
                result = dojo.byId( this._fullPortletId );
            }
            
            ibm.portal.debug.exit( "IbmSkin.getActiveDiv", result );
            return result;
        },
        _getTitlebarActionsContainer: function () {
            return dojo.byId( "portletActions_" + this._fullPortletId );    
        },
        _getPortletActionsShelf: function () {
            return dojo.byId( "portletModes_" + this._fullPortletId );  
        },
        _getModesContainer: function () {
            return dojo.byId( this._fullPortletId + "_mode");   
        },
        _getPortletContainer: function () {
            return dojo.byId( "portlet_"+this._fullPortletId);  
        },
        _getPreviousWindowState: function () {
            return this._previousWindowState;
        },
        _getWindowStatesArray: function () {
            return this._windowStatesArray;
        },
        _isHidden: function(node) {
            return dojo.style(node, 'display') == 'none';
        },
        _hide: function(node) {
            ibm.portal.debug.entry( "IbmSkin._hide", arguments );
            dojo.fx.wipeOut({node: node, duration: 5}).play();
            ibm.portal.debug.exit( "IbmSkin._hide" );
        },
        _show: function(node) {
            ibm.portal.debug.entry( "IbmSkin._show", arguments );
            dojo.fx.wipeIn({node: node, duration: 5}).play();
            ibm.portal.debug.exit( "IbmSkin._show" );
        },
        togglePortletModesDisplay: function(){
            ibm.portal.debug.entry( "IbmSkin.togglePortletModesDisplay" );
            var portletModesDiv = this._getModesContainer();
            
            if( this._UIState.isInlineModeContainerVisible() ){
                this._UIState.setInlineModeContainerHidden();
                this._hide( portletModesDiv );
            } else {
                this._UIState.setInlineModeContainerVisible();
                this._show( portletModesDiv );
            }
            ibm.portal.debug.exit( "IbmSkin.togglePortletModesDisplay", false );
            return false;
        },
        togglePortletModesShelfDisplay: function(){
            ibm.portal.debug.entry( "IbmSkin.togglePortletModesShelfDisplay" );
            
            var portletModesId = "portletModes_"+this._fullPortletId;
            var portletModesLink = dojo.byId("portletModesLink_"+this._fullPortletId);
            var portletModesDiv = this._getModesContainer();
            
            ibm.portal.debug.text( "UIState.isPortletActionsShelfExpanded? " + this._UIState.isPortletActionsShelfExpanded() );
            
            if( this._UIState.isPortletActionsShelfExpanded() ){
                portletModesLink.innerHTML = this._v3themeProperties["actions"];
                this._hide(portletModesId);
                this._UIState.setPortletActionsShelfCollapsed();
            } else {
                portletModesLink.innerHTML = this._v3themeProperties["closeActions"];
                this._show(portletModesId);
                this._UIState.setPortletActionsShelfExpanded();
            }
            
            ibm.portal.debug.exit( "IbmSkin.togglePortletModesShelfDisplay", false );
            return false;
        },
        
        // ************************** RENDERING FUNCTIONS *************************************
        updateSkin: function ( pInfo ) {
            // summary: Updates the skin based on the provided PortletInfo object (see PortletFragmentService.js).
            // description: This is the starting point for rendering the IbmSkin. This function is called by the 
            //      PortletControl object to update the skin according to the retrieved portlet navigational state.
            // pInfo: the PortletInfo object
            ibm.portal.debug.entry( "IbmSkin.updateSkin", [ pInfo ] );
            
            //Actions aren't loaded until the user mouses over the portlet.
            this.actionsLoaded = false;
            //Keep the current window state and current portlet mode around for comparisons.
            this._currentWindowState = pInfo.currentWindowState;
            this._currentMode = pInfo.currentMode;
            //Update the skin based on the portlet window state first (e.g. Maximize, Minimize, etc.)
            this.setSkinToCurrentWindowState(pInfo);
            //Select the active div based on the portlet mode AND give any client-side mode handling functions
            //a chance to grab control.
            this.selectActiveDiv(pInfo);
            //Create and attach the event handlers which hide and show the skin links when the user mouses over the skin.
            //Also create the keyboard event handlers which will allow the user to see the links when TABbing through the page.
            this.attachEventHandlers();
            //If this is the first rendering, we want to switch loading decorators and use one that is a little more attractive than
            //plain text + image. We don't want to use the more attractive decorator during the initial page rendering because the 
            //page contents re-flow so quickly, the resize function can't keep up.
            if ( this._firstRendering ) {
                //Clean up the trash from the initial loading decorator.
                com.ibm.portal.EVENT_BROKER.startFragment.unregister( this._startFragmentHandle );
                com.ibm.portal.EVENT_BROKER.endFragment.unregister( this._endFragmentHandle );
                this._loadingDecorator = new com.ibm.portal.aggregation.OpaquePortletRefreshingDecoration( this._fullPortletId );
                //Register the new loading decorator.
                var me = this;
                this._startFragmentHandle = com.ibm.portal.EVENT_BROKER.startFragment.register( function(args) {
                    if(!me._isHidden(me._getPortletContainer())) {
                        me._loadingDecorator.show(args);
                    } 
                });
                this._endFragmentHandle = com.ibm.portal.EVENT_BROKER.endFragment.register( function(args) {
                    if(!me._isHidden(me._getPortletContainer())) {
                        me._loadingDecorator.hide(args);
                    } 
                });
                //Make sure this doesn't get executed again while this skin is not destroyed.
                this._firstRendering = false;
            }
                        
            ibm.portal.debug.exit( "IbmSkin.updateSkin" );
        },
        setSkinToCurrentWindowState: function(/*PortletInfo*/pInfo){
            // summary: When rendering the portlet, if the current window state is not normal,
            //          then we call the appropriate function to display the portlet in the 
            //          correct state
            ibm.portal.debug.entry( "IbmSkin.setSkinToCurrentWindowState", [ pInfo ] );
            ibm.portal.debug.text("IbmSkin.setSkinToCurrentWindowState: currentWindowState= "+pInfo.currentWindowState);
            
            //The client side programming model allows a portlet to define a specific function which can control the 
            //transition from window state to window state. We must first find out if a portlet has defined such a function. 
            //If so, whether or not our skin specific functions are called are dependent on the return value of the portlet's
            //function.
            var isWindowStateOnClient = false;
            var update = true;
            //var clientWindowStateFn = "PC_"+this._portletWindowId+"_doWindowState";
            var clientWindowStateFn = "PC_"+pInfo.windowId+"_doWindowState";
            //Check to see if the client-side function is defined.
            if( typeof window[clientWindowStateFn] == "function" ){
                isWindowStateOnClient = true;
            }   
            //If the portlet's new window state is minimized, we want to check if the portlet is already minimized. If so, we 
            //just leave it alone. If the previous state was null, then this is likely the first time rendering this portlet. 
            if( pInfo.currentWindowState == "minimized" && (this._previousWindowState == null || dojo.byId(this._fullPortletId+"_minimized") == null) ){
                if ( isWindowStateOnClient ) {
                    update = window[clientWindowStateFn]( this._currentWindowState , this._getPortletContainer() );
                }
                //The client window state function has to return TRUE for our skin-specific function to be called.      
                if ( update ) {
                    this._doMinimize(null);
                }    
            }
            //If the portlet's new window state is maximized, we want to check if the portlet is already maximized. Again, if the 
            //previous state was null, then this is likely the first time rendering this portlet and it cannot be already maximized.
            else if( pInfo.currentWindowState == "maximized" && (this._previousWindowState == null || dojo.byId("maximized_portlet_placeholder"+this._fullPortletId) == null) ){ 
                if( isWindowStateOnClient ) {
                    update = window[clientWindowStateFn]( pInfo.currentWindowState , this._getPortletContainer() );
                }       
                //The client window state function has to return TRUE for our skin-specific function to be called.
                if( update ) {
                    this._doMaximize(null);
                }    
            }
            
            //In the following two cases, we are returning the portlet from maximized or minimized window state to NORMAL window state. 
            if(dojo.byId("maximized_portlet_placeholder"+this._fullPortletId) != null && this._previousWindowState == "maximized" && pInfo.currentWindowState == "normal" ){
                if( isWindowStateOnClient ) {
                    update = window[clientWindowStateFn]( pInfo.currentWindowState , this._getPortletContainer() );
                }       
                //The client window state function has to return TRUE for our skin-specific function to be called.
                if( update ) {
                    this.unMaximize();
                }               
            }
            if(dojo.byId(this._fullPortletId+"_minimized") != null && this._previousWindowState == "minimized" &&  pInfo.currentWindowState == "normal" ){
                if( isWindowStateOnClient ) {
                    update = window[clientWindowStateFn]( pInfo.currentWindowState , this._getPortletContainer() );
                }       
                if( update ) {
                    //The client window state function has to return TRUE for our skin-specific function to be called.
                    this.unMinimize();
                }               
            }
            
            this._previousWindowState = pInfo.currentWindowState;
            ibm.portal.debug.exit( "IbmSkin.setSkinToCurrentWindowState" );
        },
        selectActiveDiv: function( pInfo ){
            // summary: Selects the container which should receive the portlet markup from this portlet request.
            // pInfo: the object containing the results of the portlet request (see PortletFragmentService.js)
            ibm.portal.debug.entry( "IbmSkin.selectActiveDiv", [ pInfo ]);
            
            //The IbmSkin has two containers for portlet markup. One container is reserved for the VIEW mode markup.
            //The other container is reserved for any other mode's markup. 
            if( pInfo.currentMode == "view" ){
                ibm.portal.debug.text( "IbmSkin.selectActiveDiv: mode is view");                        
                //Hide the modes container because we are in view mode.
                if( this._UIState.isPortletActionsShelfExpanded() ){
                    this._UIState.setInlineModeContainerHidden();
                    this._hide( this._getModesContainer() );
                    this._UIState.setPortletActionsShelfCollapsed();
                    this._hide( this._getPortletActionsShelf() );
                }
                //Set the active div to the view container.
                this._activeDiv = dojo.byId( this._fullPortletId);
            } else {
                var update = true;
            
                //The client side programming model allows a portlet to define a specific function which can control the 
                //transition from portlet mode to portlet mode. We must first find out if a portlet has defined such a function. 
                //If so, whether or not our skin specific functions are called are dependent on the return value of the portlet's
                //function.
                if(typeof window["PC_"+pInfo.windowId+"_doPortletMode"] == "function" ){
                    update = window["PC_"+pInfo.windowId+"_doPortletMode"]( pInfo.currentMode , this._getModesContainer() );
                }   
                
                if(update){
                    //The portlet is NOT in VIEW mode, so if the portlet is also not minimized, then we need to show the portlet
                    //actions shelf and the portlet modes container so that the current mode's markup is visible.                       
                    if(pInfo.currentWindowState != "minimized"){
                        this._show( this._getPortletActionsShelf() );
                        this._UIState.setPortletActionsShelfExpanded();
                        this._show( this._getModesContainer() );
                        this._UIState.setInlineModeContainerVisible();
                    }
                    
                    //Set active div to the mode container.
                    this._activeDiv = dojo.byId( this._getModesContainer() );
                }else{
                    //This will require getActiveDiv to return null. Since mode handling is taken over by the client, we do not want
                    //to update the portlet modes container.
                    this._activeDiv = "clientModeHandling";
                }
                
                //The view mode is shown at the same time as any other mode so that updates made in Personalize or Configure mode, for
                //example, are shown immediately to the user.
                if ( dojo.byId( this._fullPortletId ).getAttribute( "loaded" ) != "true" ) {
                    this._parentControl.renderViewMode( pInfo, dojo.byId(this._fullPortletId) );
                }
                
                //Since the mode shelf will be visible, we can't wait for the user to mouseover to load the portlet actions shelf 
                //contents.
                this.loadPortletActions();                
            }
            
            ibm.portal.debug.exit( "IbmSkin.selectActiveDiv" );
        },
        attachEventHandlers: function () {
            // summary: Attach any required event handlers for the IbmSkin.
            ibm.portal.debug.entry( "IbmSkin.attachEventHandlers" );
            
            this._createActionsMouseOver();
            this._createActionsOnFocus();
            
            ibm.portal.debug.exit( "IbmSkin.attachEventHandlers" );
        },
        _createActionsOnFocus: function(){
            // summary: Creates a markup element just before the hidden titlebar actions so that a user tabbing through
            //      the HTML document will have a markup element that can be used to show the titlebar actions since they
            //      are hidden by default (and usually only shown via mouse events). This is required to make the show/hide
            //      behavior accessible.
            ibm.portal.debug.entry( "IbmSkin._createActionsOnFocus" );
            
            var me = this;
            var titleContainer = dojo.byId("portletTitle_"+me._fullPortletId);

            var skipPortletAnchor = com.ibm.portal.utilities.html.createAnchor( titleContainer.childNodes[0], 
                                                                                "#skipportlet"+me._fullPortletId );
                                                                                
            dojo.connect(skipPortletAnchor, "onfocus", function () { me.showPortletTitlebarActions(); });
            
            var skipPortletImage = com.ibm.portal.utilities.html.createImage( skipPortletAnchor, 
                                                                              ibm.portal.ThemeImages.clearPixelPath, 
                                                                              null, 
                                                                              this._engineProperties["link.skiptonextportlet"]);
            skipPortletImage.border = "0px none";
            
            ibm.portal.debug.exit( "IbmSkin._createActionsOnFocus" );                                               
        },          
        _createActionsMouseOver: function(){
            // summary: Create the onmouseover event for the portlet container that shows and hides the titlebar
            //      actions.
            ibm.portal.debug.entry( "IbmSkin._createActionsMouseOver" );
            
            var portlet = this._getPortletContainer();
            var me = this;
            
            if (dojo.isIE){
                dojo.connect(portlet, "onmouseenter", function () { me.showPortletTitlebarActions(); });
                dojo.connect(portlet, "onmouseleave", this, "hidePortletTitlebarActions");
            }else{
                dojo.connect(portlet, "onmouseover", function () { me.showPortletTitlebarActions(); });
                dojo.connect(portlet, "onmouseout", this, "hidePortletTitlebarActions");
            }
            
            ibm.portal.debug.exit( "IbmSkin._createActionsMouseOver" );
        },
        showPortletTitlebarActions: function(){
            // summary: Makes the portlet's titlebar actions visible and loads the allowed portlet modes and window states 
            //      from the operations REST service, if they haven't been previously loaded. The request to load the actions
            //      is asynchronous, so there may be some delay from the first mouseover event and the actions actually being
            //      displayed.
            ibm.portal.debug.entry( "IbmSkin.showPortletTitlebarActions" );
            if(this.actionsLoaded != true){
                this.loadPortletActions();
            }
            dojo.style("portletActions_"+this._fullPortletId, "visibility", "visible");
            ibm.portal.debug.exit( "IbmSkin.showPortletTitlebarActions" );
        },
        hidePortletTitlebarActions: function( ){
            // summary: Makes the portlet's titlebar actions invisible to the user.
            ibm.portal.debug.entry( "IbmSkin.hidePortletTitlebarActions" );
            dojo.style("portletActions_"+this._fullPortletId, "visibility", "hidden");
            ibm.portal.debug.exit( "IbmSkin.hidePortletTitlebarActions" );
        },
        loadPortletActions: function(){
            // summary: Retrieve the operations feed link from the ATOM document and request it's contents for this portlet.
            // description: The operations feed allows us to know which modes and window state the user is allowed to access.
            ibm.portal.debug.entry( "IbmSkin.loadPortletActions" );
            
            var portletTd = this._getPortletContainer();
            var uri = portletTd.getAttribute("menuLink");
            var url = new com.ibm.portal.services.ContentHandlerURL( /*String*/uri, /*int*/null, /*String*/null, /*String?*/null );
            var serviceReq = new com.ibm.portal.services.PortalRestServiceRequest( url );
            var state = com.ibm.portal.navigation.controller.NAVIGATION_CONTROLLER.getState();
            //Make sure we don't try to load these twice.
            this.actionsLoaded = true;
            
            //Send the request.
            serviceReq.read( dojo.hitch( this, "applyXslt" ) );
            
            ibm.portal.debug.exit( "IbmSkin.loadPortletActions" );
        },
        applyXslt: function ( /*String*/type, /*dojox.data.dom.Document*/xmlData, /*XMLHttpRequest*/xhr, /*Array*/callbackargs ) {
            // summary: Apply the XSLT to gather the portlet actions from the menu feed, 
            //          then populate the action array objects
            // type: the type of response
            // xmlData: the xml of the Feed
            // xhr: the XMLHttpRequest used to retrieve the feed
            // callbackargs: any arguments passed through to this function
            ibm.portal.debug.entry( "IbmSkin.applyXslt", [xmlData,xhr,callbackargs] );
            
            if ( xmlData instanceof Error ) {
                //Clear out all skin actions.
                var container = this._getTitlebarActionsContainer();
                dojox.data.dom.removeChildren( container );
            } else {
                var trf = this._xslt = com.ibm.portal.xslt.TRANSFORMER_FACTORY.newTransformer( ibmPortalConfig["contextMenuXslt"] );
                if (trf == null) {
                    ibm.portal.debug.text("XSL transformer is null");
                }
                
                //The results of this XSLT will be javascript string. Eval turns it into an
                //object for us.
                var results = trf.transformToDocument(xmlData, {}, true);
                eval( results );
                //menuItems is defined by the XSL file
                this._renderActions( menuItems );
            }    
            
            ibm.portal.debug.exit( "IbmSkin.applyXslt" );    
        },
        _renderActions: function ( /*Array*/items ) {
            // summary: Renders the items in the menu items array.
            // description: Unfortunately, there's not a generic way to render these actions. A large switch statement
            //      provides the necessary logic currently. Adding an action to the portlet skin should be done in this
            //      function or one of the functions it calls.
            // items: the array of items to render
            ibm.portal.debug.entry( "IbmSkin._renderActions" );
            
            var me = this;
            
            var titlebarContainer = this._getTitlebarActionsContainer();
            dojox.data.dom.removeChildren( titlebarContainer );
            
            var shelfContainer = this._getPortletActionsShelf();
            dojox.data.dom.removeChildren( shelfContainer );
            
            //Index the menu items by label.
            var indexedItems = {}; 
            for ( var i = 0; i < items.length; i++ ) {
                ibm.portal.debug.text( "Indexing label \"" + items[i].label + "\"." );
                indexedItems[ items[i].label ] = items[i];
            }
            
            //Render the window states menu.
            this._renderWindowStatesMenuButton( titlebarContainer, [ indexedItems[ "maximized" ], indexedItems["minimized"], indexedItems["normal"] ] );
            
            //Render the move menu only if the portlet is NOT maximized.
            if(dojo.byId("maximized_portlet_placeholder"+this._fullPortletId) == null){
                this._renderMoveMenuButton( titlebarContainer );
            }
            
            //Render refresh icon. This will refresh the portlet using it's last known navigational state.
            this._renderRefreshIcon( titlebarContainer );       
            
            //Render the help icon.
            this._renderHelpIcon( titlebarContainer, indexedItems[ "help" ] );
            
            //Render Actions Link.
            var showActionsLink = dojo.some(items, function(item, index, array) {
                if(item.label != "view"
                    && item.label != "normal" 
                    && item.label != "minimized"
                    && item.label != "maximized"
                    && item.label != "help") {
                    return true;
                }
                return false;
            });
            if(showActionsLink) this._renderActionsToggleLink( titlebarContainer );
            
            //Render portlet actions shelf (includes the portlet modes).
            var deletePermission = ( typeof ( indexedItems[ "delete_portlet" ] ) != "undefined" );
            this._renderPortletActionsShelf( shelfContainer, [ indexedItems[ "config" ], indexedItems[ "edit" ], indexedItems[ "edit_defaults" ] ], deletePermission ); 
            
            ibm.portal.debug.exit( "IbmSkin._renderActions" );
        },
        _renderRefreshIcon: function ( /*HTMLElement*/container ) {
            // summary: Renders the refresh icon and attaches it's event handlers.
            // container: the element which should contain the newly created refresh icon
            ibm.portal.debug.entry( "IbmSkin._renderRefreshIcon", [ container ] );
            
            var refreshAnchor = com.ibm.portal.utilities.html.createAnchor( container, "javascript:void(0);" );
            var refreshImage = com.ibm.portal.utilities.html.createImage( 
                refreshAnchor,  
                ibm.portal.ThemeImages.skinRefreshIconPath,
                "refresh_" + this._fullPortletId,
                this._titlebarProperties["refresh"],
                "wpsPortletIcons" ); 
                
            dojo.connect( refreshAnchor, "onclick", dojo.hitch(this,"refreshPortlet") );
            //The icon colors in when the mouse is over top of it.
            var me = this;
            dojo.connect( refreshImage, "onmouseover", function () { dojo.byId( "refresh_" + me._fullPortletId ).src=ibm.portal.ThemeImages.skinRefreshIconHoverPath; } );
            dojo.connect( refreshImage, "onmouseout", function () { dojo.byId( "refresh_" + me._fullPortletId ).src=ibm.portal.ThemeImages.skinRefreshIconPath; } );
            
            ibm.portal.debug.exit( "IbmSkin._renderRefreshIcon" );
        },
        _renderHelpIcon: function ( /*HTMLElement*/container, /*Object*/helpInfo ) {
            // summary: Renders the help icon and attaches it's event handlers.
            // container: the element which should contain the newly created help icon
            // helpInfo: the menu item object containing the info about the help mode, may be NULL to indicate
            //      there is no help mode for this portlet
            ibm.portal.debug.entry( "IbmSkin._renderHelpIcon", [ container, helpInfo ] );
            
            if( helpInfo != null ){
                var me = this;
                var helpAnchor = com.ibm.portal.utilities.html.createImageAnchor( 
                    container,  
                    ibm.portal.ThemeImages.skinHelpIconPath,
                    "help_" + this._fullPortletId,
                    this._titlebarProperties["help"],
                    "wpsPortletIcons" );
                    
                dojo.connect( helpAnchor, "onclick", function (){ me["_createModeFunction"](helpInfo.label, "Help"); }); //me.helpObject.oncommand,
                //The icon colors in when the mouse is over top of it.
                dojo.connect( helpAnchor, "onmouseover", function () { dojo.byId( "help_" + me._fullPortletId ).src=ibm.portal.ThemeImages.skinHelpIconHoverPath; } );
                dojo.connect( helpAnchor, "onmouseout", function () { dojo.byId( "help_" + me._fullPortletId ).src=ibm.portal.ThemeImages.skinHelpIconPath; } );
            }
            
            ibm.portal.debug.exit( "IbmSkin._renderHelpIcon" );
        },
        _renderActionsToggleLink: function ( /*HTMLElement*/container ) {
            // summary: Renders the Actions/Close Actions toggle link and attaches it's event handlers.
            // container: the element which should contain the newly create link
            ibm.portal.debug.entry( "IbmSkin._renderActionsToggleLink", [ container ] );
            
            var actionsText = null;
            
            //The text of the anchor depends upon whether the portlet actions shelf is showing or not.
            if( this._UIState.isPortletActionsShelfExpanded() ){
                actionsText = this._v3themeProperties["closeActions"];
            } else {
                actionsText = this._v3themeProperties["actions"];
            }
            
            ibm.portal.debug.text( "Actions text is: " + actionsText );
             
            var actionsAnchor = com.ibm.portal.utilities.html.createAnchor( 
                container, 
                "javascript:void(0);",
                "portletModesLink_"+this._fullPortletId,
                actionsText,
                "wpsPortletActions");
            //The background of the anchor link changes when the mouse is over top of it.
            var me = this;
            dojo.connect( actionsAnchor, "onmouseover", function () { dojo.byId( "portletModesLink_"+me._fullPortletId ).className = 'wpsPortletActionsHover' });
            dojo.connect( actionsAnchor, "onmouseout", function () { dojo.byId( "portletModesLink_"+me._fullPortletId ).className = 'wpsPortletActions' });
            
            var isMinimized = ( this._currentWindowState == 'minimized' );
            
            //If the current portlet mode is VIEW or the portlet is minimized, the Actions/Close Actions link acts
            //simply as a toggle. Otherwise, it acts as the "Back To View" link since the user is essentially
            //returning to VIEW mode by closing the inline mode element.
            if ( ( this._currentMode == "view" ) || isMinimized ) {            
                dojo.connect( actionsAnchor, "onclick", dojo.hitch( this, "togglePortletModesShelfDisplay" ) ); 
            }                                                                                   
            else {
                dojo.connect( actionsAnchor, "onclick", function () { me["_createModeFunction"]("view", "Back"); }) 
            }
            
            ibm.portal.debug.exit( "IbmSkin._renderActionsToggleLink" );
        },
        _renderPortletActionsShelf: function ( /*HTMLElement*/container, /*Array*/pModes, /*boolean*/isDeletable ) {
            // summary: Renders the portlet actions shelf.
            // description: This is the area that displays the links for the different portlet modes, as well as
            //      the Delete portlet link, if the user has permission to delete the portlet.
            // container: the element which will contain each of these links
            // pModes: the portlet modes this portlet supports
            // isDeletable: indicates if the portlet is deletable by the current user
            ibm.portal.debug.entry( "IbmSkin._renderPortletActionsShelf", [ container, pModes, isDeletable ] );
            
            //If this is a Right-to-Left language (Hebrew, Arabic), we want to render the Delete link first.
            /*
            if( bidiSupport.isRTL && isDeletable ){
                this._createDeletePortletLink( container );
            }
            */
            
            var isMinimized = ( this._currentWindowState == 'minimized' );

            //If the portlet is minimized, we don't render any of the mode links.                   
            if( !isMinimized ){                         
            
                //Cycle through the possible modes and create anchor links for each one 
                //for bidi go from pModes.length to 0   
                //  for ( var i = pModes.length-1; i >= 0; i-- ) 
                //for non bidi go from 0 to pModes.length               
                //  for ( var i = 0; i < pModes.length; i++ ) 
                //instead of using two for loops, 
                //this logic was contained in one while loop
                var modesEnd = false;
                var i = 0;
                /*
                if( bidiSupport.isRTL ) {
                    i = pModes.length - 1;
                }
                */
                            
                while(pModes != null && !modesEnd){
                    if ( pModes[i] != null ) {
                        var me = this;
                        if ( this._currentMode == pModes[i].label ) {
                            //Render the active mode link differently than the other modes. 
                            //Since it is our active mode, this will not be in our array.                        
                            this._createActiveModeAnchor(container, this._currentMode, pModes[i].title);
                        }
                        else {
                            ibm.portal.debug.text( "Creating mode link for: " + pModes[i].title );
                            
                            var spanElement = document.createElement('SPAN');
                            spanElement.className= "wpsPortletModesSpan" ;
        
                            var anchor = com.ibm.portal.utilities.html.createAnchor( spanElement, 
                                                                                        "javascript:void(0);",
                                                                                        null,
                                                                                        pModes[i].title,
                                                                                        "wpsPortletModes" );
                            //Check for client mode handling.
                            var isModeOnClient = false;
                            var clientModeFn = "PC_"+this._portletWindowId+"_doPortletMode";
                            if( typeof window[clientModeFn] == "function" ){
                                isModeOnClient = true;
                            }   
                                 
                            //To maintain the variable that contains the mode url throughout the loop, 
                            //we need to use unique variables for each mode                 
                            if(pModes[i]["label"] == "config"){             
                                var configMode = pModes[i]["label"];
                                if(isModeOnClient){
                                    dojo.connect( anchor, "onclick",function () { me["_createClientModeFunction"](  configMode, clientModeFn ) }  );    
                                }else{                                          
                                    dojo.connect( anchor, "onclick", function () { me["_createModeFunction"](  configMode , "Mode" ) } );   
                                }
                            }
                                            
                            if(pModes[i]["label"] == "edit"){               
                                var editMode = pModes[i]["label"];  
                                if(isModeOnClient){
                                    dojo.connect( anchor, "onclick", function () { me["_createClientModeFunction"](  editMode, clientModeFn ) } );                              
                                }else{                  
                                    dojo.connect( anchor, "onclick", function () { me["_createModeFunction"](  editMode , "Mode" ) } ); 
                                }
                            }
                                            
                            if(pModes[i]["label"] == "edit_defaults"){              
                                var editDefaultsMode = pModes[i]["label"];  
                                if(isModeOnClient){
                                    dojo.connect( anchor, "onclick", function () { me["_createClientModeFunction"](  editDefaultsMode, clientModeFn ) } );                              
                                }else{              
                                    dojo.connect( anchor, "onclick", function () { me["_createModeFunction"](  editDefaultsMode , "Mode" ) } ); 
                                }
                            }
                            container.appendChild(spanElement); 
                        }                                                               
                    }
                                
                    modesEnd = true;

                    /*
                    if(bidiSupport.isRTL){
                        i--;
                        if(i>=0){
                            modesEnd = false;
                        }
                    }else*/{
                        i++;
                        if(i<pModes.length){
                            modesEnd = false;
                        }
                    }
                }
            }
            
            //If this is a Left-to-Right language (English, etc.), we want the Delete link last.
            //Note the Delete link is the only actions shelf link rendered when the portlet is minimized.
            if( /*!bidiSupport.isRTL &&*/ isDeletable ) {
                this._createDeletePortletLink( container );
            }
        },
        _renderWindowStatesMenuButton: function ( /*HTMLElement*/parent, /*Array*/wStates ) {
            // summary: will create the window state context menu icon and initialize it's contents
            // parent: the container where the window states menu is rendered
            // wStates: the window states supported by the portlet
            ibm.portal.debug.entry( "IbmSkin._renderWindowStatesMenuButton", [ parent ] );
            
            //Create the button element. We use a button so that the context menu will appear
            //directly below the image (limitation of the WCL context menu code).
            var wStatesButton = com.ibm.portal.utilities.html.createButton( 
                parent,  
                "javascript:void(0);",
                "menu_windowStateMenu" + this._fullPortletId,
                null,
                "wptheme-contextMenuIcon" );
            
            //Create the image to go on the button.
            var wStatesIcon = com.ibm.portal.utilities.html.createImage( 
                wStatesButton, 
                ibm.portal.ThemeImages.skinWindowStateIconPath, 
                "menu_windowStateMenu"+this._fullPortletId+"_img", 
                this._v3themeProperties["windowState"],
                "wpsPortletIcons" );
            
            //Connect all events.
            var me = this;
            dojo.connect( wStatesButton, "onclick", function(){ me["displayPortletMenu"]("windowStateMenu"); });
            dojo.connect( wStatesButton, "onmouseover", function () { document.getElementById("menu_windowStateMenu"+me._fullPortletId+"_img").src=ibm.portal.ThemeImages.skinWindowStateIconHoverPath; });
            dojo.connect( wStatesButton, "onmouseout", function () { document.getElementById("menu_windowStateMenu"+me._fullPortletId+"_img").src=ibm.portal.ThemeImages.skinWindowStateIconPath; });
            
            //Clear the menu.
            this.clearMenuContents("windowStateMenu");
            //Load the menu items.
            this._createWindowStatesMenu( wStates );
            
            ibm.portal.debug.exit( "IbmSkin._renderWindowStatesMenuButton");
        },
        _createWindowStatesMenu: function( /*Array*/contents ){
            ibm.portal.debug.entry( "IbmSkin._createWindowStatesMenu", [ contents ] );
            
            var menuId = "contextMenu_"+"windowStateMenu"+this._fullPortletId;
            /* PK73199 */
            var menu = createContextMenu(menuId, !bidiSupport.isRTL, ""/*menuBorderStyle*/, "wptheme-skinContextMenuTable"/*menuTableStyle*/, this._engineProperties["info.emptymenu"] );
            var state = com.ibm.portal.navigation.controller.NAVIGATION_CONTROLLER.getState();
                        
            // Cycle through the menu item array.
            // The structure of the array object should be {oncommand: portletWindowId, label: modeName].
            /* PK73199 */
            for ( var i=0; i < contents.length; i++ ) {
                if ( contents[i] && contents[i].length != 0 && ( contents[i].label != this._currentWindowState ) ) {
                    menu.add( new UilMenuItem( contents[i].title, true, '',  'dojo.publish("/portal/Skin/'+contents[i].label+'/'+this._fullPortletId+'",[{url: "'+state.newPortletRenderURL(this._portletWindowId, null, contents[i].label.toString())+'"}]);', null, /*no icon*/ null, null, 'wptheme-skinContextMenuItem'/*menuItemStyle*/, 'wptheme-skinContextMenuItemHover'/*menuItemSelectedStyle*/) );
                }
            }
            
            ibm.portal.debug.exit( "IbmSkin._createWindowStatesMenu" ); 
        },  
        _renderMoveMenuButton: function ( /*HTMLElement*/parent ) {
            // summary: will create the move context menu icon
            // parent: the container where the move menu is rendered
            ibm.portal.debug.entry( "IbmSkin._renderMoveMenuButton", [ parent ] );
            
            var moveDirectionsArray = this._getValidMoves();
            if ( moveDirectionsArray.length != 0 ) {
                //Create the button element. We use a button so that the context menu will appear
                //directly below the image (limitation of the WCL context menu code).
                var moveButton = com.ibm.portal.utilities.html.createButton( 
                    parent,  
                    "javascript:void(0);",
                    "menu_moveMenu" + this._fullPortletId,
                    null,
                    "wptheme-contextMenuIcon" );
                
                //Create the image to go on the button.
                var moveIcon = com.ibm.portal.utilities.html.createImage( 
                    moveButton, 
                    ibm.portal.ThemeImages.skinMoveIconPath, 
                    "menu_moveMenu"+this._fullPortletId+"_img", 
                    this._v3themeProperties["movePortlet"],
                    "wpsPortletIcons" );
                
                //Connect all events.
                var me = this;
                dojo.connect( moveButton, "onclick", function(){ me["displayPortletMenu"]("moveMenu"); });                  
                dojo.connect( moveButton, "onmouseover", function () { document.getElementById("menu_moveMenu"+me._fullPortletId+"_img").src=ibm.portal.ThemeImages.skinMoveIconHoverPath; });
                dojo.connect( moveButton, "onmouseout", function () { document.getElementById("menu_moveMenu"+me._fullPortletId+"_img").src=ibm.portal.ThemeImages.skinMoveIconPath; });
                
                //Clear the menu.
                this.clearMenuContents("moveMenu");
                //Load the menu items.
                this._createPortletMoveMenu( moveDirectionsArray );
            }
            
            ibm.portal.debug.exit( "IbmSkin._renderMoveMenuButton");
        },
        _getValidMoves: function (){
            // summary: Determines the valid move locations for the current portlet using the
            //      portlet move controller.
            // returns: an array of objects describing the valid moves for this portlet            
            ibm.portal.debug.entry( "IbmSkin._getValidMoves" );
            
            var moveDirectionsArray = new Array();
            var i = 0;               
            if(com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.portletMoveController._isValidLeftMove("dndSrc"+this._fullPortletId) != null){
                this._leftMoveTargetId = com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.portletMoveController._isValidLeftMove("dndSrc"+this._fullPortletId);
                moveDirectionsArray[i] = new Object();
                moveDirectionsArray[i].title = this._titlebarProperties["move.left"];
                moveDirectionsArray[i].direction = "left";
                i++
                ibm.portal.debug.text( "this._leftMoveTargetId :"+this._leftMoveTargetId );
            }
            
            if(com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.portletMoveController._isValidRightMove("dndSrc"+this._fullPortletId) != null){
                this._rightMoveTargetId = com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.portletMoveController._isValidRightMove("dndSrc"+this._fullPortletId);
                moveDirectionsArray[i] = new Object();
                moveDirectionsArray[i].title = this._titlebarProperties["move.right"];
                moveDirectionsArray[i].direction = "right";
                i++;
                ibm.portal.debug.text( "this._rightMoveTargetId :"+this._rightMoveTargetId );
            }
            
            if(com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.portletMoveController._isValidUpMove("dndSrc"+this._fullPortletId) != null){
                this._upMoveTargetId = com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.portletMoveController._isValidUpMove("dndSrc"+this._fullPortletId);
                moveDirectionsArray[i] = new Object();
                moveDirectionsArray[i].title = this._titlebarProperties["move.up"];
                moveDirectionsArray[i].direction = "up";
                i++;
                ibm.portal.debug.text( "this._upMoveTargetId :"+this._upMoveTargetId );
            }
            
            if(com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.portletMoveController._isValidDownMove("dndSrc"+this._fullPortletId) != null){
                this._downMoveTargetId = com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.portletMoveController._isValidDownMove("dndSrc"+this._fullPortletId);
                moveDirectionsArray[i] = new Object();
                moveDirectionsArray[i].title = this._titlebarProperties["move.down"];
                moveDirectionsArray[i].direction = "down";
                ibm.portal.debug.text( "this._downMoveTargetId :"+this._downMoveTargetId );
            }
            
            ibm.portal.debug.exit( "IbmSkin._getValidMoves", moveDirectionsArray );
            return moveDirectionsArray;     // Array
        },
        _createPortletMoveMenu: function( /*Array*/ moveMenuItemsArray ) {
            // summary: Creates and populatese the portlet move menu.
            // moveMenuItemsArray: the array of menu items
            ibm.portal.debug.entry( "IbmSkin._createPortletMoveMenu" );
            
            var menuId = "contextMenu_"+"moveMenu"+this._fullPortletId;
            menu = createContextMenu(menuId, !bidiSupport.isRTL, ""/*menuBorderStyle*/, "wptheme-skinContextMenuTable"/*menuTableStyle*/, this._engineProperties["info.emptymenu"] );
            // Cycle through the move menu item array.
            for ( i=0; i < moveMenuItemsArray.length; i+=1 ) {
                if ( moveMenuItemsArray[i] && moveMenuItemsArray[i].length != 0 ){
                    menu.add( new UilMenuItem( moveMenuItemsArray[i].title, true, '',  'dojo.publish("/portal/Skin/MoveMenu/'+this._fullPortletId+'",[{direction: "'+moveMenuItemsArray[i].direction+'"}]);', null, null/*icon*/, null, 'wptheme-skinContextMenuItem'/*menuItemStyle*/, 'wptheme-skinContextMenuItemHover'/*menuItemSelectedStyle*/) );
                }
            }
            
            ibm.portal.debug.exit( "IbmSkin._createPortletMoveMenu" ); 
        },
        _createDeletePortletLink: function( container ){
            // summary: Creates the delete portlet link and attaches it's event handlers.
            // container: the element which will contain the portlet link
            ibm.portal.debug.entry( "IbmSkin._createDeletePortletLink", [ container ] );
            
            //Render the delete portlet link. This is the lone link rendered on the portletModesElem if the portlet is minimized.
            var spanDeleteElement = document.createElement('SPAN');
            spanDeleteElement.className= "wpsPortletModesSpan";
            var titlebarProperties = dojo.i18n.getLocalization("com.ibm.portal", "titlebar", csaUserLocale);
            var deleteAnchor = com.ibm.portal.utilities.html.createAnchor( spanDeleteElement,
                                                                          "javascript:void(0);",
                                                                          "portletModesLink_" + this._id,
                                                                          titlebarProperties["delete"],
                                                                          "wpsPortletModes" );
                              
            dojo.connect( deleteAnchor, "onclick", dojo.hitch(this,"deletePortlet") );
            container.appendChild(spanDeleteElement);
           
           ibm.portal.debug.exit( "IbmSkin._createDeletePortletLink" );
        },
        _createActiveModeAnchor: function( container, mode, title ) {
            // summary: Creates the currently active mode anchor and attaches it's event handlers.
            // description: The currently active mode anchor is different from the other modes in that
            //      toggles the display of the active mode (for modes other than VIEW only).
            // container: the element which should contain the link
            // mode: the active mode name
            // title: the localized string for the active mode
            ibm.portal.debug.entry( "IbmSkin._createActiveModeAnchor", [ container, mode, title ] );
            
            var me = this;
            var spanActiveElement = document.createElement('SPAN');
            spanActiveElement.className= "wpsPortletModesSpan" ;

            var activeModeAnchor = com.ibm.portal.utilities.html.createAnchor( 
                spanActiveElement, 
                "javascript:void(0);",
                "activeModeLink_" + me._fullPortletId, 
                title,
                "wpsActiveModeLink");
                   
            dojo.connect( activeModeAnchor , "onmouseover", function () { dojo.byId( "activeModeLink_" + me._fullPortletId ).className='wpsActiveModeLinkHover'; } );
            dojo.connect( activeModeAnchor , "onmouseout", function () { dojo.byId( "activeModeLink_" + me._fullPortletId ).className='wpsActiveModeLink'; } );
            dojo.connect( activeModeAnchor , "onclick", dojo.hitch(me,"togglePortletModesDisplay") );
            container.appendChild(spanActiveElement);
            
            ibm.portal.debug.exit( "IbmSkin._createActiveModeAnchor" );
        },
        
        // ************************** PORTLET MODE SWITCHING FUNCTIONS *************************************
        _createModeFunction: function ( label, type) {
            //summary: create and return a function to load a portlet mode
            // label: actual mode name to be created, values must match mode constants as specified by state apis
            // type: skin method call suffix. i.e. "Help" will cause function _doHelp to be returned.
            ibm.portal.debug.entry("IbmSkin._createModeFunction",[label, type]);
            
            var portletWindowState = null;
            
            if ( label == "help" && this._currentWindowState == ibm.portal.portlet.WindowState.MINIMIZED ) {
                portletWindowState = ibm.portal.portlet.WindowState.NORMAL;
            }
            
            var state = com.ibm.portal.navigation.controller.NAVIGATION_CONTROLLER.getState();
            var url = state.newPortletRenderURL(/*portletWindowId*/this._portletWindowId, /*portletMode*/label, /*windowstate*/portletWindowState );
            
            ibm.portal.debug.exit( "IbmSkin._createModeFunction" );
            return this["_do"+type]( url );
        },
        _createClientModeFunction: function ( label, clientModeFn ) {
            //summary: Use mode function on client and check for markup update
            // label: actual mode name to be created, values must match mode constants as specified by state apis
            // clientModeFn: the function on the client to be called
            ibm.portal.debug.entry("IbmSkin._createClientModeFunction",[label, clientModeFn]);
            
            var updateMarkup = window[clientModeFn](label, this._getModesContainer() );
            
            if(updateMarkup){
                var state = com.ibm.portal.navigation.controller.NAVIGATION_CONTROLLER.getState();
                var url = state.newPortletRenderURL(this._portletWindowId, label);
                this._doMode(url);
            }
            
            ibm.portal.debug.exit( "IbmSkin._createClientModeFunction" );
        },
        _doMode: function ( url ) {
            // summary: Change to a particular mode.
            // url: the portlet url for switching to another portlet mode (Any except VIEW and HELP)
            ibm.portal.debug.entry( "IbmSkin._doMode", [ url ] );
            
            this.actionsLoaded = false;
            this._activeDiv = this._getModesContainer();
            
            var serviceReq = new com.ibm.portal.services.PortletFragmentService();
            serviceReq.getPortletInfo( this._fullPortletId, url );
            
            this._show(this._getModesContainer());
            this._show(this._getPortletActionsShelf().id);
            
            ibm.portal.debug.exit( "IbmSkin._doMode" );
        },
        _doBack: function ( url ) {
            // summary: Return to VIEW mode.
            // url: the url to return to VIEW mode
            ibm.portal.debug.entry( "IbmSkin._doBack", [ url ] );
            
            this._activeDiv = this._getModesContainer();
            this.actionsLoaded = false;
            
            var serviceReq = new com.ibm.portal.services.PortletFragmentService();
            serviceReq.getPortletInfo( this._fullPortletId, url );
            
            this._UIState.setInlineModeContainerHidden();
            this._hide(this._getModesContainer());
            this._UIState.setPortletActionsShelfCollapsed();
            this._hide(this._getPortletActionsShelf());
            
            dojox.data.dom.removeChildren( this._getModesContainer() );
            ibm.portal.debug.exit( "IbmSkin._doBack" );
        },
        _doHelp: function ( url ) {
            // summary: Changes to help mode.
            // description: Help mode is unique in this skin because it renders the help in a new browser
            //      window. To accomplish that, we have to intercept the response (make a stateless portlet request
            //      - see PortletFragmentService.js) and simply write the markup to the new window.
            // url: the url for help mode
            ibm.portal.debug.entry( "IbmSkin._doHelp", [ url ] );
            
            var stateManager = new com.ibm.portal.state.StateManager( ibmPortalConfig.contentHandlerURI );
            stateManager.reset( dojox.data.dom.createDocument() );
            
            var selectionAcc = stateManager.newSelectionAccessor();
            var selectionId = com.ibm.portal.utilities.getSelectionNodeId( this._fullPortletId );
            selectionAcc.setPageSelection( selectionId );
            selectionAcc.getParameters().setValue( "renderMode", "force_ssa" );
            
            var portletAcc = stateManager.newPortletAccessor( this._portletWindowId );
            portletAcc.setPortletMode( ibm.portal.portlet.PortletMode.HELP );
            
            var templateAcc = stateManager.newThemeTemplateAccessor();
            templateAcc.setThemeTemplate( "Plain" );
            
            var s11nManager = stateManager.getSerializationManager();
            s11nManager.serialize( stateManager.getState(), false, function ( status, state, serializedURL ) { 
            	window.open(serializedURL, 'helpWindow','resizable=yes,scrollbars=yes,menubar=no,toolbar=yes,status=no,width=800px,height=600px,screenX=10px,screenY=10px,top=10px,left=10px');
            });
            
            //var service = new com.ibm.portal.services.PortletFragmentService();
            //var me = this;
            //var win = window.open(url + "&renderMode=force_ssa", 'helpWindow','resizable=yes,scrollbars=yes,menubar=no,toolbar=yes,status=no,width=800px,height=600px,screenX=10px,screenY=10px,top=10px,left=10px');                              
                                                                        
            /*service.getPortletInfo( 
                me._fullPortletId, 
                url,
                function ( pInfo ) { 
                    win.document.write('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">');
                    win.document.write('<html><head><title>IBM WebSphere Portal - Help</title><style type="text/css">');
                    
                    //Copy over stylesheet information so everything displays correctly.
                    if ( dojo.isIE ){
                        for(var i = 0; i < document.styleSheets.length; i++ ){
                            win.document.write(document.styleSheets[i].cssText);
                        }
                    } else {
                        for(var i = 0; i < document.styleSheets.length; i++ ){
                            var ii = 0;
                            do{
                                var cssRule = document.styleSheets[i].cssRules[ii];                                                     
                                if(cssRule){
                                    win.document.write(cssRule.cssText);
                                }                                                           
                                ii++;
                            }while(cssRule)
                        }
                    }
                    win.document.write('</style></head><body>');
                    
                    //Write the help markup into the body element.
                    win.document.write(pInfo.markup);
                    
                    win.document.write('</body></html>');
                    win.document.close();
                    //We need special handling for FF.
                    if ( window.addEventListener ) {
                        var handler = new com.ibm.portal.aggregation.event.NamedAnchorHandler();
                        win.document.addEventListener( "click", function (e) { handler.handle(e); }, true );
                    }   
                },
                null,
                //This parameter makes the request stateless. This means our normal processing of a response will not occur and
                //it's entirely up to the callback function passed into the getPortletInfo function to do something interesting
                //with the response. The navigational state on the client for this portlet will also NOT be updated by this request.
                true
            );*/
            
            ibm.portal.debug.exit( "IbmSkin._doHelp" );
        },
        // ************************** PORTLET WINDOW STATE SWITCHING FUNCTIONS *************************************
        _doMaximize: function( /*Object*/ args ) {           
            // summary: Maximize the window object. 
            // description: This function can be called two ways. One is the dojo subscription topic which is called
            //      when the user selects the "Maximize" option on the window states menu. The second way is when the portlet
            //      is first rendered, if it's initial window state is "Maximized", this function will be called to perform
            //      the necessary DOM manipulations to make the window maximized with the existing markup (as the initial
            //      request will already contain the "maximized" markup). In this second case, the "args" parameter is expected
            //      to be NULL. 
            // args: Expects a single property "url" with the maximize portlet url. 
            ibm.portal.debug.entry( "IbmSkin._doMaximize", [ args ] );
            
            var update = true;
            
            if( typeof window["PC_"+this._portletWindowId+"_doWindowState"] == "function" ){
                update = window["PC_"+this._portletWindowId+"_doWindowState"]("maximized",this._getPortletContainer());
            }   
            
            if(update){
                var url = null;
                if(args != null){
                    this.actionsLoaded = false;
                    url = args["url"];
                }
    
                if(dojo.byId(this._fullPortletId+"_minimized") != null){
                    this.unMinimize();
                }
                
                var main = dojo.byId("mainContent");
                var portlet = this._getPortletContainer();
                var portletParent = dojo.byId("portlet_"+this._fullPortletId).parentNode;
                
                var placeHolderDiv = document.createElement("div");
                placeHolderDiv.id = "maximized_portlet_placeholder"+this._fullPortletId;
                portletParent.appendChild(placeHolderDiv);
                
                main.appendChild(portlet);
                
                this._hide(main.childNodes[0].id);
                
                //Markup can be different depending on the portlet window state so give the portlet a chance to adjust to it's
                //new window state.
                if(url != null){                    
                    dojo.publish("/portal/Skin/ClearMenu/"+this._fullPortletId,[{menuId: "contextMenu_windowStateMenu"+this._fullPortletId}]);  
                    var serviceReq = new com.ibm.portal.services.PortletFragmentService();
                    serviceReq.getPortletInfo( this._fullPortletId, url );
                }
            }
            
            ibm.portal.debug.exit( "IbmSkin._doMaximize" );
        },
        _doMinimize: function ( /*Object*/ args ) {
            // summary: Minimize the window object. 
            // description: This function can be called two ways. One is the dojo subscription topic which is called
            //      when the user selects the "Minimize" option on the window states menu. The second way is when the portlet
            //      is first rendered, if it's initial window state is "Minimized", this function will be called to perform
            //      the necessary DOM manipulations to make the window minimized with the existing markup (as the initial
            //      request will already contain the "minimized" markup). In this second case, the "args" parameter is expected
            //      to be NULL. 
            // args: Expects a single property "url" with the maximize portlet url.
            ibm.portal.debug.entry( "IbmSkin._doMinimize", [ args ] );
            
            var update = true;
            
            if( typeof window["PC_"+this._portletWindowId+"_doWindowState"] == "function" ){
                update = window["PC_"+this._portletWindowId+"_doWindowState"]("minimized",this._getPortletContainer());
            }  
            
            if(update){
                var url = null;
                if(args != null){
                    this.actionsLoaded = false;
                    url = args["url"];
                }
                if(dojo.byId("maximized_portlet_placeholder"+this._fullPortletId) != null){
                    this.unMaximize();
                }
                
				// create a div  that will contain the inline mode and the portlet body div 
                var hiddenDiv = document.createElement("DIV");
                hiddenDiv.id = this._fullPortletId+"_minimized";
                if(!this._isHidden(this._getPortletActionsShelf())){
                    this._hide(this._getPortletActionsShelf());
                }
                
                var portlet = dojo.byId(this._fullPortletId);
                var modesContainer = dojo.byId(this._getModesContainer());
                var portletParent = portlet.parentNode;
                
                portletParent.insertBefore(hiddenDiv, modesContainer);
                hiddenDiv.appendChild(modesContainer);
                portletParent.removeChild(portlet);
                var tempNode = portlet;
				// this code must be here for a reason?
                if(dojo.isOpera) {
                    tempNode = document.createElement("div");
                    tempNode.innerHTML = portlet.innerHTML;
                    tempNode.setAttribute('id', portlet.getAttribute('id'));
                    tempNode.setAttribute('class', portlet.getAttribute('class'));
                    tempNode.setAttribute('loaded', portlet.getAttribute('loaded'));
                    delete portlet;
                }
                hiddenDiv.appendChild(tempNode);
                
				// hide the new containing div so both the inline mode and portletbody will be hidden
                this._hide(this._fullPortletId+"_minimized");
                
                //Markup can be different depending on the portlet window state so give the portlet a chance to adjust to it's
                //new window state.
                if(url != null){
                    dojo.publish("/portal/Skin/ClearMenu/"+this._fullPortletId,[{menuId: "contextMenu_windowStateMenu"+this._fullPortletId}]);
                    var serviceReq = new com.ibm.portal.services.PortletFragmentService();
                    serviceReq.getPortletInfo( this._fullPortletId, url );
                }
            }
            
            ibm.portal.debug.exit( "IbmSkin._doMinimize" );
        },
        _doRestore: function ( /*Object*/ args ) {
            // summary: Returns the portlet window state to NORMAL.
            // args: Expects a single property "url" with the maximize portlet url.
            ibm.portal.debug.entry( "IbmSkin._doRestore", [ args ]);
            
            var update = true;
            
            if( typeof window["PC_"+this._portletWindowId+"_doWindowState"] == "function" ){
                update = window["PC_"+this._portletWindowId+"_doWindowState"]("normal",this._getPortletContainer());
            }  
            
            if(update){
                var url = null;
                if(args != null){
                    this.actionsLoaded = false;
                    url = args["url"];
                }
                
                if(url != null){
                    dojo.publish("/portal/Skin/ClearMenu/"+this._fullPortletId,[{menuId: "contextMenu_windowStateMenu"+this._fullPortletId}]);
                    var serviceReq = new com.ibm.portal.services.PortletFragmentService();
                    serviceReq.getPortletInfo( this._fullPortletId, url );
                }else{
                    if(dojo.byId("maximized_portlet_placeholder"+this._fullPortletId) != null){
                        this.unMaximize();
                    }else{
                        this.unMinimize();
                    }
                }
            }
            
            ibm.portal.debug.exit( "IbmSkin._doRestore" );
        },
        unMaximize: function () {
            // summary: Performs the necessary DOM manipulations to return the window state to NORMAL from MAXIMIZED.
            //      NO portlet markup is updated as a result of a call to this function.
            ibm.portal.debug.entry( "IbmSkin.unMaximize");
            this.actionsLoaded = false;
            
            var main = dojo.byId("mainContent");
            
            maximizedPortlet = this._getPortletContainer();
            
            var origPortletDiv = dojo.byId("maximized_portlet_placeholder"+this._fullPortletId);
            var origPortletParent = origPortletDiv.parentNode;
            
            origPortletParent.replaceChild(maximizedPortlet, origPortletDiv);
            
            var origLayoutNode = main.childNodes[0];
            this._show(origLayoutNode.id);
            
            ibm.portal.debug.exit( "IbmSkin.unMaximize" );
        },
        unMinimize: function () {
            // summary: Performs the necessary DOM manipulations to return the window state to NORMAL from MINIMIZED.
            //      NO portlet markup is updated as a result of a call to this function.
            ibm.portal.debug.entry( "IbmSkin.unMinimize");
            this.actionsLoaded = false;
            
			// find the hidden div that contains the portlet markup
            var hiddenDiv = dojo.byId(this._fullPortletId+"_minimized");
            var modesContainer = hiddenDiv.childNodes[0];
            var portlet = hiddenDiv.childNodes[1];
            var portletParent = hiddenDiv.parentNode;
            // move the  contents back out of the hidden div 
            portletParent.appendChild(modesContainer);
            portletParent.appendChild(portlet);
            
            // cleanup by removing the hiddendiv 
            portletParent.removeChild(hiddenDiv);
            ibm.portal.debug.exit( "IbmSkin.unMinimize" );
        },
        
        // ************************** MISCELLANEOUS SKIN ACTION FUNCTIONS *************************************
        refreshPortlet: function () {
            // summary: Refreshes this portlet using the navigational state currently stored on the client.
            ibm.portal.debug.entry( "IbmSkin.refreshPortlet" );
            
            this.actionsLoaded = false;
            
            var portletElem = this._getPortletContainer();
            
            if (document.all ){     
                portletElem.style.cssText = "filter: alpha(opacity=25); background-color: #c1c1c1;";
            }else{
                portletElem.setAttribute('style', "-moz-opacity: .25; background-color: #c1c1c1;");
            }
                        
            var state = com.ibm.portal.navigation.controller.NAVIGATION_CONTROLLER.getState();
            var url = state.newPortletRenderURL( this._portletWindowId );
            var serviceReq = new com.ibm.portal.services.PortletFragmentService();
            var me = this;
            
            
            serviceReq.getPortletInfo( 
                this._fullPortletId,
                url,
                function () {       
                    portletElem.removeAttribute("style");   
                }
            );
            
            ibm.portal.debug.exit( "IbmSkin.refreshPortlet" );
        },
        deletePortlet: function(){
            // summary: Confirms that the user wishes to delete the portlet, performs the DOM manipulations
            //      and sends the DELETE request to the Portal REST services.
            ibm.portal.debug.entry( "IbmSkin.deletePortlet" );
            
            //Are you sure?????
            var check = confirm(this._titlebarProperties["delete.confirm"]);
            
            if( check ) {
                //If the portlet is maximized, we have to undo our MAXIMIZE DOM manipulations so that the
                //other portlets on the page are visible once this one is deleted. Also there are no drop 
                //zones to clean up in the maximized case.
                if( dojo.byId("maximized_portlet_placeholder"+this._fullPortletId) != null ) {
                    var main = dojo.byId("mainContent");                   
                    var maxPortlet = main.childNodes[0];
                    var origLayoutNode = main.childNodes[1];
                    
                    this._show(origLayoutNode.id);
                    main.removeChild(maxPortlet);
                    
                    // var portlet = dojo.byId("dndSrc"+this._fullPortletId);
                    var portlet = dojo.byId("portlet_"+this._fullPortletId);
                    var portletParent = portlet.parentNode;
                    
                    portletParent.removeChild(portlet);
                } else {
                    //Clean up the drop zones and containers.
                    var portlet = dojo.byId("dndSrc"+this._fullPortletId);
                    var portletDZ = dojo.byId("tgt_dndSrc"+this._fullPortletId);
                    var container = CSADND_getPortletsContainer(portlet);
                    var containerType = container.getAttribute("CSAContainerType");
                    
                    if(containerType == "UCV"){
                        var parent = portlet.parentNode;
                        var parentDZ = portletDZ.parentNode.parentNode;
                        
                        container.childNodes[0].removeChild(parentDZ);
                        container.childNodes[0].removeChild(parent);
                    }else{
                        var parentDZ = portletDZ.parentNode;
                        
                        container.childNodes[0].childNodes[0].removeChild(parentDZ);
                        container.childNodes[0].childNodes[0].removeChild(portlet);
                    }
                }
                //Make sure to call destroy on the fragment so that all the events are properly unhooked.
                var fragment = com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.getFragment( this._fullPortletId );
                if ( fragment ) {
                    fragment.destroy();
                }
                com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.layoutManager.deletePortletInLayoutManager( this._fullPortletId );
                //Finally, send the request to the Portal REST services to persist the change to the layout model.  
                this._makeDeleteRequest( this._fullPortletId );
            } else {
                //The user apparently didn't really want to the delete the portlet.
                ibm.portal.debug.exit( "IbmSkin.deletePortlet", false );
                return false;
            }
            
            ibm.portal.debug.exit( "IbmSkin.deletePortlet" );
        },
        _makeDeleteRequest: function( controlId ) {
            // summary: Sends the DELETE request to the Portal REST Services to remove this portlet from
            //      the layout model.
            // controlId: the object id of the Control(PortletWindow)
            ibm.portal.debug.entry( "IbmSkin._makeDeleteRequest", arguments );
            
            //validate input params
            if (!controlId){
                ibm.portal.debug.text("_makeDeleteRequest: a required parameter is missing or null.");
                return false;
            }

            var deleteURL = ibmPortalConfig["contentHandlerURI"]+ '?uri='+controlId;
            ibm.portal.debug.text("_makeDeleteRequest: Delete URL is " + deleteURL);

            //get resource bundle for status messages
            var v3themeProperties = dojo.i18n.getLocalization("com.ibm.portal", "v3theme", csaUserLocale);
                            
            var request = new com.ibm.portal.services.PortalRestServiceRequest( { url: deleteURL } );
            request.remove( function(type, data, xhr, callbackargs){
                    var resTxt = data;
                    if (type == "load") {
                        ibm.portal.debug.text("_makeDeleteRequest: success: "+resTxt);
                        var statusMessage = new com.ibm.portal.aggregation.StatusMessage('info', v3themeProperties["portletDeleteOk"], "");
                        dojo.publish("/portal/status",[{message: statusMessage}]);
                        dojo.publish("/portal/Skin/RefreshSkins/");
                    } else {
                        ibm.portal.debug.text("_makeDeleteRequest: failure: "+resTxt);
                        var statusMessage = new com.ibm.portal.aggregation.StatusMessage('error', v3themeProperties["portletDeleteFailed"], resTxt);
                        dojo.publish("/portal/status",[{message: statusMessage}]);
                        dojo.publish("/portal/PortalPage/reload");
                    }
            } );
            
            ibm.portal.debug.exit( "IbmSkin._makeDeleteRequest" );
        },
        movePortlet: function( /*Object*/ args ) {
            // summary: Moves the portlet in the specified direction.
            // args: Expects a single property called "direction" with a value of "left","right","up","down"
            ibm.portal.debug.entry( "IbmSkin.movePortlet", [ args ] );
            
            //Make sure we have a valid direction.
            var direction = null;
            if(args != null){
                direction = args["direction"];
            }
            //Part of the complication of moving portlets around is the drop zones. The DND javascript
            //already knows how to do this, so let it handle the heavy lifting for us.
            var sourceContainer = CSADND_getPortletsContainer(dojo.byId("dndSrc"+this._fullPortletId));
            ibm.portal.debug.text("movePortlet: _leftMoveTargetId is " + this._leftMoveTargetId);
            ibm.portal.debug.text("movePortlet: _rightMoveTargetId is " + this._rightMoveTargetId);
            ibm.portal.debug.text("movePortlet: _upMoveTargetId is " + this._upMoveTargetId);
            ibm.portal.debug.text("movePortlet: _downMoveTargetId is " + this._downMoveTargetId);
            ibm.portal.debug.text("movePortlet: direction is " + direction);
            
            var targetId = null;
            if(direction != null){
                if(direction == "left"){
                    targetId = this._leftMoveTargetId;
                }
                else if(direction == "right"){
                    targetId = this._rightMoveTargetId;
                }
                else if(direction == "up"){
                    targetId = this._upMoveTargetId;
                }
                else if(direction == "down"){
                    targetId = this._downMoveTargetId;
                }
            }
            
            if(targetId != null) {
                com.ibm.portal.aggregation.PORTAL_AGGREGATOR.page.portletMoveController._findAndMovePortlet(sourceContainer, "dndSrc"+this._fullPortletId, targetId, direction);
            }
            
            if(direction != null){
                dojo.publish("/portal/Skin/MoveMenu/"+this._fullPortletId,[{menuId: "contextMenu_moveMenu"+this._fullPortletId}]);
                dojo.publish("/portal/Skin/RefreshSkins/", [{menuId: "contextMenu_moveMenu"+this._fullPortletId}]);
            }
            
            ibm.portal.debug.exit( "IbmSkin.movePortlet" );
        },
        refreshSkins: function() {
            // summary: Called to update the move menus after a portlet is moved on the client.
            ibm.portal.debug.entry( "IbmSkin.refreshSkins" );            
            
            //Clear the menu.
            this.clearMenuContents( "moveMenu" );
            var moveDirectionsArray = this._getValidMoves();
            //Load the menu items.
            this._createPortletMoveMenu( moveDirectionsArray );
            
            ibm.portal.debug.exit( "IbmSkin.refreshSkins" );
        },
        displayPortletMenu: function ( menuType ){
            // summary: Displays a portlet menu.
            // menuType: the menu type - "moveMenu" or "windowStatesMenu"
            ibm.portal.debug.entry( "IbmSkin.displayPortletMenu", [ menuType ] );
            
            var menuId = "contextMenu_"+menuType+this._fullPortletId;
            var menu = getContextMenu(menuId);
            var targetImg = document.getElementById( "menu_"+menuType+this._fullPortletId );                
            
            ibm.portal.debug.exit( "IbmSkin.displayPortletMenu" );
            return showContextMenu( menuId , targetImg ); 
        },
        clearMenuContents: function( menuType ){                    
            // summary: Clears the contents of a portlet menu.
            // menuType: the menu type - "moveMenu" or "windowStatesMenu"
            ibm.portal.debug.entry( "IbmSkin.clearMenuContents" );
            
            var menuId = "contextMenu_"+menuType+this._fullPortletId;
            var menu = getContextMenu(menuId);
            if ( menu ) {
                uncacheContextMenu(menu);
            }
            
            ibm.portal.debug.exit( "IbmSkin.clearMenuContents" );   
        }
    }
);


}
