<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:thr="http://purl.org/syndication/thread/1.0" 
	xmlns:atom="http://www.w3.org/2005/Atom" 
	xmlns:xhtml="http://www.w3.org/1999/xhtml" 
	xmlns:model="http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model-elements" 
	xmlns:base="http://www.ibm.com/xmlns/prod/websphere/portal/v6.0/ibm-portal-composite-base" 
	xmlns:portal="http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model" 
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<xsl:output method='html' version='1.0' encoding='UTF-8' indent='yes'/>

<xsl:param name="nmPrefix"/>
<xsl:param name="rootNode" />

<xsl:key name="parent" match="atom:entry" use="atom:id"/>
<xsl:key name="children" match="atom:entry" use="thr:in-reply-to/@portal:uri"/>

<xsl:template match="/atom:feed">
	<div>
		<xsl:apply-templates select="atom:entry[atom:id=$rootNode]">
			<xsl:with-param name="direction">up</xsl:with-param>
		</xsl:apply-templates>	
	</div>
</xsl:template>

<!-- IMPORTANT!!!!! If you make any changes to the attribute names below (add, delete, modify), you need to also make the same changes in the constructor of NavigationNode AND
      in the _populateNewDoc function of the NavigationModel. Otherwise, the client-side aggregation code will be broken in IE only. -->

<!-- page -->
<xsl:template match="atom:entry[atom:content/model:content-page]">
	<xsl:param name="direction"/>
	
	<xsl:choose>
		<xsl:when test="(thr:in-reply-to) and ($direction != 'down')">
			<xsl:apply-templates select="key('parent',thr:in-reply-to/@portal:uri)" >
				<xsl:with-param name="direction" select="thr:in-reply-to/@portal:uri" />
			</xsl:apply-templates>
		</xsl:when>	
	 
		<xsl:otherwise> 
			<div style="display:none;" >
		  	  <xsl:attribute name="id"><xsl:value-of select="$nmPrefix" /><xsl:value-of select="atom:id" /></xsl:attribute>
			  <xsl:choose>
			      	<xsl:when test="atom:link[@rel='replies']">
			          <xsl:attribute name="hasChildren">true</xsl:attribute>
					  <xsl:attribute name="childrenURI"><xsl:value-of select="atom:link[@rel='replies']/@href" /></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="hasChildren">false</xsl:attribute>	
					</xsl:otherwise>
			   </xsl:choose>
			   <xsl:if test="atom:link[@portal:rel='theme']">
			   		<xsl:attribute name="theme" ><xsl:value-of select="atom:link[@portal:rel='theme']/@portal:uri" /></xsl:attribute>
			   </xsl:if>
			   <xsl:attribute name="contentNodeType">COMPOSITION</xsl:attribute>
			   <xsl:attribute name="lmURI"><xsl:value-of select="atom:link[@portal:rel='layout']/@href"/></xsl:attribute>
			   <xsl:attribute name="localizedTitle"><xsl:value-of select="atom:title" /></xsl:attribute>
			   <xsl:attribute name="childOf"><xsl:value-of select="thr:in-reply-to/@portal:uri" /></xsl:attribute>
			   <xsl:attribute name="themePolicy"><xsl:value-of select="./atom:content/*/model:metadata[@name='com.ibm.portal.ThemePolicy']/base:value/@value" /></xsl:attribute>
			   <xsl:attribute name="applicationGuid"><xsl:value-of select="./atom:content/*/model:metadata[@name='com.ibm.portal.applicationGuid']/base:value/@value" /></xsl:attribute>
			   <xsl:apply-templates select="key('children',atom:id)" >
			   	<xsl:with-param name="direction">down</xsl:with-param>
			   </xsl:apply-templates>	
		  	</div>
		</xsl:otherwise>
	</xsl:choose>	  	
  
</xsl:template>

<!-- label -->
<xsl:template match="atom:entry[atom:content/model:content-label]">
	<xsl:param name="direction"/>
	
	<xsl:choose>
		<xsl:when test="(thr:in-reply-to) and ($direction != 'down')">
			<xsl:apply-templates select="key('parent',thr:in-reply-to/@portal:uri)" >
				<xsl:with-param name="direction" select="thr:in-reply-to/@portal:uri" />
			</xsl:apply-templates>
		</xsl:when>	
	 
		<xsl:otherwise>
			<div style="display:none;" >
		  	  <xsl:attribute name="id"><xsl:value-of select="$nmPrefix" /><xsl:value-of select="atom:id" /></xsl:attribute>
			  <xsl:choose>
			      	<xsl:when test="atom:link[@rel='replies']">
			          <xsl:attribute name="hasChildren">true</xsl:attribute>
					  <xsl:attribute name="childrenURI"><xsl:value-of select="atom:link[@rel='replies']/@href" /></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="hasChildren">false</xsl:attribute>	
					</xsl:otherwise>
			   </xsl:choose>
			   <xsl:if test="atom:link[@portal:rel='theme']">
			   		<xsl:attribute name="theme" ><xsl:value-of select="atom:link[@portal:rel='theme']/@portal:uri" /></xsl:attribute>
			   </xsl:if>
			   <xsl:attribute name="contentNodeType">LABEL</xsl:attribute>
			   <xsl:attribute name="localizedTitle"><xsl:value-of select="atom:title" /></xsl:attribute>
			   <xsl:attribute name="childOf"><xsl:value-of select="thr:in-reply-to/@portal:uri" /></xsl:attribute>
			   <xsl:attribute name="themePolicy"><xsl:value-of select="./atom:content/*/model:metadata[@name='com.ibm.portal.ThemePolicy']/base:value/@value" /></xsl:attribute>
			   <xsl:attribute name="applicationGuid"><xsl:value-of select="./atom:content/*/model:metadata[@name='com.ibm.portal.applicationGuid']/base:value/@value" /></xsl:attribute>
			   <xsl:apply-templates select="key('children',atom:id)" >
			   	<xsl:with-param name="direction">down</xsl:with-param>
			   </xsl:apply-templates>
		  	</div>
		</xsl:otherwise>		  		
  </xsl:choose>
</xsl:template>

<!-- url -->
<xsl:template match="atom:entry[atom:content/model:content-url]">
	<xsl:param name="direction"/>
	
	<xsl:choose>
		<xsl:when test="$direction='up'">
			<xsl:apply-templates select="key('parent',thr:in-reply-to/@portal:uri)" >
				<xsl:with-param name="direction">up</xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>	
	 
		<xsl:when test="$direction='down'">
			<div style="display:none;" >
		  	  <xsl:attribute name="id"><xsl:value-of select="$nmPrefix" /><xsl:value-of select="atom:id" /></xsl:attribute>
			  <xsl:choose>
			      	<xsl:when test="atom:link[@rel='replies']">
			          <xsl:attribute name="hasChildren">true</xsl:attribute>
					  <xsl:attribute name="childrenURI"><xsl:value-of select="atom:link[@rel='replies']/@href" /></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="hasChildren">false</xsl:attribute>	
					</xsl:otherwise>
			   </xsl:choose>
			   <xsl:choose>
			   		<xsl:when test="atom:link[@portal:rel='external-url']">
						<xsl:attribute name="contentNodeType">EXTERNAL-URL</xsl:attribute>
						<xsl:attribute name="cmURI"><xsl:value-of select="atom:link[@portal:rel='external-url']/@href"/></xsl:attribute>
					</xsl:when>
					<xsl:when test="atom:link[@portal:rel='internal-url']">
						<xsl:attribute name="contentNodeType">INTERNAL-URL</xsl:attribute>
						<xsl:attribute name="cmURI"><xsl:value-of select="atom:link[@portal:rel='internal-url']/@portal:uri"/></xsl:attribute>
					</xsl:when>
			   </xsl:choose>
			   <xsl:if test="atom:link[@portal:rel='theme']">
			   		<xsl:attribute name="theme" ><xsl:value-of select="atom:link[@portal:rel='theme']/@portal:uri" /></xsl:attribute>
			   </xsl:if>
			   <xsl:attribute name="localizedTitle"><xsl:value-of select="atom:title" /></xsl:attribute>
			   <xsl:attribute name="childOf"><xsl:value-of select="thr:in-reply-to/@portal:uri" /></xsl:attribute>
			   <xsl:attribute name="themePolicy"><xsl:value-of select="./atom:content/*/model:metadata[@name='com.ibm.portal.ThemePolicy']/base:value/@value" /></xsl:attribute>
			   <xsl:attribute name="applicationGuid"><xsl:value-of select="./atom:content/*/model:metadata[@name='com.ibm.portal.applicationGuid']/base:value/@value" /></xsl:attribute>
			   <xsl:apply-templates select="key('children',atom:id)"/>
		  </div>
		</xsl:when>	  
  </xsl:choose>	
</xsl:template>

<xsl:template match="atom:entry[atom:content/model:static-content-page]">
	<xsl:param name="direction"/>
	
	<xsl:choose>
		<xsl:when test="(thr:in-reply-to) and ($direction != 'down')">
			<xsl:apply-templates select="key('parent',thr:in-reply-to/@portal:uri)" >
				<xsl:with-param name="direction" select="thr:in-reply-to/@portal:uri" />
			</xsl:apply-templates>
		</xsl:when>	
	 
		<xsl:otherwise> 
			<div style="display:none;" >
		  	  <xsl:attribute name="id"><xsl:value-of select="$nmPrefix" /><xsl:value-of select="atom:id" /></xsl:attribute>
			  <xsl:choose>
			      	<xsl:when test="atom:link[@rel='replies']">
			          <xsl:attribute name="hasChildren">true</xsl:attribute>
					  <xsl:attribute name="childrenURI"><xsl:value-of select="atom:link[@rel='replies']/@href" /></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="hasChildren">false</xsl:attribute>	
					</xsl:otherwise>
			   </xsl:choose>
			   <xsl:if test="atom:link[@portal:rel='theme']">
			   		<xsl:attribute name="theme" ><xsl:value-of select="atom:link[@portal:rel='theme']/@portal:uri" /></xsl:attribute>
			   </xsl:if>
			   <xsl:attribute name="contentNodeType">STATIC-PAGE</xsl:attribute>
			   <xsl:attribute name="lmURI"><xsl:value-of select="atom:link[@portal:rel='layout']/@href"/></xsl:attribute>
			   <xsl:attribute name="localizedTitle"><xsl:value-of select="atom:title" /></xsl:attribute>
			   <xsl:attribute name="childOf"><xsl:value-of select="thr:in-reply-to/@portal:uri" /></xsl:attribute>
			   <xsl:attribute name="themePolicy"><xsl:value-of select="./atom:content/*/model:metadata[@name='com.ibm.portal.ThemePolicy']/base:value/@value" /></xsl:attribute>
			   <xsl:attribute name="applicationGuid"><xsl:value-of select="./atom:content/*/model:metadata[@name='com.ibm.portal.applicationGuid']/base:value/@value" /></xsl:attribute>
			   <xsl:apply-templates select="key('children',atom:id)" >
			   	<xsl:with-param name="direction">down</xsl:with-param>
			   </xsl:apply-templates>	
		  	</div>
		</xsl:otherwise>
	</xsl:choose>	  	
  
</xsl:template>

</xsl:stylesheet>
