/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["com.ibm.strategy.PageAddedNotificationStrategy"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.strategy.PageAddedNotificationStrategy"] = true;
dojo.provide("com.ibm.strategy.PageAddedNotificationStrategy");

dojo.require("com.ibm.strategy.Strategy");

dojo.declare("com.ibm.strategy.PageAddedNotificationStrategy",
	com.ibm.strategy.Strategy,
	{
		// extensions: Array
		//		Array of strings indicating which functions in this strategy should be used
		//		to wrap functions of the same name in the object this strategy is applied to.
		//		Extensions cannot be named "strategyInit", "around", or "proceed", as these
		//		reserved words for strategy management.
		// 		This extension is set in the pageBuilderTheme.js file in the theme,
		//		it is set for com.ibm.mm.builder.viewMorePage widget.
		extensions: ["save"],
		
		constructor: function(callback) {
			if(callback) this.callback = callback;
			ibmPortalConfig.isPageAddedStrategySet = true;
		},
		
		save: function() {
			var me = this,
				oldNavModelGetter = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel;
			com.ibm.mm.builder.utils.navigationUtil.getNavigationModel = function(){
				var navModel = oldNavModelGetter.apply(this, arguments);
				com.ibm.mm.builder.utils.navigationUtil.getNavigationModel = oldNavModelGetter;
				var oldCommit = navModel.commit;
				navModel.commit = function() {
					var dfd = oldCommit.apply(this, arguments);
					dfd.setOperationCallback(function(newNode){
						me.callback(newNode);
					});
					navModel.commit = oldCommit;
					return dfd;				
				}
				return navModel;
			};			
			var ret = this.proceed(arguments);

			return ret;
		},
		
		callback: function(newNode) {
			// summary: Function which is called at the end of the Deferred processing which
			// 		fires its operation callback when the share operation completes either
			// 		successfully or unsuccessfully.
		}
	}
);

}
