/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource['com.ibm.widgets.NewPageDialog']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['com.ibm.widgets.NewPageDialog'] = true;
dojo.provide('com.ibm.widgets.NewPageDialog');
dojo.require('dijit.Dialog');
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "Shelf", null, "ROOT,ar,ca,cs,da,de,el,en,es,fi,fr,hr,hu,it,iw,ja,ko,nl,no,pl,pt,pt-br,ro,ru,sk,sl,sv,th,tr,uk,zh,zh-tw", "ROOT,ar,ca,cs,da,de,el,en,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt,pt-br,ro,ru,sk,sl,sv,th,tr,uk,zh,zh-tw");
dojo.requireLocalization("com.ibm.bundles", "PageCreatorDialog", null, "ROOT,ar,ca,cs,da,de,el,en,es,fi,fr,hr,hu,it,iw,ja,ko,nl,no,pl,pt,pt-br,ro,ru,sk,sl,sv,th,tr,uk,zh,zh-tw", "ROOT,ar,ca,cs,da,de,el,en,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt,pt-br,ro,ru,sk,sl,sv,th,tr,uk,zh,zh-tw");
dojo.declare('com.ibm.widgets.NewPageDialog',
	[dijit.Dialog],
    {
		shelfBundle: null,
		dialogBundle: null,
		blankImg: "",
		autofocus: false,
		showMakePrivate: true,
		showFriendlyURL: true,
		value: {},
		
		templateString: '<div class="lotusDialogBorder lotusui" waistate="labelledby-${id}" wairole="dialog" role="dialog" index="-1" aria-labelledby="${id}" dojoAttachPoint="dialogDiv">' +
						'<div class="lotusDialog">' +
							'<h1>' +
								'<a href="javascript:void(0);" dojoAttachPoint="closeButtonNode" class="lotusBtnImg lotusClose" title="${closeText}">' +
									'<img src="${blankImg}" alt="" aria-label="${closeText}" />' +
									'<span class="lotusAltText">X</span>' +
								'</a>' +
								'<span dojoAttachPoint="titleNode">${titleText}</span>' +
							'</h1>' +
							'<form dojoAttachPoint="newPageForm" action="javascript:;">' +
								'<div dojoAttachPoint="containerNode" class="lotusDialogContent">' +
									'<div>' +
										'<div class="lotusMessage" dojoAttachPoint="newPageError" style="display: none" role="alert">' +
											'<span>${nlsTitleError}</span>' +
										'</div>' +
										'<div><label for="ibmPortalPageNameInput">${nlsPageTitle}</label></div>' +
										'<div><input id="ibmPortalPageNameInput" type="text" name="title" dojoAttachPoint="typingNode, focusNode" size="24"/></div><br />' +
										
										'<div dojoAttachPoint="divFriendlyURL">'+
											'<div><label for="ibmPortalFriendlyUrlInput">${nlsFriendlyURL}:</label></div>' +
											'<div><input id="ibmPortalFriendlyUrlInput" type="text" name="friendlyURL" dojoAttachPoint="newPageFriendlyURL" size="24"/></div>'+
										'</div><br />' +
										
										'<div dojoAttachPoint="divPrivate">' +
											'<input id="ibmPortalIsPrivateInput" type="checkbox" name="private" dojoAttachPoint="makePrivate"/><span> <label for="ibmPortalIsPrivateInput">${nlsMakePrivate}</label></span>' +
										'</div>' +
									'</div>' +
								'</div>' +
								'<div class="lotusDialogFooter" dojoAttachPoint="dialogFooter">' +
									'<input value="${okText}" class="lotusFormButton" dojoAttachPoint="submitDialog" type="submit"/> ' +
									'<a href="javascript:void(0);" class="lotusAction" dojoAttachPoint="dialogCancel">${cancelText}</a>' +
								'</div>' +
							'</form>' +
						'</div>' +
					'</div>',
								
		postMixInProperties: function() {
			this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.dialogBundle = dojo.i18n.getLocalization("com.ibm.bundles", "PageCreatorDialog");
			this.cancelText = this.shelfBundle["add_content_cancel"];
			this.closeText = this.shelfBundle["add_content_close"];
			this.okText = this.dialogBundle["page_dialog_create_page"];
			this.nlsPageTitle = this.dialogBundle["page_dialog_page_name"];
			this.nlsTitleError = this.shelfBundle["new_feed_enterTitle"];
			this.nlsFriendlyURL = this.dialogBundle["page_dialog_friendly_url_name"];
			this.nlsMakePrivate = this.dialogBundle["page_dialog_make_private"];
			this.titleText = this.dialogBundle["page_dialog_create_page"];		
		},	
		
		postCreate: function() { 
			this.inherited(arguments);
			
			this.submitDialog.onclick = dojo.hitch(this,function(){this.submit();return false;});
			this.closeButtonNode.onclick = this.dialogCancel.onclick = dojo.hitch(this,function(){this.cancel();return false;});
			
			if (!this.showMakePrivate) { dojo.destroy(this.divPrivate); delete this.divPrivate; }
			this.connect(this.typingNode, "onblur", function() { 
				if (this.typingNode.value != "") { 
					this.newPageError.style.display="none"; 
				}
			});
			if (this.showFriendlyURL){
				this.connect(this.typingNode, "onkeyup", function(){ 
					this.filterFriendlyURL(this.typingNode.value);
				});
				this.connect(this.newPageFriendlyURL, "onkeyup", function(){
					this.filterFriendlyURL(this.newPageFriendlyURL.value);
				});
			} else {
				dojo.destroy(this.divFriendlyURL);
				delete this.divFriendlyURL;
			}
		},
		
		submit: function() {
			if(this.typingNode.value != "") { 	// If they havn't put in a page name it won't let them submit.
					this.hide();
					this.beforeSubmit();
					this.onSubmit();
			}
			else {
				this.newPageError.style.display="block"; 	// shows error if there is no page title.
			}
		},
		
		cancel: function(){
			this.hide();
		},
		
		onChange: function(/*Object*/arg){
		},
		
		onComplete: function(){
		},
		
		beforeSubmit: function(){
		},
		
		onSubmit: function() {
			// When the user presses the Submit button.
			this.value = dojo.formToObject(this.newPageForm);
			this.value.onComplete = this.onComplete;
			this.onChange(this.value);
		},
		
		focus: function(){
			this.newPageError.style.display="none";
			if(this.showMakePrivate){this.makePrivate.checked = false;}
			this.typingNode.value = "";
			if(this.showFriendlyURL){this.newPageFriendlyURL.value = "";}
			this.show();
			this.focusNode.focus();
		},
		
		filterFriendlyURL: function(/*String*/textToFilter) {
		// summary: filters the given text into something more acceptable for the friendly url.
		// textToFilter: text for the filter to run on.
			var friendly = textToFilter.replace(/[!\*\'\(\);:@&=+$,\/?%#\[\]\s]/g,'_');
			this.newPageFriendlyURL.value = friendly;
		}
    }
);

}
